import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;



public class DisplayParameters extends HttpServlet
  {
    public void doGet( HttpServletRequest req, HttpServletResponse resp ) throws ServletException, IOException
      {
        doPost( req, resp );
      }
      
    public void doPost( HttpServletRequest req, HttpServletResponse resp ) throws ServletException, IOException
      {
        MultipartRequest request = new MultipartRequest();
        request.setRequest( req );
        resp.setContentType( "text/html" );
        PrintWriter out = resp.getWriter();
        out.println( "<HTML>" );
        out.println( "<HEAD><TITLE>MultipartRequest Parameters</TITLE></HEAD>" );
        out.println( "<BODY>" );
        out.println( "<TABLE BORDER=1>" );
        out.println( "<TR><TH>Parameter</TH><TH>Values</TH></TR>" );
        Iterator iterator = request.getParameterNames();
        while ( iterator.hasNext() )
          {
            String name = (String)iterator.next();
            Object[] values = request.getParameterValues(name);
            out.println( "<TR>" );
            out.println( "<TD>" + name + "</TD>" );
            out.println( "<TD>" );
            if ( values.length > 1 )
              out.println( "<TABLE BORDER=1 WIDTH=100%>" );
            for ( int i=0; i<values.length; i++ )
              {
                Object value = values[i];
                if ( values.length > 1 )
                  out.println( "<TR><TD>" );
                if ( value instanceof MultipartRequest.File )
                  printFile( out, (MultipartRequest.File)value );
                else
                  out.print( "<PRE>" + value.toString() + "</PRE>" );
                if ( values.length > 1 )
                  out.println( "</TD></TR>" );
              }
            if ( values.length > 1 )
              out.println( "</TABLE>" );
            out.println( "</TD>" );
            out.println( "</TR>" );
         }
        out.println( "</TABLE>" );
        out.println( "</BODY></HTML>" );
        request.release();
      }
      
    private void printFile( PrintWriter out, MultipartRequest.File file ) throws IOException
      {
        out.println( "<TABLE>" );
        out.println( "<TR><TH>Name</TH><TD>" + file.getName() + "</TD></TR>" );
        out.println( "<TR><TH>Length</TH><TD>" + file.getLength() + "</TD></TR>" );
        out.println( "<TR><TH>Type</TH><TD>" + file.getType() + "</TD></TR>" );
        if ( file.getType().startsWith("text") )
          {
            out.println( "<TR><TH>Contents</TH><TD>" );
            out.print( "<PRE>" );
            InputStream in = file.getInputStream();
            int c;
            while ( (c=in.read()) != -1 )
              if ( (c == '<') || (c == '>') || (c == '"') || (c == '\'') )
                out.print( "&#"+c+";" );
              else
               out.print( (char)c );
            out.print( "</PRE>" );
            out.println( "</TD></TR>" );
          }
        out.println( "</TABLE>" );
      }
  }