package org.hd.d.pg2k.ai.scorer;

public interface ScorerParam
    {
    /**Returns a parameter with a small perturbation of the value (if possible); never null.
     * If there is a bias in the perturbation direction then it is applied.
     * @return  legal value of same type as this, possibly with small perturbation applied
     */
    public ScorerParam perturb();

    /**Generate the "name=value" text; never null or empty, though the value part may be empty. */
    public String toNameValueString();

    /**Parse the String representation of a parameter returning a value of the same type; never null.
     * If the argument is null or unparsable or out of range,
     * then the result has the default value,
     * else an instance with the requested parameter value is returned.
     * @return legal value of the same type as this, with the parsed input String's value if possible
     */
    public ScorerParam parse(String v);
    }