/*
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.hd.d.pg2k.ai.scorer.fixed;

import org.hd.d.pg2k.ai.scorer.*;
import org.hd.d.pg2k.svrCore.Rnd;
import org.hd.d.pg2k.svrCore.datasource.SimpleExhibitPipelineIF;

/**Returns a random positive score with matching confidence (no nulls).
 * Can be used as a test (ie to ensure that it gets rejected as "bad"). 
 * @author dhd
 */
public final class RandomPositiveScore extends AbstractScorer implements BadScorer
    {
    /**Returns random-score, maximum-confidence result, ignoring its input. */
    public ScoreAndConf computeScoreAndConfidence(final SimpleExhibitPipelineIF dataSource, final String exhibitName)
        {
        final int score = Rnd.fastRnd.nextInt(ScoreAndConf.MAX+1);
        return(new ScoreAndConf(score, score)); 
        }  
    }
