package org.hd.d.pg2k.clApp.uploader;

import javax.jnlp.FileContents;
import javax.jnlp.JNLPRandomAccessFile;
import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: DHD
 * Date: 05-Oct-2006
 * Time: 20:19:47
 */

/**Wrap a normal File as FileContents for non-random read-only access.
 * Package-visible for access by GUI classes.
 */
final class NormalFileContent implements FileContents
    {
    /**Internal form of name; never null. */
    final File f;

    /**Construct an instance from a (non-null) File. */
    NormalFileContent(final File f)
        {
        if(f == null) { throw new IllegalArgumentException(); }
        this.f = f;
        }

    public String getName() // throws IOException
        { return(f.getPath()); }

    public InputStream getInputStream() throws IOException
        { return(new FileInputStream(f)); }

    public OutputStream getOutputStream(final boolean b) // throws IOException
        { throw new UnsupportedOperationException(); }

    public long getLength() // throws IOException
        { return(f.length()); }

    public boolean canRead() // throws IOException
        { return(f.canRead()); }

    public boolean canWrite() // throws IOException
        { return(f.canWrite()); }

    public JNLPRandomAccessFile getRandomAccessFile(String s) // throws IOException
        { throw new UnsupportedOperationException(); }

    public long getMaxLength() // throws IOException
        { throw new UnsupportedOperationException(); }

    public long setMaxLength(long l) // throws IOException
        { throw new UnsupportedOperationException(); }
    }
