/*
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 28-Dec-02
 * Time: 22:24:51
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package org.hd.d.pg2k.test.dev;

import junit.framework.TestCase;
import org.hd.d.pg2k.webSvr.util.LocaleBean;

/**Test of some aspects of internationalisation (i18n) support.
 *
 */
public final class I18NTest extends TestCase
    {
    public I18NTest(final String name)
        {
        super(name);
        }

    /**Make sure that we can read non-ASCII characters from resource bundles,
     * Makes sure that we can load characters that don't
     * fit into 7 (or 8) bits.
     */
    public static void testBundleNonASCIILoad()
        {
        final String s = (new LocaleBean()).getLocalisedMessage("org.hd.pg2k.test.simpleWelcome.mt");
//        for(int i = 0; i < s.length(); ++i)
//            {
//            System.out.println("CHAR " + i + " = 0x" + Integer.toHexString((int) s.charAt(i)));
//            }

        assertEquals("UNICODE not read correctly from property: org.hd.pg2k.test.simpleWelcome.mt",
                     "Mer\u0127ba ghal DHD Multimedia Gallery!", s);
        }
    }
