package SevenZip.Compression.LZ;

public class OutWindow {
    byte[] _buffer = null;
    int _pos;
    int _windowSize = 0;
    int _streamPos;
    java.io.OutputStream _stream;
    
    public void Create(int windowSize) {
        if (_windowSize != windowSize) {
            _buffer = new byte[windowSize];
        }
        _windowSize = windowSize;
        _pos = 0;
        _streamPos = 0;
    }
    
    public void Init(java.io.OutputStream stream, boolean solid) throws java.io.IOException {
        ReleaseStream();
        _stream = stream;
        if (!solid) {
            _streamPos = 0;
            _pos = 0;
        }
    }
    
    public void Init(java.io.OutputStream stream) throws java.io.IOException {
        Init(stream, false); }
    
    public void ReleaseStream() throws java.io.IOException {
        Flush();
        _stream = null;
    }
    
    public void Flush() throws java.io.IOException {
        int size = _pos - _streamPos;
        if (size == 0)
            return;
        _stream.write(_buffer, _streamPos, size);
        if (_pos >= _windowSize)
            _pos = 0;
        _streamPos = _pos;
    }
    
    public void CopyBlock(int distance, int len) throws java.io.IOException {
        int pos = _pos - distance - 1;
        if (pos < 0) // if (pos >= _windowSize)
            pos += _windowSize;
        for (; len > 0; len--) {
            if (pos >= _windowSize)
                pos = 0;
            _buffer[_pos++] = _buffer[pos++];
            if (_pos >= _windowSize)
                Flush();
        }
    }
    
    public void PutByte(int b) throws java.io.IOException {
        _buffer[_pos++] = (byte)b;
        if (_pos >= _windowSize)
            Flush();
    }
    
    public int GetByte(int distance) {
        int pos = _pos - distance - 1;
        if (pos < 0) // if (pos >= _windowSize)
            pos += _windowSize;
        return _buffer[pos] & 0xFF;
    }
}

