package SevenZip.Compression.RangeCoder;

import SevenZip.Compression.RangeCoder.Decoder;

public class BitDecoder {
    public final static int kNumBitModelTotalBits = 11;
    public final static int kBitModelTotal = (1 << kNumBitModelTotalBits);
    final static int kNumMoveBits = 5;
    
    int Prob;
    
    public final void Init() { Prob = kBitModelTotal >>> 1; }
    
    public final int Decode(Decoder rangeDecoder) throws java.io.IOException {
        
        int newBound = (rangeDecoder.Range >>> kNumBitModelTotalBits) * Prob;
        // if ((rangeDecoder.Code & 0xFFFFFFFFL) < (newBound & 0xFFFFFFFFL)) // unsigned comparison
        if ((rangeDecoder.Code + 0x80000000) < (newBound + 0x80000000)) // unsigned comparison    
        {
            rangeDecoder.Range = newBound;
            Prob += (kBitModelTotal - Prob) >>> kNumMoveBits;
            // if ((rangeDecoder.Range & 0xFFFFFFFFL) < Decoder.kTopValue)
            if ((rangeDecoder.Range & Decoder.kTopValueMask) == 0) {
                rangeDecoder.Code = (rangeDecoder.Code << 8) | rangeDecoder.Stream.read();
                rangeDecoder.Range <<= 8;
            }
            return 0;
        } else {
            rangeDecoder.Range -= newBound;
            rangeDecoder.Code -= newBound;
            Prob -= (Prob) >>> kNumMoveBits;
            // if ((rangeDecoder.Range & 0xFFFFFFFFL) < Decoder.kTopValue)
            if ((rangeDecoder.Range & Decoder.kTopValueMask) == 0) {
                rangeDecoder.Code = (rangeDecoder.Code << 8) | rangeDecoder.Stream.read();
                rangeDecoder.Range <<= 8;
            }
            return 1;
        }
    }
}

