#!/bin/sh

# Check the exhibit data files for corruption.
# $1 is the exhibit data dir: must be supplied.

if [ "X$1" = "X" ]; then
    echo USAGE: $0 dir/Gallery/photos
    exit 1
fi

DATADIR=$1
CACHEFILE="$DATADIR/_expropsCache.dat"

OPTS="-Xmx1500m -Xms256m"
export OPTS

# Now set up the java stuff...

# Try for the JDK in standard places for various *nix flavours.
for jh in /usr/jdk1.5.0 \
          /System/Library/Frameworks/JavaVM.framework/Versions/1.5.0/Home ;
   do
       if [ -x $jh/bin/java ]; then
           JAVA_HOME=$jh
	   break
       fi
   done;
if [ "X$JAVA_HOME" = "" ]; then
    echo Java not found.
    exit 1;
fi
JAVACMD="$JAVA_HOME/bin/java -server"; export JAVACMD

# Main (debug) JAR for the Gallery core routines.
SVRCORE_JAR=../../../out_D/svrCore.jar
if [ ! -f $SVRCORE_JAR ]; then
    echo Remember to build $SVRCORE_JAR.
    exit 1;
fi

if $JAVACMD $OPTS -classpath `echo ../../*/*.jar | tr ' ' ':'`:../../../out_D/svrCore.jar \
	org.hd.d.pg2k.svrCore.datasource.ExhibitDataFileSource \
	-checkexhibits $CACHEFILE; then
    echo OK
else
    echo FAILED
    exit 1
fi
