@echo off
rem Call with $0 [ run | start | stop ]

rem Starts/stops a test Tomcat server for Windows.

rem cd C:\dhd\PG2K\V1.0\PG2Ksrc

rem Assume a minimal Tomcat (4.X) has been unpacked in jakarta-tomcat.
set CATALINA_HOME=..\jakarta-tomcat-4.1.27
echo CATALINA_HOME: %CATALINA_HOME%

rem Tight memory constraints but with a lower limit that
rem should allow some SoftReference cacheing to work...
set CATALINA_OPTS=-Xmx128m -Xms32m

rem Try to use incremental GC to reduce annoying pauses...
rem Not safe to use NewParGC under JDK 1.5.0_03 to _07 at least.
set CATALINA_OPTS=%CATALINA_OPTS% -Xincgc -XX:-UseParNewGC -XX:CMSInitiatingOccupancyFraction=70 -XX:MaxGCPauseMillis=999

rem Run as an all-in-one WAR-only master.
set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.WAR.disposition=waronly
rem Set up access to static global exhibit properties.
rem set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.WAR.waronly.exglobdata=fs_conf\prePG2K\GlobalProperties.txt
rem Set up configuration for WAR-only test server.
rem set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.WAR.waronly.configroot=fs_conf
rem Set bandwidth limit.
set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.maxBytesPerSec=1000000
set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.maxGBytesPer30D=500
rem Watch code hot-spots being compiled.
rem set CATALINA_OPTS=%CATALINA_OPTS% -XX:+PrintCompilation
rem Profile system start-up.
rem set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.profileStartup=true
rem Profile main catalogue JSP.
rem set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.profileJSP.doHTML=true
rem Turn on asserts.
set CATALINA_OPTS=%CATALINA_OPTS% -ea
rem Watch GC.
rem set CATALINA_OPTS=%CATALINA_OPTS% -verbose:gc
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xloggc:gc.log -XX:+PrintGCDetails
echo CATALINA_OPTS: %CATALINA_OPTS%

rem Optionally turn on profiling.
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xrunhprof:cpu=times,depth=8,monitor=y,msa=y,file=hprof.log
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xrunhprof:cpu=samples,monitor=y
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xrunhprof:cpu=samples,depth=8
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xprof

rem Optionally turn on JConsole/JMX remote monitoring.
set CATALINA_OPTS=%CATALINA_OPTS% -Dcom.sun.management.jmxremote

rem Now set up the java stuff...
rem set JAVA_HOME=C:\Progra~1\Java\jdk1.5.0
set JAVA_HOME=C:\Progra~1\Java\jdk1.5.0_03
set JAVA_OPTS= -server

set arg1=%1%
if "%arg1%" == "" set arg1=run

call %CATALINA_HOME%\bin\catalina.bat %arg1%

rem call %CATALINA_HOME%\bin\startup.bat


pause
