#!/bin/sh

# Call with $0 [ start | stop ]

# Starts/stops a test Tomcat server.

# Assume a minimal Tomcat (4.1.X) has been unpacked in jakarta-tomcat.
CATALINA_HOME=`pwd`/../jakarta-tomcat-4.1.27; export CATALINA_HOME
# Tight memory constraints but with a lower limit that
# should allow some SoftReference cacheing to work...
CATALINA_OPTS="-Xmx512m -Xms512m -XX:MaxPermSize=128m"
# Turn on all our assertions.
CATALINA_OPTS="$CATALINA_OPTS -ea"
# Run in incremental/concurrent GC mode to minimise pauses.
CATALINA_OPTS="$CATALINA_OPTS -XX:CMSInitiatingOccupancyFraction=70"
#CATALINA_OPTS="$CATALINA_OPTS -Xconcgc -XX:CMSInitiatingOccupancyFraction=70"
# Run as an all-in-one WAR-only master.
CATALINA_OPTS="$CATALINA_OPTS -Dorg.hd.d.pg2k.WAR.disposition=slave"
# Set up bandwidth throttling.
CATALINA_OPTS="$CATALINA_OPTS -Dorg.hd.d.pg2k.maxBytesPerSec=100000"
export CATALINA_OPTS

# Now set up the java stuff...
# Try for the JDK in standard places for various *nix flavours.
for jh in /usr/jdk1.6.0 \
          /System/Library/Frameworks/JavaVM.framework/Versions/1.6.0/Home ;
   do
       if [ -x $jh/bin/java ]; then
           JAVA_HOME=$jh
	   break
       fi
   done;
if [ "X$JAVA_HOME" = "" ]; then
    echo Java not found.
    exit 1;
fi
export JAVA_HOME
# Run in server mode.
JAVA_OPTS=" -server "; export JAVA_OPTS


# Default to ``run'' as the single arg.
if [ $# -lt 1 ]; then
    arg1="run"
else
    arg1=$1
    shift
fi

pwd
exec $CATALINA_HOME/bin/catalina.sh "$arg1" "$@"
