@echo off
rem Call with $0 [ run | start | stop ]

rem Starts/stops a test SLAVE Tomcat server for Windows under JPROFILER 4.x.
rem Can be used as a temporary test "mirror" for testing new services/code.

rem cd D:\dhd\PG2K\V1.0\PG2Ksrc

rem Assume a minimal Tomcat (4.X) has been unpacked in jakarta-tomcat.
set CATALINA_HOME=..\jakarta-tomcat-4.1.27
echo CATALINA_HOME: %CATALINA_HOME%

rem Tight memory constraints but with a lower limit that
rem should allow some SoftReference cacheing to work...
set CATALINA_OPTS=-Xmx128m -Xms32m

rem Try to use incremental GC to reduce annoying pauses...
rem JProfiler 4.0 and -Xincgc do not like one another...
rem set CATALINA_OPTS=%CATALINA_OPTS% -Xincgc

rem Run as an all-in-one WAR-only master.
set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.WAR.disposition=slave
rem Allow for lots of local cache for exhibits...
rem set CATALINA_OPTS=%CATALINA_OPTS% -Dpg2k.websvr.ex.maxcachesize=10000000
rem Set bandwidth limit.
set CATALINA_OPTS=%CATALINA_OPTS% -Dorg.hd.d.pg2k.maxBytesPerSec=18000


rem The following lines have been added by the
rem application server integration wizard of JProfiler

rem set PATH=C:\Program Files\jprofiler4\bin\windows;%PATH%
rem set CATALINA_OPTS=-agentlib:jprofilerti=port=8849  "-Xbootclasspath/a:C:\Program Files\jprofiler4\bin\agent.jar" %CATALINA_OPTS%

rem end of modifications


rem Now set up the java stuff...
rem NOTE THAT WE MAY USE A SLIGHTLY DIFFERENT JVM TO NORMAL AS A TEST...
rem set JAVA_HOME=C:\Progra~1\Java\jdk1.5.0
set JAVA_HOME=C:\Progra~1\Java\jdk1.5.0_03
set JAVACMD=%JAVA_HOME%\bin\java -server


call %CATALINA_HOME%\bin\startup_jprofiler.bat


pause
