<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.ads.*"
    session="false"
    buffer="8kb" %><%--


HOME PAGE for 3D walk-through.


LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "3D Walkthrough - Beta"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Gallery 3D Walkthrough Beta</h1>

<p>This is an early-access version of the Gallery 3D walkthrough using Java3D.
   You will need Java 1.5 and/or Java Web Start installed to use it,
   on a fairly powerful modern machine (eg 1GHz+ CPU, 1GB+ memory, Windows XP).
   If your machine has multiple CPUs then this will try to make use of them.</p>

<p>The main features still to be added include:
   <ul>
   <li>More robust installation and navigation.
   <li>Fallback to use small exhibits directly if no thumbnails available.
   <li>Handling of audio and movie/animation exhibits.
   <li>Handling of VRML and other 3D formats within the Gallery in general.
   <li>A fully-released JWS version of the underlying JAI libraries from <a href="http://java.net/" target="_top"></a>java.net</a>.
   </ul>
   </p>

<p>To navigate in this 3D view, use the mouse.
   In my setup, holding the right mouse button down while moving the mouse moves in the X/Y plane,
   and holding down the ALT key and left mouse button while moving the mouse up and down moves in the Z direction (holding down the middle mouse button may also work for you).
   Click on an exhibit or its caption to select it (ie to see more details about the exhibit in your browser).</p>

<%
    if("localhost".equalsIgnoreCase(request.getServerName()))
        { %><p><a href="3DLH.jnlp">Launch the test-only Gallery 3D Walkthrough</a> (development only).</p><% }
    else
        { %><p><a href="http://<%= CoreConsts.MAIN_DATA_HOST %>/_3D/3D.jnlp">Launch the <strong>beta</strong> Gallery 3D Walkthrough with Java Web Start</a>.</p><% }
%>

<p>Take a look at the <a href="/_javadoc/org/hd/d/pg2k/webSvr/threeD/package-summary.html">Javadoc and Java source code</a>.</p>

<p>Take a look at the <a href="http://www.galleryof3d.com/" target="_top">Gallery of 3D</a> (not connected with this gallery).</p>

<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>