<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.ai.scorer.*,
            org.hd.d.pg2k.webSvr.ads.*"
    session="false"
    buffer="8kb" %><%--


HOME PAGE for AI work.


LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "AI Exhibit Scorers - Alpha"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Gallery AI Exhibit Scorers Alpha</h1>

<p>This is a small project to try to develop (using Genetic Algorithms)
    a set of simple Java classes for guessing an exhibit's likely appeal to Gallery users.
    In the first instance this is restricted to 2D still images.</p>

<p>One use of this is to help predict at or before upload of new images to the Gallery
    those that are likely to be most popular.  The contributor may then choose to upload or not,
    and/or create more variations rather than waiting for bouquets or brickbats from the users.</p>

<p>Another possible use is to automatically produce a "tweaked" version of an existing exhibit
    more likely to appeal to Gallery visitors.</p>

<h2>Status</h2>
<% final ScorerCacheIF scorers = dataSource.getScorerCache(); %>
<p>The current set of available "best" exhibit Scorers (with a total population of <%= scorers.size() %>) is:
    <%
    final ArrayList<String> sortedScorerNames = new ArrayList<String>(scorers.getCurrentScorersWithParameters(true));
    Collections.sort(sortedScorerNames);
    %><%= sortedScorerNames %>.</p>

<%
    final String exhibitName = WebUtils.getPopularExhibit(dataSource,
                          ExhibitMIME.getParamsByType(ExhibitMIME.ET_JPEG));
    if(exhibitName != null)
        { %>
<p>The current raw unweighted score of a popular JPEG (<a href="<%= WebUtils.makeCatPageRRURL(exhibitName, WebConsts.F_secondary_generated_HTML_suffix) %>"><%= WebUtils.hyphenateHTMLText(ExhibitName.getFileComponent(exhibitName)) %></a>) by of each of the Scorers is as follows:
    <ul>
    <%
    for(final String n : sortedScorerNames)
        {
	    try
	        {
            // We allow "stale" values for robustness and speed of page construction.
            %><li><%= n %>: <%= scorers.computeUnweightedScoreAndConfidence(exhibitName, n, true) %></li><%
	        }
	    catch(final IOException e) { dataSource.log(e.getMessage()); /* Log brief error, complete the page if possible. */ }
	    catch(final Throwable e) { e.printStackTrace(); /* Log error, complete the page if possible. */ }
       }
    %></ul>
    <% out.flush(); /* Force a flush now since the composite score may be VERY slow to compute. */ %>
    with the composite predicted exhibit score: <%= scorers.computeCompositeScoreAndConfidence(exhibitName, true) %>.</p>
       <% } %>

<p>The current "ratings" of each of the best and base Scorers is as follows:
    <ul>
    <%
    final SortedSet<String> bestAndBaseScorerNames = new TreeSet<String>(scorers.getBaseScorersWithoutParameters());
    bestAndBaseScorerNames.addAll(sortedScorerNames);
    for(final String n : bestAndBaseScorerNames)
        {
	    try
	        {
            // We allow "stale" values for robustness and speed of page construction.
            final ScoreAndConf sc = scorers.computeScorerWeighting(n, true);
            %><li><%= n %>: <%= sc %> [<%= (sc.score * sc.confidence) / (float) (ScoreAndConf.MAX * ScoreAndConf.MAX) %>]</li><%
	        }
	    catch(final IOException e) { dataSource.log(e.getMessage()); /* Log brief error, complete the page if possible. */ }
	    catch(final Throwable e) { e.printStackTrace(); /* Log error, complete the page if possible. */ }
        }
    %></ul></p>

<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>