<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.util.ThroughputMonitorFilterPG2K,
            org.hd.d.pg2k.svrCore.datasource.SimpleExhibitPipelineIF,
            org.hd.d.pg2k.svrCore.vars.*,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts,
            org.hd.d.tmf.ThroughputMonitorFilterBase,
            org.hd.d.pg2k.webSvr.upload.HTTPUploaderUtils"
    session="false"
%><%!
    /**Prefix for name of attributes of values from ThroughputMonitorFilter. */
    public static final String THROUGHPUT_ATTRNAME_PREFIX = "org.hd.d.pg2k.throughput";
%><%
// Work out how busy the server is...
final boolean serverIsOverloaded = WebUtils.isOverloaded(application);

// Allow a little cacheing, but not much...
final int cacheSeconds = 60;
response.setHeader("Cache-Control", "max-age=" + cacheSeconds + ", private");
response.setDateHeader("Expires", System.currentTimeMillis() + 1000*cacheSeconds);

// Refresh every 30-ish minutes normally, but every 10-ish when busy...
response.setIntHeader("Refresh",
                      (serverIsOverloaded ? 10 * 60 : 30 * 60) +
                      Rnd.fastRnd.nextInt(5 * 60));
%><%--
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get the dataSource bean set up...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- Get locale bean set up...
--%><%

    final DataSourceBean dsb = dataSource;
    final LocaleBean lb = localeBean;

    // Get current bandwidth consumption for title...
    final SimpleNumberStats ltbw = VarTools.generateSimpleNumberStats(dsb,
                    SystemVariables.ThroughputMonitorFilter_ltBps,
                    0,
                    "#,###Bps");

    // Get current number of users for title...
    final SimpleNumberStats uStats = (VarTools.generateSimpleNumberStats(dsb,
                    SystemVariables.ThroughputMonitorFilter_STICKY_CLIENT_COUNT,
                    0,
                    "#,###u"));

    // Compute insert for title if we have stats available.
    // Defaults to being empty...
    final StringBuilder titlePrefix = new StringBuilder();
    if((ltbw != null) && (uStats != null))
        {
        final Number bwTotal = ltbw.getSum();
        final Number uTotal = uStats.getSum();
        if((bwTotal != null) && (uTotal != null))
            {
            titlePrefix.append('[');
            titlePrefix.append(uTotal.intValue()).
                append('u'); // Total users.
            titlePrefix.append(' ');
            titlePrefix.append(TextUtils.sizeAsText(bwTotal.longValue(), true)).
                append("ps"); // Total bandwidth.
            titlePrefix.append(' ').append(ltbw.getNonNullValueCount()).
                append('s'); // Total systems participating.
            titlePrefix.append(' ').append(dsb.getEventValue(SystemVariables.ACCESSPATTERN_CLICKTHROUGH,
                                                       EventPeriod.VLONG,
                                                       true).getTotalEventCount()).
                append('c');
            titlePrefix.append("] ");
            }
        }

    // Start whole title with "!" if the local server is busy...
    if(serverIsOverloaded)
        { titlePrefix.insert(0, '!'); }
%><%--
--%><html>
<head>
<meta name="robots" content="noindex,nofollow">
<title><%= titlePrefix %>System Parameters</title>
</head>
<body bgcolor=white>
<center><h1><%= CoreConsts.APP_DEFAULT_NAME %> System Parameters</h1></center>

<p>Return to <a href="index.html">Admin Central</a>.</p>

<p>This page is used for viewing selected system properties and stats.</p>


<h2>System Throughput</h2>

<p>Several system throughput measures are presented below.
   Where the expected attribute cannot be found or is of the wrong type,
   the attribute name and value may be shown for debugging purposes.</p>

<p><table border=1>
<tr><th>Parameter Description (units)</th><th>Value</th></tr>

<tr>
<td>The server is busy [false,true]:</td>
<td align=right><%= serverIsOverloaded %></td>
</tr>

<tr>
<td>Server is compressing some streams to conserve bandwidth [false,true]:</td>
<td align=right><%= application.getAttribute("org.hd.d.pg2k.highTraffic.overlt") %></td>
</tr>

<tr>
<td>The current system long-term throughput (bytes per second) [0,+inf[:</td>
<td align=right><%= ltbw %></td>
</tr>

<tr>
<td>Local short-term bandwidth (bytes per second) [0,+inf[:</td>
<td align=right><%= application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_BYTES_PER_SEC_OUTBOUND) %></td>
</tr>

<%
// Get mean bandwidth over whole runtime of server.
    final Object tltbpss = application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_SERVER_LIFETIME_BYTES_PER_SEC_OUTBOUND);
%>
<tr>
<td>Server life-time bandwidth (bytes per second) [0,+inf[:</td>
<td align=right><%= (tltbpss instanceof Number) ?
 String.valueOf(((Number) tltbpss).intValue()) :
 (THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_SERVER_LIFETIME_BYTES_PER_SEC_OUTBOUND + " = " + application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_SERVER_LIFETIME_BYTES_PER_SEC_OUTBOUND))
 %></td>
</tr>
<tr>
<td>Server life-time bandwidth (Gbytes per month) [0,+inf[:</td>
<td align=right><%= (tltbpss instanceof Number) ?
 String.valueOf((float) (((Number) tltbpss).doubleValue() * (3600 * 24 * 30) / 1e+9)) :
 ("?")
 %></td>
</tr>

<tr>
<td>Current number of visitors (including spiders, hotlinkers, etc) [0,+inf[:</td>
<td align=right><%= (VarTools.generateSimpleNumberStats(dsb,
                    SystemVariables.ThroughputMonitorFilter_CLIENT_COUNT,
                    0,
                    "#,###u")) %></td>
</tr>

<tr>
<td>Current number of (sticky, human) visitors [0,+inf[:</td>
<td align=right><%= uStats %></td>
</tr>

<tr>
<td>Computed mean yearly unique visitors [0,+inf[:</td>
<td align=right><%= VarTools.generateSimpleNumberStats(dsb, SystemVariables.ThroughputMonitorFilter_YEARLY_UNIQUE_VISITORS, -1, "#,###u/y") %></td>
</tr>

<tr>
<td>Current connection load short-term in-process list length [0,+inf[:</td>
<td align=right><%= application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_CONNECTION_LOAD) %></td>
</tr>

<tr>
<td>Current connection load long-term in-process list length [0,+inf[:</td>
<td align=right><%= application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_CONNECTION_LOAD_LONG_TERM) %></td>
</tr>

<tr>
<td>Current system non-idle fraction [0,1]:</td>
<td align=right><%= application.getAttribute(THROUGHPUT_ATTRNAME_PREFIX + '.' + ThroughputMonitorFilterBase.ATTR_NAME_SUFFIX_BUSY_FRACTION_SMOOTHED) %></td>
</tr>

<tr>
<td>Current local persistent cache space % used (if any) [0,100]%:</td>
<td align=right><%= VarTools.generateSimpleNumberStats(dsb, SystemVariables.ExhibitDataSimpleCache_CACHE_AVAIL_SPACE_PERCENT_USED, -1, "#") %></td>
</tr>

<tr>
<td>Current local persistent cache count of exhibits in cache [0,+inf[%:</td>
<td align=right><%= VarTools.generateSimpleNumberStats(dsb, SystemVariables.ExhibitDataSimpleCache_CACHED_EXHIBIT_COUNT, -1, "#e") %></td>
</tr>

</table><p>

<h2>System Status</h2>

<p>Time now: <%= (new Date()) %>.</p>

<p>The heap for the current JVM is <%= Runtime.getRuntime().totalMemory() %> bytes
   of which <%= Runtime.getRuntime().freeMemory() %> bytes are free.</p>

<p>This Web front end is a slave: <%= dsb.isSlave() %></p>

<p>This server's unique ID: <%= dsb.getVariable(SystemVariables.LOCAL_SYS_ID) %></p>

<p>Participating slave/client systems by ID: <%= VarTools.generateSimpleStats(dsb, SystemVariables.TunnelServlet_SLAVE_ADDRS, 0) %></p>


<h2>Your Session</h2>

<p>You currently have a session: <%= (request.getSession(false) != null) %></p>

<p>Your apparent IP address is: <%= request.getRemoteAddr() %></p>

<p>Your browser-set locale is: <%= request.getLocale() %></p>

<p>Our best guess at your locale is: <%= lb.getLocale() %></p>

<p>The basic welcome message is rendered as: ``<%= lb.getLocalisedMessage("org.hd.pg2k.simpleWelcome") %>''.</p>


<h2>The Main System Properties</h2>

<p>The generic properties were last updated at: <%= new Date(dsb.getGenProps(-1).timestamp) %>.</p>


<h2>The Exhibit/Attribute Data</h2>

<%
final AllExhibitProperties aep = dsb.getAllExhibitProperties(-1);
final AllExhibitImmutableData aEID = aep.aeid;
if(aEID == null)
    {
    %><p>This data is not available.</p><%
    }
else
    {
    %><p>The exhibits were last updated at: <%= new Date(aEID.timestamp) %>.</p><%
    %><p>The AEP has not changed since: <%= new Date(aep.hashNotChangedSince) %>.</p><%
    %><p>There are <%= aEID.size() %> exhibits available.</p><%
    }
%>

<% out.flush(); %>

<a name="dump"><h2>System Variable Dump</h2></a>

<%
    // Name of parameter we use to chose a value for charting.
    final String chartParamName = "chart";

    // Number of top values to show from an event.
    // 10--100 is a reasonable number.
    final int topN = 100;

    // Maximum number of characters to show from the String rendition of a value.
    final int maxValChars = 64;
    // Slightly larger number when we might need to see more significant characters.
    final int maxMaxValChars = (3 * maxValChars) / 2;

    // See if there is a chart parameter set.
    // Note that this raw value is not necessarily trustworthy.
    final String rawCPVal = request.getParameter(chartParamName);

    // Random (alphanumeric) token for cache busting.
    final String cacheBustRnd = Integer.toString(Rnd.fastRnd.nextInt() >>> 1, Character.MAX_RADIX);


    // We may be prepared to show slightly-sensitive variable values to
    // authorised users.
    // For the moment we'll accept an upload login as better than nothing.
//    final HttpSession session = request.getSession(false); // Don't force a session.
//    final Object userIDo = (session == null) ? null :
//                           session.getAttribute(UploadConsts.USERID_FIELD_NAME);
//    // Do some very faint checking of validity here,
//    // but really non-null would do since validation should be done elsewhere.
//    final boolean authed = (userIDo instanceof String) &&
//                           ExhibitName.validAuthorSyntax((String) userIDo);
    final boolean authed = (null != HTTPUploaderUtils.isLoggedInForUploads(request));
%>

<p>A summary dump of the system variables (including events, but excluding test values) in name order:
<br />
<table border=1>
<tr><th>Variable Name</th><th>Event Count<br /> VLONG <br />curr/prev</th><th>Latest Value</th></tr>

<%
    for(final SimpleVariableDefinition def : SystemVariables.defs)
        {
        final String name = def.getName();

        // Skip test values.
        if(name.startsWith("test.")) { continue; }

        // Skip sensitive values.
        if(!authed && SystemVariables.sensitiveVars.contains(name)) { continue; }

        %><tr><%
        %><td><%

        %><a href="?<%= chartParamName %>=<%= name %>&amp;rnd=<%= cacheBustRnd %>#dump"><%= name %></a><%

        %></td><%
        if(!def.isEvent()) { %><td>-</td><% }
        else
            {
            %><td align=center><%= dsb.getEventValue(def, EventPeriod.VLONG, true).getTotalEventCount() %>/<%= dsb.getEventValue(def, EventPeriod.VLONG, false).getTotalEventCount() %></td><%
            }
        final SimpleVariableValue svv = dsb.getVariable(def);
        %><td><%= TextUtils.sanitiseForXML(String.valueOf(svv), maxValChars, false) %></td><%
        %>
        </tr>
        <% // Leave linebreak for ease of reading the HTML...

        // Are we charting this variable?
        final boolean charting = name.equals(rawCPVal);
        // If charting
        // then insert a special row in the table!
        if(charting)
            {
            EventVariableValue evvs[] = new EventVariableValue[0];
            int totalDiffEvents[] = new int[0];
            int totalCounts[] = new int[0];
            if(def.isEvent())
                {
                final BitSet which = new BitSet();
                which.set(0);
                final EventVariableValue[] all = dsb.getEventValues(def, EventPeriod.VLONG, 0, which);
                which.set(1);
                final long now = System.currentTimeMillis();
                final long currentIntervalNumber = EventPeriod.VLONG.getIntervalNumber(now);
                final EventVariableValue[] pc = dsb.getEventValues(def, EventPeriod.VLONG, currentIntervalNumber, which);
                evvs = new EventVariableValue[]
                    {
                    ((pc.length > 0) ? pc[0] : null), // Current event bucket.
                    ((pc.length > 1) ? pc[1] : null), // Previous event bucket.
                    ((all.length > 0) ? all[0] : null), // All event bucket.
                    };

                totalDiffEvents = new int[evvs.length];
                totalCounts = new int[evvs.length];

                // Get total different events known for each interval.
                for(int i = evvs.length; --i >= 0; )
                    {
                    final EventVariableValue evv = evvs[i];
                    if(evv != null)
                        {
                        totalDiffEvents[i] = evv.getTotalDistinctValues();
                        totalCounts[i] = evv.getTotalEventCount();
                        }
                    }
                }

            %>
        <tr>
            <td colspan=3><small><table border=1>
            <tr><th>Global Map</th><%
            if(def.isEvent())
                { %>
                <th>Current Top-<%= topN %>/<%= totalDiffEvents[0] %><br />Count=<%= totalCounts[0] %></th>
                <th>Prev Top-<%= topN %>/<%= totalDiffEvents[1] %><br />Count=<%= totalCounts[1] %></th>
                <th>All Top-<%= topN %>/<%= totalDiffEvents[2] %><br />Count=<%= totalCounts[2] %></th>
                <% }
            %></tr>
            <tr>
            <%
            // Show the members of the global map (if any) sorted in order by ID.
            final Map<InstanceID, SimpleVariableValue> gm = (svv == null) ? null : svv.getGlobalMap();
            if(gm == null) { %><td>-</td><% }
            else
                {
                final SortedMap<InstanceID, SimpleVariableValue> sgm = new TreeMap<InstanceID, SimpleVariableValue>(gm);
                %><td><small><dl compact><%
                for(final InstanceID id : sgm.keySet())
                    {
                    final SimpleVariableValue v = sgm.get(id);
                    if(v == null)
                        {
                        %><dt><%= id %></dt><%
                        continue;
                        }
                    %><dt><%= id %> (<%= new Date(v.getTimestamp()) %>)</dt><dd><%= TextUtils.sanitiseForXML(String.valueOf(v), maxValChars, false) %></dd><%
                    }
                %></dl></small></td><%
                }

            // If this is an event then show the top-n of each.
            for(final EventVariableValue evv : evvs)
                {
                // Skip a missing event set.
                if(evv == null)
                    {
                    %><td>-</td><%
                    continue;
                    }

                // Keep an array in rank order of keys.
                // Each entry is null or a List of the keys (ie event value) at the given rank.
                final List[] byRank = new List[topN];

                if(evv != null)
                    {
                    // Extract all the info, and keep only items suitably well ranked.
                    final Map<Object, EventVariableValue.ValueInfo> info = evv.getInfo();

                    for(final Map.Entry<Object,EventVariableValue.ValueInfo> entry : info.entrySet())
                        {
                        final int rank = entry.getValue().rank;
                        if(rank >= topN) { continue; }

                        if(byRank[rank] == null) { byRank[rank] = new ArrayList(1 + topN/2); }

                        // Add this new item.
                        byRank[rank].add(entry.getKey());
                        }
                    }

                // Now sort each non-null rank into its natural order.
                for(final List l : byRank)
                    {
                    if(l != null) { Collections.sort(l); }
                    }

                // Now dump each event collection in order.
                %><td><small><ol compact><%
                int totalDisplayed = 0;
                for(int i = 0; i < topN; ++i)
                    {
                    final List l = byRank[i];
                    if(l == null) { continue; }
                    for(final Object o : l)
                        {
                        %><li value=<%= i+1 %>><%
                        if(++totalDisplayed > topN)
                            {
                            // We're somehow showing too many items...
                            %>...</li><%
                            break;
                            }
                        %>(<%= evv.getCount(o) %>) <%
                        %><%= TextUtils.sanitiseForXML(String.valueOf(o), maxMaxValChars, false) %><%
                        %></li><% // Just neatness...
                        }
                    }
                %></ol></small></td><%
                }

            %>
            </tr>
            </table></small></td>
            <%
        %>
        </tr>
        <% // Leave linebreak for ease of reading the HTML...
            } // End charting....
        }
%>

</table><p>

</body>
</html>
