<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

Shows what i18n support is present (and what is missing/needed).

--%><%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.util.ThroughputMonitorFilterPG2K,
            org.hd.d.pg2k.svrCore.datasource.SimpleExhibitPipelineIF,
            org.hd.d.pg2k.svrCore.vars.*,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts,
            org.hd.d.tmf.ThroughputMonitorFilterBase"
    session="false"
%>
<html>
<head>
<meta name="robots" content="noindex,nofollow">
<title>I18N Support</title>
</head>
<body bgcolor="white">
<h1>I18N Support</h1>

<p>Locales: <%= I18NTools.LOCALES.size() %>: <%= new ArrayList(I18NTools.LOCALES) %></p>

<%
    // The "default" locale when using the LocaleBean.
    final Locale defaultLocale = (new LocaleBean()).getLocale();
    %><p>Default locale: <%= defaultLocale %></p><%

    // Underlying resource bundle names.
    final String[] bundleNames = new String[]{
        I18NTools.BUNDLE_COMMON,
        // I18NTools.BUNDLE_TREEDESC,
        };

    // Locales already expanded.
    final Set<Locale>[] alreadyShown = new HashSet[bundleNames.length];
    for(int i = bundleNames.length; --i >= 0; ) { alreadyShown[i] = new HashSet<Locale>(1 + 2 * I18NTools.LOCALES.size()); }

    // Include a dummy emptyLocale locale first to force dump of fallback set.
    final Locale emptyLocale = new Locale("");
    final ArrayList<Locale> locales = new ArrayList<Locale>(1 + I18NTools.LOCALES.size());
    locales.add(emptyLocale);
    locales.addAll(I18NTools.LOCALES);

    for(final Locale l : locales)
        {
        %><h2>Locale: "<%= l %>"</h2><%

        for(int i = 0; i < bundleNames.length; ++i)
            {
            final String bundleName = bundleNames[i];
            final ResourceBundle bundle = ResourceBundle.getBundle(bundleName, l);
            final Locale realLocale = bundle.getLocale();
            // Get the "fallback" bundle.
            final ResourceBundle fallbackBundle = ResourceBundle.getBundle(bundleName, defaultLocale);

            %><p>Best-available <%= bundleName %> locale/bundle: <%= realLocale %></p><%
            if(alreadyShown[i].contains(realLocale))
                {
                %>(Already shown for <%= bundleName %> set <%= realLocale %>.)<%
                continue;
                }

            // Extract all keys from bundle...
            final ArrayList<String> keys = Collections.list(bundle.getKeys());
            Collections.sort(keys);
            %><p>Total keys: <%= keys.size() %></p><%

            for(final String key : keys)
                {
                final String msg = bundle.getString(key);
                String msgFallback = null;
                try { msgFallback = fallbackBundle.getString(key); }
                catch(final Exception e) { }

                // Only show if not just the fallback value
                // (unless this is the fallback locale itself).
                if(l.equals(emptyLocale) || !msg.equals(msgFallback))
                    {
                    final boolean keyNotInFallback = (msgFallback == null);

                    if(keyNotInFallback) { %><strong>[new key]</strong> <span style="color: red"><% }
                    %><i><%= key %> =</i> <%
                    if(keyNotInFallback) { %></span><% }

                    %><%= msg %><%

                    %><br /><%
                    }
                }

            alreadyShown[i].add(realLocale);
            }
        }
%>

</body>
</html>
