<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--
Runs system jUnit tests,
including those that need to be run in a WAR container,
directing results to the browser window.

This is for repeatability and security/resource reasons
only to be run in one coopy at a time and by selected clients.

Acceptable clients might be the localhost,
or any user that managed to authenticate themselves elsewhere (eg for upload).
--%><%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.util.ThroughputMonitorFilterPG2K,
            org.hd.d.pg2k.test.dev.Main,
            java.net.URL"
    session="false"
%><%
// No cacheing.
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");
    response.setHeader("Expires", "0");
%>
<html>
<head>
<meta name="robots" content="noindex,nofollow">
<title>System Self-test</title>
</head>
<body bgcolor="white">
<h1>System Self-test</h1>

<%
    // Allow access from the localhost (eg for development or local users).
    // Don't allow it for the whole Web to avoid DoS attacks in the main.
    if(request.getRemoteAddr().equals("127.0.0.1")) {
%>

<p>You are authenticated to the system; running self-test...</p>

<% out.flush(); %>

<pre>
<%
    final URL requestURL = new URL(request.getRequestURL().toString());
    %><p>(This request being serviced at: <%= requestURL %>.)</p><%
    Main.runTestsFromServlet(out,
                             new URL(requestURL.getProtocol(),
                                     requestURL.getHost(),
                                     requestURL.getPort(),
                                     request.getContextPath()),
                             application);
%>
</pre>

<p>Self-tests done.</p>

<% } else { %>

<p>I'm sorry, you are not authorised to run system tests.</p>

<% } %>

</body>
</html>
