<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.svrCore.props.*"
    session="false"
%>
<%
// Allow a little cacheing, but not much...
final int cacheSeconds = 60;
response.setHeader("Cache-Control", "max-age=" + cacheSeconds +", must-revalidate");
response.setDateHeader("Expires", System.currentTimeMillis() + 1000*cacheSeconds);
%>
<%@ include file="/_common/_exhibitBean.inc.jsp" %> <%-- Get the dataSource bean set up... --%>

<%
// Get hold of the data pipeline and generic properties.
final GenProps genProps = dataSource.getGenProps(-1);
// Get hold of the exhibit data...
final AllExhibitImmutableData aEID = dataSource.getAllExhibitImmutableData(-1);
final SortedSet ae = aEID.getAllStaticAttrsSorted();
%>

<html>
<head>
<meta name="robots" content="noindex,nofollow">
<title><%= CoreConsts.APP_DEFAULT_NAME %> Simple Exhibit Listing</title>
</head>
<body bgcolor=white>
<center><h1><%= CoreConsts.APP_DEFAULT_NAME %> Simple Exhibit Listing</h1></center>

<p>Return to <a href="index.html">Admin Central</a>.</p>

<p>Time now: <%= new Date() %></p>

<p>Exhibit count: <%= ae.size() %></p>
<p><table border="1">
<tr><th>Name</th><th>Size (bytes)</th><th>Last Modified</th></tr>
<%
int j = 128; // Limit number of exhibits listed...
for(final Iterator it = ae.iterator(); it.hasNext(); )
    {
    if(--j < 0) { break; } // Limit number of exhibits shown...
    final ExhibitStaticAttr esa = (ExhibitStaticAttr) it.next();
    %> <tr><td><small><a href="<%= WebUtils.makeCatPageURL(esa.filePath, WebConsts.F_secondary_generated_HTML_suffix) %>"><%= esa.filePath %></a></small></td><td align="right"><%= esa.length %></td><td align="right"><nobr><%= new Date(esa.timestamp) %></nobr></td></tr> <%
    }
%>
</table></p>

</body>
</html>
