<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

     Search box for catalogue as one form item; include into JSP page.

     I make this as compact (and compressable) as possible even omitting quotes where allowed.

     If the "searchBoxWidth" page-level attribute is set,
     it is used as the with of the searchBox.
     The default size of small enough to fit anywhere on a page,
     in particular in the architrave.

     If the "searchNoFormTag" attribute is set, we do not wrap this
     up in its own form tag, but instead allow the caller to embed
     the submit in their own form.
--%><%@ page
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts,
            org.hd.d.pg2k.svrCore.uploader.UploaderUtils" %><% { /* Scope the variables locally... */
final String oldQuery = TextUtils.sanitiseForXML(DataSourceBean.canonicaliseSimpleByWordQuery(request.getParameter("q"), WebConsts.MAX_SIMPLE_QUERY_LEN), WebConsts.MAX_SIMPLE_QUERY_LEN, false);
final Object searchBoxWidth = pageContext.getAttribute("searchBoxWidth");
final boolean noWrap = (pageContext.getAttribute("searchNoFormTag") != null);
%><%--
--%><% if(!noWrap) { %><form method=<%= WebConsts.SEARCH_FORM_METHOD %> action="/_cat/doHTMLSearch.jsp"><% } %><%--
--%><input type=text name=q size=<%= (searchBoxWidth != null) ? searchBoxWidth.toString() : String.valueOf(Math.min(16, WebConsts.MAX_SIMPLE_QUERY_LEN)) %> maxlength=<%= WebConsts.MAX_SIMPLE_QUERY_LEN %><%= (oldQuery.length() == 0) ? "" : " value="+UploaderUtils.quoteHTMLArg(oldQuery) %>>&nbsp;<%--
--%><input type=submit value=<%= UploaderUtils.quoteHTMLArg(localeBean.getLocalisedMessage("common.cat.search")) %>><%--
--%><% if(!noWrap) { %></form><% } %><%--
--%><% } /* End local scope. */ %>
