<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%--Catalogue page handler for HTML.
    Since we serve a lot of these we'd like to be extra-efficient on space
    if we can, so, for example, not adding lots of spurious whitespace,
    which implies odd comment start/end to eliminate blank lines...
--%><%@ page
    import="java.io.*,
            java.net.*,
            java.text.*,
            java.util.*,
            java.util.concurrent.*,
            java.util.concurrent.atomic.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            ORG.hd.d.jIndexer.server.JIndexBean,
            org.hd.d.pg2k.svrCore.location.*,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.location.*,
            org.w3c.dom.Node,
            org.hd.d.pg2k.svrCore.vars.*,
            org.hd.d.tmf.ThroughputMonitorFilterBase,
            org.hd.d.pg2k.webSvr.ads.*,
            org.hd.d.pg2k.webSvr.virtualHosts.AlohaEarth.*,
            org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
            org.hd.d.pg2k.svrCore.mediahandler.swf,
            org.hd.d.pg2k.svrCore.uploader.*,
            java.nio.ByteBuffer"
    %><%-- Should inherit session="false"...
--%><% response.setContentType("text/html;charset=UTF-8"); %><%--
--%><%! private static final boolean profileJSP = Boolean.getBoolean("org.hd.d.pg2k.profileJSP.doHTML"); %><%-- // Allow profiling to be enabled at run-time.
--%><%! private static final ConcurrentHashMap<StackTraceElement, AtomicInteger> perfCounts = (!profileJSP) ? null : new ConcurrentHashMap<StackTraceElement, AtomicInteger>(1001); %><%-- // Stats are cumulative.
--%><%! private static volatile long lastPerfSampleAt; %><%-- // Marked volatile for thread-safe lockless access.
--%><%! private static final int perfSampleInterval = 25000 + Rnd.fastRnd.nextInt(10000); %><%--
--%><%! private static final AtomicLong serviceCount = new AtomicLong(); %><%--
--%><%
    // Start performance sampling if enabled.
    // Do this periodically to get reasonable stats without killing the system.
    Thread perfMonitorThread = null;
    if(profileJSP && (perfCounts != null) &&
       (lastPerfSampleAt + perfSampleInterval < System.currentTimeMillis()))
        {
        // There is a small-but-harmless race hazard just here... B^>
        lastPerfSampleAt = System.currentTimeMillis(); // Postpone next sample...
	    perfMonitorThread = GenUtils.startThreadPerfMonitor(
	        Thread.currentThread(),
	        perfCounts,
	        null, // "org.hd.",
	        System.currentTimeMillis() + 1000, // Monitor thread for at most 1s.
	        2); // Sample every couple of ms so as to obtain >> 10 samples.
	    }
  %><%--
--%><%@ include file="/_common/_SetPageStartTime.inc.jsp" %><%-- Note start time if not already done for standard footer.
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- Get locale bean set up...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...
--%><%
    // Provide local aliases for some imported values...
    final DataSourceBean dsb = dataSource;
    final LocaleBeanBase lb = localeBean;

    // Get all exhibit properties; never null.
    final AllExhibitProperties aep = dsb.getAllExhibitProperties(-1);
    final Comparator<String> exhibitComparator = ExhibitAttrUtils.getAttrWords().SMART_ORDER;

    // Retrieve the exhibit name from the request...
    final String exhibitName = (String) request.getAttribute("exhibitName");
    // Check that the syntax is valid and that the exhibit exists...
    if(!ExhibitName.validNameSyntax(exhibitName))
        {
//        response.sendError(response.SC_FORBIDDEN);
        request.getRequestDispatcher(WebConsts.NOT_FOUND_PAGE).forward(request, response);
        return;
        }
    // Get this exhibit's properties; never null.
    final ExhibitStaticAttr esa = aep.aeid.getStaticAttr(exhibitName);
    // If it doesn't exist gently tell the user so...
    if(esa == null)
        {
//        response.sendError(response.SC_NOT_FOUND);
        request.setAttribute("javax.servlet.error.request_uri", request.getRequestURI()); // Force setup of request URI.
        request.getRequestDispatcher(WebConsts.NOT_FOUND_PAGE).forward(request, response);
        return;
        }
    // Compute the short (file-component-only) name.
    final String shortName = ExhibitName.getFileComponent(exhibitName);

    // Get the exhibit type...
    final ExhibitMIME.ExhibitTypeParameters exhibitType = (ExhibitMIME.getInputFileType(esa.filePath));

    // Get the author initials...
    final String auth = ExhibitName.getAuthorComponent(esa.filePath);

    // Get the exhibit loadable properties; never null.
    final ExhibitPropsLoadable epl = aep.getExhibitPropsLoadable(exhibitName);

    // Get the exhibit immutable computable properties if possible.
    final ExhibitPropsComputable epc = aep.getExhibitPropsComputable(exhibitName);

    final GenProps gp = dsb.getGenProps(-1);

    // Does our visitor seem to be a spider?
    final boolean probablySpider = WebUtils.requestProbablyFromSpider(request);

    // Reduce server load when being spidered (or possibly if busy)
    // by generating more 304s for unpopular old exhibits,
    // ie allow their pages to be cached for longer.
    // Only force new/good exhibits to be refetched all the time...
    if(probablySpider)
        {
        // Get the exhibit immutable computable properties,
        // but don't force recomputation at all if not immediately available.
        final ExhibitPropsComputableMutable epcm =
            aep.getExhibitPropsComputableMutable(exhibitName, true, gp, dsb, dsb.getScorerCache());
        // If unpopular, allow spider to use much older cached page.
        if((epcm != null) && !epcm.isStale())
            {
            final int goodness = epcm.getGoodness();
            // "Bad" (and not new) exhibits can be respidered very infrequently.
            if(goodness < 0)
                { request.setAttribute(WebConsts.SPIDER_IF_MOD_SINCE_THRESHOLD_ATTR_NAME, new Long(esa.timestamp)); }
            // Not-quite "good" (and not new) exhibits can be respidered reasonably frequently.
            else if(goodness < Integer.MAX_VALUE - ExhibitPropsComputableMutable.GOODBAD_LIMIT_INT)
                { request.setAttribute(WebConsts.SPIDER_IF_MOD_SINCE_THRESHOLD_ATTR_NAME, new Long(Math.max(aep.hashNotChangedSince - WebConsts.SPIDER_PAGE_EXPIRY_MS/4, esa.timestamp))); }          
            // Implicitly, "good" exhibits get respidered most frequently.
            }
        }

    // Does this look like a new (or newly-sticky) visitor?
    final boolean probablyNewClient = (null != request.getAttribute(ThroughputMonitorFilterBase.REQ_ATTR_NAME_NEW_CLIENT_FLAG));

    // FIND PREV AND NEXT EXHIBITS (if any)...
    // We use this to tie all the exhibit catalogue pages together
    // for the benefit of spiders and humans!
    // Get full exhibit set (full names), sorted in SMART_ORDER order.
    final List<String> allExhibits = FullSortedExhibitSet.select(application);
    // Find our own location in the array using same order as sort used...
    final int ourPos = Collections.binarySearch(allExhibits, exhibitName, exhibitComparator);
    // Get PREV and NEXT catalogue URLs, if any.
    final String prevPage = (ourPos > 0) ? WebUtils.makeCatPageRRURL((String) allExhibits.get(ourPos-1), WebConsts.F_secondary_generated_HTML_suffix) : null;
    final String nextPage = ((ourPos >= 0) && (ourPos < allExhibits.size() - 1)) ? WebUtils.makeCatPageRRURL((String) allExhibits.get(ourPos+1), WebConsts.F_secondary_generated_HTML_suffix) : null;

    final String category = ExhibitName.getCategoryComponent(exhibitName);
    final String categoryTitle = GenUtils.computeSectionTitle(category, lb);
    final String categoryURL =
        WebConsts.VIRTUAL_COLLECTIONS_BYCATEGORY_ROOT + category + '/';

    // Make the breadcrumbs.
    // Claim that the page is "within" the category tree,
    // and show similar breadcrumbs.
    final Breadcrumbs crumbs = new Breadcrumbs();
    crumbs.append(new Breadcrumbs.Breadcrumb(lb.getLocalisedMessage("common.main.VirtualCollections"), WebConsts.VIRTUAL_COLLECTIONS_ROOT));
    crumbs.append(new Breadcrumbs.Breadcrumb(lb.getLocalisedMessage("common.virtCol.byCategory.title"), WebConsts.VIRTUAL_COLLECTIONS_BYCATEGORY_ROOT));
    crumbs.append(new Breadcrumbs.Breadcrumb(categoryTitle, categoryURL));
%><%--


HEADER (possibly including breadcrumbs line, flush()ed to the user)
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, categoryTitle); %><%--
--%><%
    // Insert page-specific keywords in title and meta-headers if extant.
    final String specificAKA = GenUtils.getLocalisedTreeDesc(aep, exhibitName, lb, false, true, false, true);
    final boolean hasSpecificAKA = (specificAKA.length() != 0);
    final String keywords = ExhibitName.getMainWordsComponent(exhibitName, ExhibitAttrUtils.getAttrWords().getAttrWordsSortedSet()).replace(ExhibitName.WORD_SEP, ',') +
        (hasSpecificAKA ? (',' + specificAKA) : "");
    request.setAttribute(WebConsts.STDHDR_ATTR_NAME_KEYWORDS, keywords);
    final String subhead = WebUtils.minimalUniqueENTitlePrefix(allExhibits, ourPos) +
        (!hasSpecificAKA ? "" : (" - " + specificAKA) );
    request.setAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE, subhead);
    %><%--
--%><% if(prevPage != null) { pageContext.setAttribute("prev", prevPage); } %><%--
--%><% if(nextPage != null) { pageContext.setAttribute("next", nextPage); } %><%--
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_BREADCRUMBS, crumbs); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--
--%><% final boolean isBusy = siteIsBusy; %><%--


BODY STARTS...
--%><% final long bodyGenStartTime = System.currentTimeMillis(); %><%--
--%><% final String referringHost = WebUtils.requestProbablyReferredFromExternalSite(request); %><%--
--%><% final boolean justArrived = referringHost != null; %><%-- Just arrived from a 3rd-party site?
--%><% final int pageDisplayTarget_ms = ((WebConsts.FIRST_PAGE_AFAP && justArrived) ? CoreConsts.MAX_INTERACTIVE_DELAY_MS : WebConsts.MAX_PG_DOWNLOAD_MS); %><%--


GET STANDARD SESSION VALUES.
--%><% final SessionVarBean svb = SessionVarBean.getExtantSessionVars(request, true); %><%--
"LITE" UI if explicitly requested, or if "lite"/minimal skin is in use.
--%><% final boolean isLiteUI = svb.isSessionVarLiteUI() || VirtualHosts.SKIN_BLACK_MINIMAL.equals(skinName); %><%--


START COMPUTING "SIMILAR EXHIBIT" RESULTS
This is likely to be slow, so we start it as soon as the header
has been flushed to the user.
Choose maximum similar-exhibit search results to show...
Trim number of results to the bone if site busy, so as to save resources.
Also trim number of results for spiders/bots to reduce system load.
--%><% final int maxToShow = (isBusy || probablySpider || isLiteUI) ? 2 : SearchResultSimpleCache.ABS_MAX_RESULTS; %><%--
--%><% final Future<List<String>> searchResultFuture = SearchResultSimpleCache.doCachedCatPageSimilarItemsFuture(dsb, exhibitName, maxToShow); %><%--



DECIDE IF WE ARE GOING TO ASK THE USER TO VOTE
Since this may be expensive for us and bothersome to the user,
we don't do it *all* the time that we can.
We make a request more likely for exhibits close to neutral score
so as to help gather votes to differentiate them from the great-unvoted masses.
--%><%! private static final int PESTER_FACTOR = 3 + Rnd.fastRnd.nextInt(2); %><%--
--%><%
    // If we do ask the user to vote then voteID will be set non-null
    // (with the unique listener ID).
    String voteID = null;

    try
        {
        // Don't ask user to vote if:
        //   * we're busy
        //   * the user looks like a spider
        //   * the user seems to be new (or newly-sticky)
        //   * randomly we don't feel like it (to put a bound on user pestering)
        //   * this seems to be a page "prefetch"
        //   * we appear to be a slave cut off from the master (and thus might not be able to record the vote)
        //   * the user already has a pending or recent vote
        //   * this exhibit was recently voted for (by anyone)
        //   * a vote was very recently cast from the same geographic area
        //   * the client is compromised or anonymised or in a "bad neighbourhood"
        if(!isBusy &&
           !probablySpider &&
           !probablyNewClient &&
           !justArrived &&
           (Rnd.fastRnd.nextInt(PESTER_FACTOR) == 0) &&
           !WebUtils.isPrecacheRequest(request) &&
           !WebUtils.isDisconnectedSlave(dsb) &&

            // Check that this user does not have another pending vote invitation.
           !StatsSink.isListenerLiveForDataPoint(
                    WebUtils.generateUserDataPointID(WebConsts.VOTER_DATA_POINT_PREFIX, request)) &&

            // Check that this exhibit was not recently voted for.
            // Check previous-period values first as usually fully cached.
           (dsb.getEventValue(SystemVariables.VOTE_PRO, EventPeriod.VLONG, false).getCount(shortName) == 0) &&
           (dsb.getEventValue(SystemVariables.VOTE_CON, EventPeriod.VLONG, false).getCount(shortName) == 0) &&
           (dsb.getEventValue(SystemVariables.VOTE_PRO, EventPeriod.VLONG, true).getCount(shortName) == 0) &&
           (dsb.getEventValue(SystemVariables.VOTE_CON, EventPeriod.VLONG, true).getCount(shortName) == 0) &&

            // Quick check that a vote has not just been cast from same-ish IP.
           !(WebUtils.VOTER_LOCATION_STATS_EVENT_PREFIX + GeoUtils.getRegionByAddress(InetAddress.getByName(request.getRemoteAddr()), true)).equals(
               dsb.getVariable(WebUtils.VOTER_LOCATION_STATS_EVENT_DEF)) &&

            // User is not hiding their ID nor on a compromised PC, etc...
           (null == AddrTools.isAddrBlackholed(gp.getDNSRBLs(), InetAddress.getByName(request.getRemoteAddr()), false))
               )
            {
            // Get the current "goodness value".
            // Use the "allow stale" flag to try to ensure that
            // this will always be quick to fetch
            // so that we do not delay showing
            // the important parts of the page to the user.
            final ExhibitPropsComputableMutable epcm = aep.getExhibitPropsComputableMutable(exhibitName,
                                                                                            true,
                                                                                            gp,
                                                                                            dsb,
                                                                                            dsb.getScorerCache());

            // There may be any number of other reasons not to ask a user to vote...
            // Don't ask for a vote if EPCM value is not available.
            // Make a request less likely if the "goodness" is far from neutral (zero);
            // in fact make it about 20 times less likely if at +/- 1 than if at zero.
            final boolean dontAskForVote = (epcm == null) ||
                (2*Math.abs(epcm.getGoodnessAsFloat()) > Math.abs(Rnd.fastRnd.nextGaussian()));

            // We want the user to vote (and we don't show them the current rating)
            // when everything seems OK.
            // We may still not actually be able to get
            // a vote request into the system however...
            if(!dontAskForVote)
                { voteID = WebUtils.createAndFileVoteListener(exhibitName, request, dsb); }

            // When we ask the user to vote,
            // display the yes/no links swapped at random
            // in order to reduce some forms of bias by humans
            // (and also by any spiders that get this far).
            if(voteID != null)
                {
                final String proText = "Yes, I like it!"; // FIXME: needs i18n...
                final String conText = "No, don't like it."; // FIXME: needs i18n...

                // Swap the links randomly and completely unpredictably!
                final boolean swap = Rnd.goodRnd.nextBoolean();

                final String tag = LocalProps.getMirrorTag();

                %><div id="voteDiv"><p id="votePara"><%--

Using POST: less likely to be followed by spider/bot/"accelerator".
We use an absolute host name if possible for robustness.
--%>
<center>
<form method="POST" action="<%= (tag == null) ? "" : ("http://" + LoadBalancingUtils.makeMirrorNameFromTag(tag)) %><%= WebConsts.STATS_SINK_PAGE_RRURL %>">
<strong>Please VOTE:</strong> &nbsp; <%-- // FIXME: needs i18n... --%>
<input type="hidden" name="<%= StatsSink.HTTP_ID_PARAM_NAME %>" value="<%= voteID %>">
<input type="image" name="<%=  swap ? WebUtils.VOTE_PRO_PARAM_NAME : WebUtils.VOTE_CON_PARAM_NAME %>" src="/_static/icon/<%=  swap ? WebConsts.PRO_ICON_15x15_NAME : WebConsts.CON_ICON_15x15_NAME %>" alt="<%=  swap ? proText : conText %>" title="<%=  swap ? proText : conText %>" width=15 height=15>
<input type="image" name="<%= !swap ? WebUtils.VOTE_PRO_PARAM_NAME : WebUtils.VOTE_CON_PARAM_NAME %>" src="/_static/icon/<%= !swap ? WebConsts.PRO_ICON_15x15_NAME : WebConsts.CON_ICON_15x15_NAME %>" alt="<%= !swap ? proText : conText %>" title="<%= !swap ? proText : conText %>" width=15 height=15>
</form>
</center>
<%--

                --%></p></div><%

// Hide/remove vote text and links when the invitation will have expired...

                // Estimated vote invitation expiry time.
                // Randomise a bit to keep people on their toes...
                final long voteExpiryMs = (WebConsts.VOTE_MIN_REQUEST_GAP_MS/2)
                    + Rnd.fastRnd.nextInt(1 + WebConsts.VOTE_MIN_REQUEST_GAP_MS/2);

                // Thanks to Brian Morris and http://www.quirksmode.org/
                // for help with this JavaScript...
                %>
                <script language="JavaScript" type="text/JavaScript">
                <!--
                var voteDiv = document.getElementById('voteDiv');
                var votePara = document.getElementById('votePara');
                function zapIt()
                {
                    voteDiv.removeChild(votePara);
                }

                setTimeout("zapIt();", <%= voteExpiryMs %>);
                //-->
                </script>
                <%
                }
            }
        }
    catch(final Throwable e)
        {
        // Don't let an exception in voting break the whole page...
        // Maybe whinge to the log but continue anyway...
//        e.printStackTrace();
        }
        %><%--


EXHIBIT THUMBNAIL, LINK AND DESCRIPTION (all centred)

We will consider using HTXT, JPEG, GIF and PNG thumbnails inline.
In the special case that the images are small enough in terms
of bytes then we will use the image directly and let the browser
do any scaling needed, else we will try
to obtain a thumbnail and use that.

All good AdSense MediaBot food.
--%><%
            if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to emphasise this text. */
                {
            %>
<!-- google_ad_section_start -->
            <%
                }
%><%--

--%><center><%--
--%><p><%--
--%><%
// Try to compute what XxY of image (if exhibit is an image)...
final java.awt.Dimension xyDim = (epc == null) ? null : epc.getXyDimensions();

// Insert thumbnail if possible...
final URL exhibitURL = WebUtils.makeExhibitURL(exhibitName, request, dsb);
if(WebUtils.canInlineInHTMLPage(exhibitType))
    {
    final int BORDER_WIDTH = PageSkinUtils.GENERIC_TN_BORDER_WIDTH_PIXELS; // Decorative border width for thumbnail tables.

    // Special case for HTXT.
    // Display ONLY if short enough to embed directly.
    if(exhibitType.type == ExhibitMIME.ET_HTMLFRAG)
        {
        // Can we use the exhibit itself?
        final boolean verySmallExhibit = (esa.length <= ExhibitThumbnails.SML_ABS_MAX_BYTES);

        if(verySmallExhibit)
            {
            %><table border=<%= BORDER_WIDTH %> width="90%"><tr><td><%
            final ByteBuffer buf = ByteBuffer.allocate((int) esa.length);
            for(int start = 0; start < esa.length; )
                {
                dsb.getRawFile(buf, exhibitName, start, false);
                // Ugly; write a single (ISO-8859-1) char at a time...
                buf.flip();
                start += buf.limit();
                while(buf.remaining() > 0)
                    { out.print((char) (buf.get() & 0xff)); }
                }
            %></td></tr></table><br /><%
            }
        }
    // Special case for Flash exhibit,
    // as long as it is small enough in size and pixels.
    else if((exhibitType.type == ExhibitMIME.ET_SWF) &&
            (esa.length <= ExhibitThumbnails.STD_ABS_MAX_BYTES) &&
            (xyDim != null) &&
                (xyDim.width <= ExhibitThumbnails.STD_STATIC_IMAGE_TN_LDIM_PX) &&
                (xyDim.height <= ExhibitThumbnails.STD_STATIC_IMAGE_TN_LDIM_PX))
        {
        final int width = xyDim.width;
        final int height = xyDim.height;

        // Attempt to extract the version of Flash that we need.
        int version = 7; // Defaults to a sensible/common value.
        try
            {
            final AllExhibitProperties.ExhibitDataSource exhibitDataSource = new AllExhibitProperties.ExhibitDataSource(){
                /**Check if the given exhibit is fully loaded; true if so. */
                public boolean isExhibitFullyLoaded(final ExhibitStaticAttr esa) throws IOException
                    { throw new IOException("not known"); }
                /**Read a chunk of the raw exhibit binary into the given buffer. */
                public void getRawFile(final ByteBuffer buf, final String name, final int start) throws IOException
                    { dsb.getRawFile(buf, name, start, false); }
                };
            final swf.SWFMetaData swfMetaData = new swf.SWFMetaData(exhibitDataSource.getInputStream(esa));
            version = Math.max(6, swfMetaData.version);
            }
        catch(final IOException e) { /* Ignore/absorb errors. */ }

        %>
<table border=<%= BORDER_WIDTH %>><tr><td>
<script type="text/javascript" src="/_static/misc/flashobject.js"></script>
<div id="flashTN">
MacroMedia Flash movie
</div>
<script type="text/javascript">
   var fo = new FlashObject("<%= exhibitURL %>", "flashTNID", "<%= width %>", "<%= height %>", "<%= version %>", "#000000");
   fo.addParam("quality", "low");
   fo.write("flashTN");
</script>
</td></tr></table><br />
        <%
        }
    else // Assume an embeddable (2D) image...
        {
        // Try and get a thumbnail, which must be an inlineable image.
        final java.awt.Dimension thumbnailXyDim = new java.awt.Dimension();
        String thumbnailRRURL = WebUtils.makeHTMLInlineImageThumbnailURL(
            dsb, exhibitName,
            true, // Make a standard thumbnail.
            true, // Make relative URL.
            thumbnailXyDim,
            isBusy || probablySpider || (WebConsts.FIRST_PAGE_AFAP && justArrived)); // Force thumbnail generation (if site not busy, etc)...
        // Fallback to small thumbnail if we have to...
        if(thumbnailRRURL == null) // If that fails, try for the small thumbnail...
            {
            thumbnailRRURL = WebUtils.makeHTMLInlineImageThumbnailURL(
                dsb, exhibitName,
                false, // Make a small thumbnail.
                true, // Make relative URL.
                thumbnailXyDim,
                isBusy || probablySpider || (WebConsts.FIRST_PAGE_AFAP && justArrived)); // Force thumbnail generation (if site not busy, etc)...
            }
        if(thumbnailRRURL != null)
            {
            %><table border=<%= BORDER_WIDTH %>><tr><td><a href="<%= exhibitURL %>"><img src="<%= thumbnailRRURL %>" width=<%= thumbnailXyDim.width %> height=<%= thumbnailXyDim.height %> alt=<%= UploaderUtils.quoteHTMLArg(lb.getLocalisedMessage("common.thumbnail") ) %> title="<%= subhead.replace('"', '\'') %>"<%= WebConsts.TN_IMG_TAG_EXTRA_ATTR %>></a></td></tr></table><br /><%
            }
        }
    }
// Can handle some non-embeddable media specially...
else
    {
    if((exhibitType != null) && exhibitType.mimeType.startsWith("audio/"))
        {
        %><img src="/_static/icon/audio.gif" width="128" height="128" alt="audio" /><br /><%
        }
    else if((exhibitType != null) && exhibitType.mimeType.startsWith("video/"))
        {
        %><img src="/_static/icon/video.gif" width="128" height="128" alt="video" /><br /><%
        }
    }

// Insert description (and location info, etc) if extant...
final String description = epl.getDescription();
final Location.Base location = aep.getLocation(exhibitName); // Never null.
if(description != null) { %><%= description %><br><% }
%><%--
Emphasise and label the download link...
--%><span style="font-weight: bold; color: red;"><%= lb.getLocalisedMessage("common.cat.Download") %></span><%--

Now the small/medium/full download links...
--%><%
final ExhibitThumbnails tns = dsb.getThumbnails(exhibitName, !isBusy && !probablySpider && !(WebConsts.FIRST_PAGE_AFAP && justArrived));
final boolean hasSmlTn = (null != tns) && (null != tns.getSmall());
final boolean hasStdTn = (null != tns) && (null != tns.getStandard());
%>
<% if(hasSmlTn) { %><small><a href="<%= WebUtils.makeThumbnailRRURL(exhibitName, false) %>"><%= lb.getLocalisedMessage("common.cat.Download.smlTn") %></a></small><% } %>
<% if(hasStdTn) { %><a href="<%= WebUtils.makeThumbnailRRURL(exhibitName, true) %>"><%= lb.getLocalisedMessage("common.cat.Download.stdTn") %></a><% } %>
<big><a href="<%= exhibitURL %>"><%= lb.getLocalisedMessage("common.cat.Download.full") %></a></big>
<br />
<%--

Now the full exhibit name and info with links into the tree...
--%><small><i>(<a href="<%= categoryURL %>/"><%= categoryTitle %></a>)</i></small>: <strong><% {
    final TreeFilterBean tfb = WebUtils.getCategoryTreeFilterBean(dsb, category);
    final String allwords = ExhibitName.getFileComponent(exhibitName);
    final String mainwords = ExhibitName.getMainWordsComponent(exhibitName, ExhibitAttrUtils.getAttrWords().getAttrWordsSortedSet());
    boolean[] uninterestingNodes;
    try { uninterestingNodes = tfb.getUninterestingNodes(application, mainwords.toLowerCase() + ExhibitName.WORD_SEP, null); }
    catch(final Exception e) { uninterestingNodes = new boolean[0]; e.printStackTrace(); }

    final StringBuilder linkText = new StringBuilder(exhibitName.length());
    linkText.append(categoryURL);

    // Link to "interesting" points further down the category tree.
    int index = 0;
    for(final String word : allwords.split("-"))
        {
        final boolean potentiallyInteresting = (index < uninterestingNodes.length);
        if(potentiallyInteresting) { linkText.append(word.toLowerCase()).append('/'); } // Generate canonical monocased URI suffixes...
        final boolean interesting = potentiallyInteresting && (!uninterestingNodes[index++]);
        %> <%
        if(interesting) { %><a href="<%= linkText %>"><% }
        %><%= word %><%
        if(interesting) { %></a><% }
        }
  %></strong><br /><% } %><%--
--%><%
        // Newness indicator.
        if((bodyGenStartTime - esa.timestamp) <= CoreConsts.MAX_EXHIBIT_AGE_NEW_MS)
            { %><span style="font-weight: bold; color: red;"><%= lb.getLocalisedMessage("common.selection.newExhibits.title") %></span> <% }
      %><%--
      --%>D=<%= CoreConsts.DEFAULT_DATE_FORMAT.format(new Date(esa.timestamp)) %><%--
          now do date in user's locale... --%> [<%= DateFormat.getDateInstance(DateFormat.MEDIUM, lb.getLocale()).format(new Date(esa.timestamp)) %>]<%--
      --%>; S=<%= TextUtils.sizeAsText(esa.length, true) %><%--
          --%><%= (xyDim == null) ? "" : (", " + xyDim.width + "x" + xyDim.height) %><%--
      --%>; T=<%= (exhibitType == null) ? "?" : (exhibitType.description + " [MIME:" + exhibitType.mimeType + "]") %><%--
      --%><% if(location != Location.NONE) { %>; <br><nobr><% if(location instanceof Location.Estd) { %><a href="<%--http://www.aloha-earth.com--%><%= AEUtils.AE_SELF_RRURL + (new AEParams()).setLocation((Location.Estd) location).getAsGetPathInfo(false) %>" target="_top">Aloha Earth! <%= LocationUtils.makeLocTNImgHTML((Location.Estd) location) %></a> <% } %>L=<%= location %></nobr><% } %><%--
      --%>.<br /><%--

PUT IN COPYRIGHT NOTICE AND LINKS (to Ts&Cs and author's virtual collection)
--%><strong><%= lb.getLocalisedMessage("common.cat.freeToUse") %></strong> <%--
--%><a href="/terms.html">(c)</a> <a href="<%= WebConsts.VIRTUAL_COLLECTIONS_BYAUTHOR_ROOT + auth + '/' %>"><%= auth %></a><%--

--%></p><%--
--%></center>
<%-- Insert linebreak for sanity of anyone reading the HTML...


End of this core "content" area for AdSense targetting.
--%><%
            if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to emphasise this text. */
                {
            %>
<!-- google_ad_section_end -->
            <%
                }
%><%--


INVITE THE USER TO ADD THIS PAGE TO THEIR "FAVOURITES" IN IE
to try to get a new user to come back,
or maybe if the page is madly popular...
--%><% if(justArrived || (dsb.getEventValue(SystemVariables.ACCESSPATTERN_COMPLETED_DOWNLOAD, EventPeriod.VLONG, true).getRank(shortName) < 10)) { %>
<!--[if IE]> <%-- IE-only add-to-favo[u]rites link... --%>
<p align="left"><a href="?action=bm" onClick="window.external.AddFavorite('http://<%= CoreConsts.MAIN_DATA_HOST %>/','<%= localeBean.getLocalisedMessage("common.addToFavourites.IE.desc") %>');"><strong><span class="favorites"><%= lb.getLocalisedMessage("common.addToFavourites.IE") %></span></strong></a></p>
<![endif]-->
<% } %><%--


START COMPUTING METADATA, IF ANY
Often slow to fetch/format, so start computing it early, asynchronously.
Don't show this for the "lite" UI mode (nor spiders, to reduce SE "noise").
--%><% final Future<?> metaDataFuture = (isLiteUI || probablySpider) ? null : WebUtils.getCatPageExhibitMetaDataHTMLFuture(dsb, exhibitName); %><%--
    


FLUSH
Now that the core exhibit-specific information-rich part has been generated,
and all the probably-slow-to-calculate values have been launched in their own threads,
we could push the page so far to the browser
if it has been a long-ish time since we started generating the body text.
Note, however, that when we are generating the whole body of
the page as a table this may have no effect other than to waste some
bandwidth/CPU on browsers such as IE5/6 that do not draw any of a
table speculatively until the whole thing has been received.
A flush MAY also block for a significant time on a slow or long-RTT connection,
thus greatly slowing down page generation and display.
--%><% if(System.currentTimeMillis() - bodyGenStartTime > pageDisplayTarget_ms/2) { %><!--TP0--><% out.flush(); } %><%--


INSERT THE RATING (and other related stats)
May be slow to compute so add to the page only after any flush of core data.
Only try to force a (re)computation if the site is not busy.
Only do this if we're not asking the user to vote so as not to influence them.
Don't display a stale rating.
--%><%! private static final int RATING_OUT_OF = 100; /* Value rating is out of. */ %><%--
--%><%
    if(voteID == null)
        {
        // Get the exhibit immutable computable properties.
        // Don't force recomputation if we're busy...
        final ExhibitPropsComputableMutable epcm =
            aep.getExhibitPropsComputableMutable(exhibitName, isBusy, gp, dsb, dsb.getScorerCache());

        // Accumulated stats (empty if none).
        final StringBuilder sb = new StringBuilder();

        // Don't show stale (unavailable/unreliable/approximate) rating.
        if((epcm != null) && (!epcm.isStale()))
            {
            // Avoid smile/frown for sensitive exhibits...
            if(!GenUtils.isSensitive(exhibitName, aep, gp))
                {
                // Insert smile/frown as appropriate.
                final Boolean isGood = epcm.isGood();
                if(isGood != null)
                    {
                    sb.append("<img src=\"/_static/icon/").
                        append(isGood.booleanValue() ? WebConsts.PRO_ICON_15x15_NAME : WebConsts.CON_ICON_15x15_NAME ).
                        append("\" border=0 width=15 height=15> ");
                    }
                }

            final int rating = Math.max(0, Math.min(RATING_OUT_OF, Math.round(
                                                    (((epcm.getGoodnessAsFloat() + 1) / 2) * RATING_OUT_OF))));

            sb.append(lb.getLocalisedMessage("common.cat.rating", rating, RATING_OUT_OF));
            }

        // Display other (live) stats, but none of this is vital.
        try
            {
            final EventVariableValue downloadRank =
                    dsb.getEventValue(SystemVariables.ACCESSPATTERN_COMPLETED_DOWNLOAD, EventPeriod.VLONG, false);
            final int rank = downloadRank.getRank(shortName);
            if(rank < Integer.MAX_VALUE) // If ranked at all...
                {
                sb.append(' ');
                sb.append(lb.getLocalisedMessage("common.cat.rank.download", 1+rank, aep.aeid.length));

                // Get long-term download stats from "all" bucket
                // if not busy/lite, and if ranked well near-term.
                if(!isBusy && !isLiteUI)
                    {
                    final EventVariableValue downloadRankLT[] =
                            dsb.getEventValues(SystemVariables.ACCESSPATTERN_COMPLETED_DOWNLOAD, EventPeriod.VLONG, 0, null);
                    if((downloadRankLT.length > 0) && (downloadRankLT[0] != null))
                        {
                        final int rankLT = downloadRankLT[0].getRank(shortName);
                        if(rankLT < Integer.MAX_VALUE)
                            {
                            sb.append(' ');
                            sb.append(lb.getLocalisedMessage("common.cat.rank.download.longterm", 1+rankLT, aep.aeid.length));
                            }
                        }
                    }
                }
            final int count = downloadRank.getCount(shortName);
            if(count > 0)
                {
                sb.append(' ');
                sb.append(lb.getLocalisedMessage("common.cat.count.download", count, downloadRank.getTotalEventCount()));
                }
            }
        catch(final Throwable e)
            {
            // Just drop stats if any cause an IOException.
//            e.printStackTrace(); // Maybe note the problem, but continue...
            }

        // Produce a whole para for any stats that we gathered...
        if(sb.length() > 0)
            { %><p align=center><%= sb.toString() %></p><% }
        }
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


INSERT OPTIONAL AD
We don't necessarily expect there to be many of these,
because we expect often to use inventory up earlier in our page header, etc,
but (say) for minimalist page skins this may be our only ad slot.
This may *sometimes* appear just "below the fold", ie only after scroll down.
We may have it with alarming colours to make it stand out when present.
We rotate the ad types after a few minutes or so
in order to keep attention of regular visitors...
This slot may also help ensure that we don't miss inventory
that is not available in all formats and at all times of day...
Some of the time possibly don't try to show an ad at all
(especially if the vistor seems to be a spider since some fallback URL code
will break in cached pages).
But we may show all the time if not using the optimal page/ad layout.
We show ads even less if this page does not seem to attract click-throughs
so as to reduce unprofitable delay in rendering the page for the visitor.
We will skip this ad entirely if the user is being asked to vote,
so as to help the page load quickly!
DHD20051121: CasaleMedia confirmed this is high enough on page for their medium rectangle ad.
--%><% if(!probablySpider &&
          (voteID == null) &&
          (!WebConsts.FIRST_PAGE_AFAP || !justArrived) &&
          AdUtils.showAds(dsb, request)) { %><%--
--%><%! final int ageLimitS = CoreConsts.MAX_EXHIBIT_AGE_NEW_S + Rnd.fastRnd.nextInt(37 * 24 * 3600); %><%--
--%><%
    // We assume that ads must be run against this exhibit for a month or more
    // (eg to allow for monthly ad-budget cycles)
    // before any click-through data for it can be considered very meaningful.
    // But we randomise this so as to gradually fade out non-performing slots.
    final boolean notVeryNew = ((System.currentTimeMillis() - esa.timestamp) >
                    Rnd.fastRnd.nextInt(ageLimitS) * 1000L);

    // If we seem to have sufficient/meaningful click-through data
    // then we can use it to help us decide about showing an ad here.
    // Skip the ad if:
    //   * the exhibit is not new (<~1M) for click-through purposes, and
    //   * we're showing towers in the best-performing position, and
    //   * the ad slot does not seem to be performing well for this exhibit.
    // The end result should be that a small number of relatively-high CTR
    // exhibits should get ads shown almost all the time in this slot,
    // and all exhibits will get an ad shown in this slot occasionally.
    final boolean skipIt = notVeryNew &&
            (AdUtils.selectPageAdLayout(dsb, request, isBusy, true) ==
                (AdTowerPos) request.getAttribute("towerPos")) &&
            AdUtils.skipUnderperformingAdSlot(dsb,
                SystemVariables.ACCESSPATTERN_CLICKTHROUGH, EventPeriod.VLONG, shortName);

    if(!skipIt) {
%><%--
--%><% final AdMidPageInternalLayout adMidPageInternalLayout = AdUtils.selectAdMidPageInternalLayout(dsb, request); %><%--
--%><% switch(adMidPageInternalLayout) { %><%--

--%><% case LBAS: %><%-- We don't run this format very often...
--%><p align=center><script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html";<%-- Collapse if no ad... --%>
google_ad_width = 728;
google_ad_height = 90;
google_ad_format = "728x90_as";
google_ad_channel ="2445865034";<%-- MidPage... --%>
google_color_link = ["FFFFFF","99CC33","FFFFFF","000080"];
google_color_text = ["CCCCCC","FFFFFF","BDB76B","008000"];
google_color_url = ["999999","FFCC00","DAA520","333366"];
google_color_border = ["333333","191933","660000","FFFFFF"];
google_color_bg = ["000000","333366","7D2626","000000"];
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script></p><%--
--%><% break; %><%--

--%><% case SQAS: %><%-- 250x250 plain square; collapses if no ad.
--%><p align=center><script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html";<%-- Collapse if no ad... --%>
google_ad_width = 250;
google_ad_height = 250;
google_ad_format = "250x250_as";
google_ad_type = "text_image";
google_ad_channel ="9645554882";
google_color_border = "333366";
google_color_bg = "FFFFFF";
google_color_link = "000080";
google_color_url = "008000";
google_color_text = "000000";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script></p><%--
--%><% break; %><%--

--%><% case sqAS: %><%-- 200x200 small square; collapses if no ad. --%>
<p align=center>
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html";
google_ad_width = 200;
google_ad_height = 200;
google_ad_format = "200x200_as";
google_ad_type = "text_image";
//2006-09-25: MidPageSmallSquare
google_ad_channel ="1320354457";
google_color_border = "333366";
google_color_bg = "FFFFFF";
google_color_link = "000080";
google_color_text = "000000";
google_color_url = "008000";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
</p>
<% break; %><%--

--%><% case MRTF: if(AdConsts.ENABLE_TRIBALFUSION) { %><%--
--%><% final int rndID = (Rnd.fastRnd.nextInt() >>> 1); %><%--
--%><p align=center><!-- TF 336x280 IFrame VAR code -->
<iframe src="http://a.tribalfusion.com/f.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&type=var&requestID=1274628298" width=336 height=280 marginwidth=0 marginheight=0 hspace=0 vspace=0 frameborder=0 scrolling=no allowTransparency=true>
         <script language=javascript><!--
           randNum = ((new Date()).getTime() % 2147483648) + Math.random();
           document.write(
             "<a href='http://a.tribalfusion.com/i.click?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=" + randNum + "' target=_blank>" +
             "<img src='http://a.tribalfusion.com/i.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=" + randNum + "'" +
               " width=336 height=280 border=0 alt='Click Here'></a>");
         // --></script>
         <noscript>
             <a href="http://a.tribalfusion.com/i.click?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=1274628298" target=_blank>
             <img src="http://a.tribalfusion.com/i.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=1274628298"
                  width=336 height=280 border=0 alt="Click Here"></a>
         </noscript>
</iframe>
<!-- TF 336x280 IFrame VAR code -->
</p><%--
--%><% break; } %><%--

--%><% case MRCM: if(AdConsts.ENABLE_CASALEMEDIA) { %><%--
--%><% final int rndID = (Rnd.fastRnd.nextInt() >>> 1); %><%--
--%><p align=center>
<!-- Casale Media 2005 (C) -->
<!-- Ad Format: Medium Rectangle -->
<!-- Domain(s): hd.org -->
<script language="Javascript"><!--
var d=new Date();var r=(d.getTime()%8673806982)+Math.random();var uu=escape(window.location.href);
var wh='" width="300" height="250" ';var host='.casalemedia.com/';var dc=document;
var fr='marginwidth="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
dc.write('<ifr'+'ame src="http://as'+host+'s?s=68148&u='+uu+'&f=4&id='+r+wh+fr);
dc.write('<a hr'+'ef="http://c'+host+'c?s=68148&f=4&id='+r+'" target="_blank">');
dc.write('<i'+'mg src="http://as'+host+'s?s=68148&u='+uu+'&f=4&id='+r+'&if=0'+wh+'border="0"></a></ifr'+'ame>');
//--></script><noscript><iframe src="http://as.casalemedia.com/s?s=68148&u=http%3A%2F%2Fhd.org&f=4&id=1"
width="300" height="250" marginwidth="0" hspace="0" vspace="0" frameborder="0" scrolling="no"><a
href="http://c.casalemedia.com/c?s=68148&f=4&id=<%= rndID %>" target="_blank"><img
src="http://as.casalemedia.com/s?s=68148&u=http%3A%2F%2Fhd.org&f=4&id=<%= rndID %>&if=0" width="300"
height="250" border="0"></a></iframe></noscript>
<!-- Casale Media 2005 (C) -->
</p><%--
--%><% break; } %><%--

--%><% case MRAS: default: %><%-- MidPageSquare gets 3x better CTR than MidPage, so run in all otherwise-unallocated slots...
--%><p align=center><script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html";<%-- Collapse if no ad... --%>
google_ad_width = 300;
google_ad_height = 250;
google_ad_format = "300x250_as";
google_ad_channel ="9645554882";<%-- MidPageSquare... --%>
google_color_link = ["FFFFFF","000000","000080"];
google_color_url = ["FF6600","666666","008000"];
google_color_border = ["003366","CCCCCC","333366"];
google_color_bg = ["000000","FFFFFF","FFFFFF"];
google_color_text = ["FF6600","333333","000000"];
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script></p><%--
--%><% break; %><%--
--%><% } %><%-- End switch by ad type...
<%-- Insert linebreak for sanity of anyone reading the HTML...
--%><% } %><%-- End skipIt...
--%><% } %><%-- End showingAds...


INSERT THE "KEY"
--%><p><%= lb.getLocalisedMessage("common.cat.key") %></p><%--


NOW INSERT ANY TREE-STRUCTURED INFORMATION AVAILABLE.
Good for the AdSense MediaBot.
--%><%
            if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to emphasise this text. */
                {
            %>
<!-- google_ad_section_start -->
            <%
                }
%><%--
--%><%
    final String treeDesc = GenUtils.getLocalisedTreeDesc(aep,
                                                          exhibitName,
                                                          lb,
                                                          true, true, true, false);
    if(!"".equals(treeDesc))
        {
        %><p><ul><%= treeDesc %></ul></p><%
        }
%>
<%-- Insert linebreak for sanity of anyone reading the HTML...


DESCRIBE ANY EXHIBIT ATTRIBUTES FOUND
Do this after the tree-structure info,
so as to explain later words in the name later on the page.
--%><%
    // Use the SortedSet to remove duplicates
    // and get a consistent alpha ordering.
    final SortedSet<String> awS =
        ExhibitName.getAttributeWordsComponentSortedSet(exhibitName, ExhibitAttrUtils.getAttrWords().getAttrWordsSortedSet());
    if(awS.size() > 0) // Potential attributes to show.
        {
        final StringBuilder attrText = new StringBuilder(79);
        for(final String aw : awS)
            {
            // We'll see if there is descriptive text for this attribute.
            final String i18nName = UploaderConsts.ATTR_I18N_DESC_PREFIX + aw;
            final String msg = lb.getLocalisedMessage(i18nName);
            if(!msg.equals(i18nName))
                {
                attrText.append("<li>");
                attrText.append("<i>").append(aw).append("</i> = ");
                attrText.append(msg);
                attrText.append("</li>");
                }
            }

        // If we found any attribute descriptive text,
        // then list it here.
        if(attrText.length() > 0)
            {
            %><p><ul><%= attrText %></ul></p><%
            }
        }
%>
<%-- Insert linebreak for sanity of anyone reading the HTML...

--%><%
            if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to emphasise this text. */
                {
            %>
<!-- google_ad_section_end -->
            <%
                }
%><%--


TODO: COMMENT BOX OR SURVEY



NOW INSERT A LINK TO MAKE A T-SHIRT...
--%><%
    if(AdConsts.ENABLE_ESHIRT &&
          // !isSensitive &&
          !AdUtils.skipUnderperformingAdSlot(dsb,
                SystemVariables.ACCESSPATTERN_COMPLETED_DOWNLOAD, EventPeriod.VLONG, shortName))
        {
        final EShirtAdBean eShirt = new EShirtAdBean();
        eShirt.setParams(lb.getLocalisedMessage("ad.eshirt.printIt"));
        %><p align="center"><%= eShirt.getHTMLBodyInsert(
            new AdBeanInterface.Context(null, null, esa.filePath),
            Rnd.fastRnd) %></p><%
        }
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


INSERT CONTACT SHEET (PREVIEW INDEX), IF ANY
Omit this if we're busy or doing a "lite" UI (or the client is a spider/bot)
as it may impose quite a CPU and bandwidth load and display latency.
Show this even on a first-page-view to entice the visitor to see similar material.
--%><%
    if(!isBusy && !isLiteUI && !probablySpider)
        { // Scope our local variables to help GC...
        try
            {
            // Get alternate background colour, quoted if necessary,
            // to highlight this exhibit in contact sheet, but not if cacheing,
            // since doing so prevents us sharing the HTML between close exhibits.
            final String altColQ = HTMLThumbnailInsertGenerators.CS_CACHE_FOR_CAT_PAGES ? null :
                UploaderUtils.quoteHTMLArg(PageSkinUtils.getAltBgColour(pageContext));

            // Assume that we can use (nearly) the full display width
            // for the contact sheet so as to minimise scrolling with large sheets.
            final String contactSheet = HTMLThumbnailInsertGenerators.getContactSheetHTML(exhibitName,
                  altColQ,
                  dsb,
                  allExhibits);

            // If a contact sheet is available,
            // drop it in here, centred, after a suitable heading.
            if(!"".equals(contactSheet))
                {
                %><h2><%= lb.getLocalisedMessage("common.cat.ContactSheet") %></h2><%
                %><center><p><%= contactSheet %></p></center><%
                }
            }
        catch(final Throwable e) { e.printStackTrace(); }

        } // End scoping of local variables to help GC.
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...



SHOW SECTION DESCRIPTION, IF ANY
--%><%
    // We'll see if there is descriptive text for this category.
    final String i18nName = UploaderConsts.SECTION_DESC_PROPNAME_PREFIX + ExhibitName.getCategoryComponent(exhibitName);
    final String desc = lb.getLocalisedMessage(i18nName);
    // We show the localised version if it exists and isn't just in a different case.
    if(!desc.equals(i18nName))
        {
        %><h2><%= lb.getLocalisedMessage("common.cat.sectionDescription") %></h2><%
        %><div><center><%= desc %><p></center></div><%
        }
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


COLLECT SET OF EXHIBITS ALREADY DISPLAYED (eg with link)
The idea being to avoid showing a link to another exhibit more than once.
This is a set of the short names of exhibits.
--%><%
    final Set<String> alreadyShownShortNames = new HashSet<String>();
    // Prime it with the exhibit itself.
    alreadyShownShortNames.add(shortName);
    %><%--


VARIATIONS ON SAME EXHIBIT
First, see if there are other variants on this exhibit
(which will be revealed by the the returned sublist being bigger than one).
--%><%
    final List<String> variants =
        WebUtils.getExhibitVariantRange(allExhibits, ExhibitAttrUtils.getAttrWords().SUBJECT_ORDER, ourPos);
    final int otherVariants = variants.size() - 1;
    if(otherVariants > 0)
        {
        // Now make a table of them in the same style as a search table.

        // Choose maximum results to show...
        // Assume these are all likely to be interesting,
        // so be prepared to show quite a lot.
        // Reduce number we will show if the site is busy (or for "lite" UI) to reduce load.
        final int MAX_TO_SHOW = (isBusy || isLiteUI) ?
                                5 : otherVariants; // Trim number of results if site busy or "lite".

        // Always show from the first variant...
        final int firstPos = 0;

        // Convert our variants list to short names.
        final String searchResults[] = new String[otherVariants];
        final Iterator it = variants.iterator();
        for(int i = 0; i < searchResults.length; )
            {
            final String variantShortName =
                ExhibitName.getFileComponent((String) it.next());
            if(variantShortName.equals(shortName))
                { continue; } // Skip exhibit's own name.
            searchResults[i++] = variantShortName;
            }

        %><h2><%= lb.getLocalisedMessage("common.cat.variantExhibits") %></h2><%
        %><center><p><%
        %><%@ include file="HTMLSearchResults.inc.jsp" %><%
        %></center></p><%

        // Don't show any of the variants again...
        alreadyShownShortNames.addAll(Arrays.asList(searchResults));
        }
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


SIMILAR EXHIBITS
Do simple query based on full name of exhibit and possibly any descriptive text...
Only show results if we get any!
Possibly don't show this if the site is busy as it is expensive,
but still allow a user to explicitly search for similar exhibits.
--%><%

    { // Scope our variables.

// Force out partial page so far if we've been slow
// and we do not yet have the search results ready.
final long timePoint1 = System.currentTimeMillis() - bodyGenStartTime;
final boolean tooSlow = timePoint1 > pageDisplayTarget_ms;
if(tooSlow && !searchResultFuture.isDone()) { %><!--TP1:<%=timePoint1%>--><% out.flush(); }

try
    {
    // Do the lookup, using most of exhibit name as "any word" query string.
    // We exclude any variants of the current exhibit from the results,
    // which therefore excludes the current exhibit too.

    // Time the full search, since it can be relatively expensive.
    // This should be zero if it we don't have to wait here...
    final long searchStartTime = System.currentTimeMillis();

    List<String> wrappedResult = searchResultFuture.get();
    
    // Make sure we remove any duplicates wrt those already shown.
    if(!wrappedResult.isEmpty() /* && !alreadyShownShortNames.isEmpty() */ )
        {
        wrappedResult = new ArrayList<String>(wrappedResult);
        wrappedResult.removeAll(alreadyShownShortNames);
        }
    final String[] searchResults = new String[wrappedResult.size()];
    wrappedResult.toArray(searchResults);

    final long endStartTime = System.currentTimeMillis();
    // Record the search time for later display, if it is significant.
    final long searchTime = endStartTime - searchStartTime;
    if(searchTime > 1) // Only record the time if not just noise...
        {
        pageContext.setAttribute(WebConsts.SEARCH_TIME_MS_ATTR_NAME,
                                 Long.valueOf(searchTime));
        }

    // Now display the results, if any...
    if(searchResults.length > 0)
        {
        // Display from first item.
        final int firstPos = 0;
        // Show all the results that we have.
        final int MAX_TO_SHOW = Math.min(maxToShow, searchResults.length);

%>
<h2><%= lb.getLocalisedMessage("common.cat.similarExhibits") %></h2>
<center><p><%@ include file="HTMLSearchResults.inc.jsp" %></p></center>
<%

        // Don't show any of the `similar exhibits' again...
        //alreadyShownShortNames.addAll(Arrays.asList(searchResults));

        } // End `if any results' if.

    } // End `doing search' if.
catch(final Throwable e) { e.printStackTrace(); }

// End local variable scope...
} %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


FIND MORE EXHIBITS LIKE THIS
Always invite the user to explicitly look for more exhibits,
even/especially when the site is busy...
Use the same search terms as the "similar exhibits" search...
We *don't* canonicalise here as it is expensive
and the vast majority of this work is wasted (the link never followed).
--%><%
    // For lookup use just:
    //   * The main words.
    //   * The attribute words.
    // In particular we exclude:
    //   * The number in series.
    //   * All the directory components.
    //   * The author initials.
    final Set<String> noAttrWords = Collections.emptySet();
    // All main and attribute words...
    final String similarExhibitsSearchTerms =
        ExhibitName.getMainWordsComponent(exhibitName, noAttrWords);
    %><%--
--%><center><p><form method="<%= WebConsts.SEARCH_FORM_METHOD %>" action="/_cat/doHTMLSearch.jsp"><%--
--%><input type=hidden name=q value="<%= TextUtils.sanitiseForXML(similarExhibitsSearchTerms, WebConsts.MAX_SIMPLE_QUERY_LEN, false) %>">&nbsp;<%--
--%><input type=submit value=<%= UploaderUtils.quoteHTMLArg(lb.getLocalisedMessage("common.cat.findMore")) %>><%--
--%></form><%--
--%></p></center>
<%-- Insert linebreak for sanity of anyone reading the HTML...


GOOGLE SITE/WEB SEARCH
--%><% if(AdConsts.AD_SUPPORT) { %><%--
--%><%@ include file="/_cat/GoogleSiteSearch.inc.jsp" %><%--
--%><% } /* End Google search. */ %><%--


SHOW METADATA, IF ANY
Often very verbose (and possibly slow to fetch/format), so put it last.
Don't show this for the "lite" UI mode (nor spiders, to reduce SE "noise").
However, we put in a link to the XML "page" when not showing metadata in-line.
--%><%
    if(null == metaDataFuture)
        {
        %><p>Metadata <a href="<%= WebUtils.makeCatPageRRURL(exhibitName, WebConsts.F_secondary_generated_XML_suffix) %>">XML</a>.</p><%
        }
    else // if(null != metaDataFuture)
        {
        try
            {
            // If metadata text is not yet ready then flush page so far.
            if(!metaDataFuture.isDone()) { %><!--TP2--><% out.flush(); }

            // Get the HTML, if any...
            final String metadataHTML = metaDataFuture.get().toString();

            // Dump metadata HTML if there is any...
            if(!"".equals(metadataHTML))
                {
                if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to ignore metadata. */
                    {
%>
<!-- google_ad_section_start(weight=ignore) -->
<%
                    }

                %><h2>Metadata</h2><%
                %><a href="<%= WebUtils.makeCatPageRRURL(exhibitName, WebConsts.F_secondary_generated_XML_suffix) %>">XML</a><br><%
                %><%= metadataHTML %><%

                if(AdConsts.AD_SUPPORT) /* Ask Google Mediabot to ignore metadata. */
                    {
%>
<!-- google_ad_section_end -->
<%
                    }
                }
            }
        catch(final Throwable e) { e.printStackTrace(); }
        }
    %>
<%-- Insert linebreak for sanity of anyone reading the HTML...


Link to XHTML (mobile) page.
--%>
<p><a href="http://<%= VirtualHosts.VIRTUAL_HOST_SMLPX.normalisedName %><%= WebUtils.makeCatPageRRURL(exhibitName, WebConsts.F_secondary_generated_XHTML_suffix) %>">XHTML (mobile) --- <%= lb.getLocalisedMessage("common.cat.title") %></a></p>
<%--


Unless generating a "lite" page, show some AI stats...
--%><% if(!isLiteUI) { %><%--
--%><%
    try
        {
	    final StringBuilder sb = new StringBuilder(80);
	    sb.append("<h2>Content Scoring</h2>Content-based score prediction: ");
	    sb.append(dsb.getScorerCache().computeCompositeScoreAndConfidence(exhibitName, true));
	    // Only show this section if we collected (enough of) it without error.
	    %><%= sb %><%
	    }
	catch(final IOException e) { /* Absorb. */ }
	catch(final Throwable t) { t.printStackTrace(); /* Shouldn't happen. */ }
	%><%--
--%><% } %><%--


NOW COLLECT SOME STATS...
...since we've generated all the important page content
so any time here may well be hidden by network latency...
Try to ignore spiders/robots and lunatics and the author testing the site!  B^>
--%><%
    if(!probablySpider &&
       !WebUtils.isPrecacheRequest(request))
        {
        try
            {
            // Record the short exhibit name as an event...
            final SimpleVariableValue svv = new SimpleVariableValue(SystemVariables.ACCESSPATTERN_CAT_PAGE_VIEW,
                                                                    shortName);
            dsb.setVariable(svv);

            // Log info about potentially-valuable traffic sources...
            if(justArrived)
                {
                // If this is apparently an external referral
                // and if this cat page is in the current top-10 today
                // and if this has accumulated several hits already today
                // then log the (normalised) referring host.
                final EventVariableValue eventValue =
                    dsb.getEventValue(SystemVariables.ACCESSPATTERN_CAT_PAGE_VIEW,
                                      EventPeriod.VLONG,
                                      true);
                if((eventValue.getRank(shortName) < 10) &&
                   (eventValue.getCount(shortName) > 3))
                    {
//                    // Put a full record in the general local log...
//                    application.log("TOP referral to cat page for "+shortName+" from "+referringHost+ " full Referer: "+TextUtils.sanitiseForXML(request.getHeader("Referer"), 1024, true));
                    // Put a brief version in the global general stats...
                    final SimpleVariableValue svv2 = new SimpleVariableValue(SystemVariables.GENSTATS_STRING_GLOBAL_EVENT,
                                                                             "topCatPageRefHost="+referringHost);
                    dsb.setVariable(svv2);
                    }
                }
            }
        catch(final Throwable e) // Absorb any errors...
            {
            e.printStackTrace();
            }
        }
    %><%--





FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--

PERFORMANCE/PROFILING
--%><%
    // Dump/log performance details if measured and if too slow.
    // Dump/log to stderr (to get noticed) if page generation was (much) too slow.
    if(profileJSP && (null != perfMonitorThread))
        {
        final long bodyGenTime = (System.currentTimeMillis() - bodyGenStartTime);
        final boolean tooSlow = (bodyGenTime > CoreConsts.MAX_INTERACTIVE_DELAY_MS);
        final boolean muchTooSlow = tooSlow && (bodyGenTime > WebConsts.MAX_PG_DOWNLOAD_MS);      
        GenUtils.stopPerfMonitorandDumpSamples(
                    perfMonitorThread,
                    ("doHTML.jsp dump #"+serviceCount.incrementAndGet()+": body took "+bodyGenTime+"ms," +
                        " justArrived="+justArrived+
                        " shortName="+shortName),
                    perfCounts,
                    20,
                    (tooSlow ? (muchTooSlow ? GenUtils.systemErrLogger : new WebUtils.ServletLogger(application)) :
                        null)); // If timing is OK then don't log this sample anywhere...
        }
%>