<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%--Handles searches in the catalogue.
    Any simple text-based query arrives in the the parameter "q".
    This code is hand-in-glove with HTMLSearchBox.inc.jsp.
--%><%@ page
    contentType="text/html;charset=UTF-8"
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.svrCore.vars.*,
            org.hd.d.pg2k.webSvr.ads.*,
            org.hd.d.pg2k.webSvr.catalogue.*,
            org.hd.d.pg2k.svrCore.uploader.*"
    session="false"
    buffer="32kb" %><%-- As at 20030420 pages with no results are already about 16kBytes; with results around 24kBytes.
--%><%@ include file="/_common/_SetPageStartTime.inc.jsp" %><%-- Note start time if not already done for standard footer.
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- Get locale bean set up...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

--%><% final long bodyGenStartTime = System.currentTimeMillis(); %><%--

--%><% final DataSourceBean dsb = dataSource; %><%--

SET UP THE PAGINATION BEAN...
--%><% final PaginationBeanNumeric paginationBean = new PaginationBeanNumeric(); %><%--

SET UP THE SEARCH BEAN...
--%><jsp:useBean id="catPageBean"
             class="org.hd.d.pg2k.webSvr.catalogue.SearchPageJavaBean"
             scope="page"/><%-- Create the backing JavaBean, page scope.
<% final SearchPageJavaBean catPageBean = new SearchPageJavaBean(); %>
--%><% catPageBean.setAep(dsb.getAllExhibitProperties(-1L)); %><%-- Get the exhibit properties ASAP...
--%><jsp:setProperty name="catPageBean" property="*"/><%-- Set all the bean's parameters...
    Maximum number of attributes (starting at attributeWord0) to allow filtering by...
--%><%! private static final int MAX_ATTR_TO_FILTER = 10; %><%--
--%><%
// Fetch any attribute values available.
// Would like to do this with indexed/array properties but this is not portable...
final String rcvdAttrWords[] = new String[MAX_ATTR_TO_FILTER];
for(int i = MAX_ATTR_TO_FILTER; --i >= 0; )
    { rcvdAttrWords[i] = request.getParameter("attributeWord" + i); }
catPageBean.setAttributeWords(rcvdAttrWords);
// Make sure that any existing attributes are deduped before search/display.
catPageBean.dedupAttrs();

// We need to control cacheing carefully for these pages...
// Allow this page to be cached for a little while to allow BACK.
final int maxCacheSec = WebConsts.DEFAULT_PAGE_CACHE_MS/4;
response.setHeader("Cache-Control", "max-age=" + maxCacheSec);
response.setDateHeader("Expires", System.currentTimeMillis() + 1000*maxCacheSec);

// Max results per page.
final int MAX_PER_PAGE = WebConsts.MAX_RESULTS_PER_PAGE;
// Max pages.
final int MAX_PAGES = WebConsts.MAX_RESULTS_PAGES;

// Raw search results...
//final String searchResults[] = dsb.findExhibitsByWord(catPageBean.getQ(), 0, MAX_PER_PAGE * MAX_PAGES, catPageBean.getSearchFilter());
final String searchResults[] = catPageBean.doLookup(dsb, MAX_PER_PAGE * MAX_PAGES);

// Tell the pagination bean how many items we will be paginating...
paginationBean.setNumberOfItems(searchResults.length);
// And capture the user's requested page.
paginationBean.setPg(request.getParameter(WebConsts.PAGE_NUMBER_PARAMETER));

// Record the search time for later display.
pageContext.setAttribute(WebConsts.SEARCH_TIME_MS_ATTR_NAME, Long.valueOf(catPageBean.getLastSearchTimeMs()));

// Total pages.
final int totalPages = paginationBean.getNumberOfPages();

// This page, numbered from 1.
final int pageNum = paginationBean.getPg();


// Get access to basic exhibit data.
final AllExhibitImmutableData aeid = catPageBean.getAep().aeid;
%><%--


HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, localeBean.getLocalisedMessage("common.cat.searchtitle")); %><%--
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE, "[" + pageNum + " / " + totalPages + "]"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--
--%><% final boolean isBusy = siteIsBusy; %><%--


BODY STARTS...
--%><center><%-- Centre all but the footer text.


NOW TRY TO EMBED GOOGLE RESULTS IN THE PAGE, EARLY...
--%><% if(AdConsts.AD_SUPPORT) { %><%--
--%>
<!-- Google Search Result Snippet Begins -->
<div id="googleSearchUnitIframe"></div>

<script type="text/javascript">
   var googleSearchIframeName = 'googleSearchUnitIframe';
   var googleSearchFrameWidth = 700;
   var googleSearchFrameHeight = 1500;
   var googleSearchFrameborder = 0 ;
   var googleSearchDomain = 'www.google.co.uk';
</script>
<script type="text/javascript"
         src="http://www.google.com/afsonline/show_afs_search.js">
</script>
<!-- Google Search Result Snippet Ends -->
<%--
--%><% } /* End embedded Google search results. */ %><%--


FORM STARTS...
--%><form method=<%= WebConsts.SEARCH_FORM_METHOD %> action="/_cat/doHTMLSearch.jsp"><%--


SEARCH BOX
--%><% pageContext.setAttribute("searchNoFormTag", "64"); %><%--
--%><% pageContext.setAttribute("searchBoxWidth", "64"); %><%--
--%><p><font size="-1"><%@ include file="HTMLSearchBox.inc.jsp" %></font></p><%--
--%><% pageContext.removeAttribute("searchBoxWidth"); %><%--


ADVANCED SELECTION ITEMS
--%><p><table border=1><tr><th colspan=2><%= localeBean.getLocalisedMessage("common.cat.AdvancedSearch") %></th></tr><%--
CATEGORY SELECTION
--%><tr><%--
--%><td colspan=2><%= localeBean.getLocalisedMessage("common.cat.category") %>: <select name=category><%--
--%><%= catPageBean.makeCategorySelectBody(localeBean) %><%--
--%></select></td><%--
--%></tr><%--
AUTHOR SELECTION
--%><tr><%--
--%><td colspan=2><%= localeBean.getLocalisedMessage("common.cat.author") %>: <select name=author><%--
--%><%= catPageBean.makeAuthorSelectBody() %><%--
--%></select></td><%--
--%></tr><%--
SUFFIX SELECTION
--%><tr><%--
--%><td colspan=2><%= localeBean.getLocalisedMessage("common.cat.type") %>: <select name=suffix><%--
--%><%= catPageBean.makeSuffixSelectBody() %><%--
--%></select></td><%--
--%></tr><%--
ATTRIBUTE FILTERING
    Minimum number of blank slots to show (until ceiling is reached)...
--%><%! private static final int MIN_EXCESS_BLANK_ATTR_FILTERS = 2; %><%--
--%><%
final List attrs = catPageBean.getAttributeWordsAsList();
final int nAttrs= attrs.size();
// Always show as many attributes as there are as a minimum,
// plus some blank slots for new filter attributes until the maximum is reached.
final int attrsToShow = Math.max(nAttrs,
    Math.min(MAX_ATTR_TO_FILTER, nAttrs + MIN_EXCESS_BLANK_ATTR_FILTERS));
final Iterator aIt = attrs.iterator();
for(int i = 0; i < attrsToShow; ++i)
    {
    final String nextAttr = (i < nAttrs) ?
        ((String) aIt.next()) : ExhibitHandlerBeanBase.SETTER_ALL;
    %><%--
--%><tr><%--
--%><td colspan=2><%= localeBean.getLocalisedMessage("common.cat.attr") %>: <select name="attributeWord<%= i %>"><%--
--%><%= catPageBean.makeAttributeSelectBody(true, nextAttr, localeBean) %><%--
--%></select></td><%--
--%></tr><%--
--%><%
    }
%><%--
RECENT-DAYS SELECTION
<tr>
<td colspan=2><%= localeBean.getLocalisedMessage("common.cat.filtersince.recent") %>: <select name=recentDaysFilter>
<%= catPageBean.makeRecentDaysFilterBody(localeBean) %>
</select></td>
</tr>
End of table...
--%></table></p><%--

(extra) SEARCH BUTTON
--%><p><input type=submit value=<%= UploaderUtils.quoteHTMLArg(localeBean.getLocalisedMessage("common.cat.search")) %>></p><%--


SEPARATOR
--%><hr width="30%"><%--


FLUSH OUTPUT so far if taking a while....
--%><% if(!isBusy || (System.currentTimeMillis() - bodyGenStartTime > WebConsts.MAX_PG_DOWNLOAD_MS/2)) { out.flush(); } %><%--


OTHER PAGES BUTTONS (top copy)
<p><%@ include file="/_common/_HTMLPageButtons.inc.jsp" %></p>


RESULTS TABLE
--%><% { // Scope our variables.
final int MAX_TO_SHOW = MAX_PER_PAGE;
final int firstPos = (pageNum-1) * MAX_PER_PAGE;
// Build the search-result HTML.
%><p><%@ include file="/_cat/HTMLSearchResults.inc.jsp" %></p><%--
--%><% } %><%--


OTHER PAGES BUTTONS (bottom copy: keep in sync with top)
--%><p><%@ include file="/_common/_HTMLPageButtons.inc.jsp" %></p><%--


FORM ENDS...
--%></form><%--


INSERT OPTIONAL AD
Show mainly CPM ads here since decent traffic...
--%><% final boolean showingAds = AdUtils.showAds(dataSource, request); %><%--
--%><% if(showingAds) { %><%--
--%><% if(!isBusy || (System.currentTimeMillis() - bodyGenStartTime > WebConsts.MAX_PG_DOWNLOAD_MS/2)) { out.flush(); } %><%--

--%><% final int midpageAdSlotNumber = (int) (System.currentTimeMillis() / (11 * 60 * 1000L)); %><%--
--%><% switch(midpageAdSlotNumber % 3) { %><%--

--%><% case 0: if(AdConsts.ENABLE_TRIBALFUSION) { %><%--
--%><% final int rndID = (Rnd.fastRnd.nextInt() >>> 1); %><%--
--%><p align=center><!-- TF 336x280 IFrame VAR code -->
<iframe src="http://a.tribalfusion.com/f.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&type=var&requestID=1274628298" width=336 height=280 marginwidth=0 marginheight=0 hspace=0 vspace=0 frameborder=0 scrolling=no allowTransparency=true>
         <script language=javascript><!--
           randNum = ((new Date()).getTime() % 2147483648) + Math.random();
           document.write(
             "<a href='http://a.tribalfusion.com/i.click?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=" + randNum + "' target=_blank>" +
             "<img src='http://a.tribalfusion.com/i.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=" + randNum + "'" +
               " width=336 height=280 border=0 alt='Click Here'></a>");
         // --></script>
         <noscript>
             <a href="http://a.tribalfusion.com/i.click?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=1274628298" target=_blank>
             <img src="http://a.tribalfusion.com/i.ad?site=DHDMultimediaGallery&adSpace=ROS&size=336x280&requestID=1274628298"
                  width=336 height=280 border=0 alt="Click Here"></a>
         </noscript>
</iframe>
<!-- TF 336x280 IFrame VAR code -->
</p><%--
--%><% } break; %><%--

--%><% case 1: if(AdConsts.ENABLE_CASALEMEDIA) { %><%--
--%><% final int rndID = (Rnd.fastRnd.nextInt() >>> 1); %><%--
--%><p align=center>
<!-- Casale Media 2005 (C) -->
<!-- Ad Format: Medium Rectangle -->
<!-- Domain(s): hd.org -->
<script language="Javascript"><!--
var d=new Date();var r=(d.getTime()%8673806982)+Math.random();var uu=escape(window.location.href);
var wh='" width="300" height="250" ';var host='.casalemedia.com/';var dc=document;
var fr='marginwidth="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
dc.write('<ifr'+'ame src="http://as'+host+'s?s=68148&u='+uu+'&f=4&id='+r+wh+fr);
dc.write('<a hr'+'ef="http://c'+host+'c?s=68148&f=4&id='+r+'" target="_blank">');
dc.write('<i'+'mg src="http://as'+host+'s?s=68148&u='+uu+'&f=4&id='+r+'&if=0'+wh+'border="0"></a></ifr'+'ame>');
//--></script><noscript><iframe src="http://as.casalemedia.com/s?s=68148&u=http%3A%2F%2Fhd.org&f=4&id=1"
width="300" height="250" marginwidth="0" hspace="0" vspace="0" frameborder="0" scrolling="no"><a
href="http://c.casalemedia.com/c?s=68148&f=4&id=<%= rndID %>" target="_blank"><img
src="http://as.casalemedia.com/s?s=68148&u=http%3A%2F%2Fhd.org&f=4&id=<%= rndID %>&if=0" width="300"
height="250" border="0"></a></iframe></noscript>
<!-- Casale Media 2005 (C) -->
</p><%--
--%><% break; } %><%--


--%><% default: %><%-- MidPageSquare gets 3x better CTR than MidPage, so run in all otherwise-unallocated slots...
--%><p align=center><script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html"; // Collapse if no ad...
google_ad_width = 300;
google_ad_height = 250;
google_ad_format = "300x250_as";
google_ad_channel ="9645554882";<%-- MidPageSquare... --%>
google_color_link = ["FFFFFF","000000","000080"];
google_color_url = ["FF6600","666666","008000"];
google_color_border = ["003366","CCCCCC","333366"];
google_color_bg = ["000000","FFFFFF","FFFFFF"];
google_color_text = ["FF6600","333333","000000"];
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script></p><%--
--%><% break; %><%--
--%><% } %><%-- End switch by ad type...
<%-- Insert linebreak for sanity of anyone reading the HTML...
--%><% } %><%-- End showingAds...


GOOGLE SITE/WEB SEARCH
--%><% if(AdConsts.AD_SUPPORT) { %><%--
--%><%@ include file="/_cat/GoogleSiteSearch.inc.jsp" %><%--
--%><% } /* End Google search. */ %><%--


NOTE THE VISIT TO THE SEARCH PAGE
--%><%
    // Note the visit to the search page.
    dsb.setVariable(new SimpleVariableValue(SystemVariables.GENSTATS_STRING_GLOBAL_EVENT,
                                                   "SearchPageView"));
    // Log any search words/term used, canonicalised.
    final String canonQ = catPageBean.getQ();
    if(!"".equals(canonQ))
        {
        dsb.setVariable(new SimpleVariableValue(SystemVariables.GENSTATS_STRING_GLOBAL_EVENT,
                                                       "SearchTerm=" + canonQ));
        }
    %><%--

FOOTER
--%></center><%--
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>
