<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

BASE NODE for virtual "SmlPx.mobi" site.

--%><%@ page
    import="org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.exhibit.*,
            java.io.*"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...
--%><%@ include file="/_common/_FullSortedExhibitSetBean.inc.jsp" %><%-- Get sorted-exhibits bean...


--%><% final DataSourceBean dsb = dataSource; %><%--

SET UP THE SEARCH BEAN...
--%><jsp:useBean id="catPageBean"
             class="org.hd.d.pg2k.webSvr.catalogue.SearchPageJavaBean"
             scope="page"/><%-- Create the backing JavaBean, page scope.
<% final SearchPageJavaBean catPageBean = new SearchPageJavaBean(); %>
--%><% catPageBean.setAep(dsb.getAllExhibitProperties(-1L)); %><%-- Get the exhibit properties ASAP...
--%><jsp:setProperty name="catPageBean" property="*"/><%-- Set all the bean's parameters...
    Maximum number of attributes (starting at attributeWord0) to allow filtering by...
--%><%! private static final int MAX_ATTR_TO_FILTER = 10; %><%--
--%><%
// Fetch any attribute values available.
// Would like to do this with indexed/array properties but this is not portable...
final String rcvdAttrWords[] = new String[MAX_ATTR_TO_FILTER];
for(int i = MAX_ATTR_TO_FILTER; --i >= 0; )
    { rcvdAttrWords[i] = request.getParameter("attributeWord" + i); }
catPageBean.setAttributeWords(rcvdAttrWords);
// Make sure that any existing attributes are deduped before search/display.
catPageBean.dedupAttrs();

// We need to control cacheing carefully for these pages...
// Allow this page to be cached for a while to allow BACK.
final int maxCacheSec = CoreConsts.DEFAULT_TEMPORAL_SLACKNESS_S;
response.setHeader("Cache-Control", "max-age=" + maxCacheSec);
response.setDateHeader("Expires", System.currentTimeMillis() + 1000*maxCacheSec);

// Max results per page: fewer than for a non-mobile device.
final int MAX_PER_PAGE = WebConsts.MAX_RESULTS_PER_PAGE / 2;
// Max pages: fewer than for a non-mobile device.
final int MAX_PAGES = Math.min(10, WebConsts.MAX_RESULTS_PAGES);

// Raw search results...
final String searchResults[] = catPageBean.doLookup(dsb, MAX_PER_PAGE * MAX_PAGES);

// Number of pages and maximum page number.
final int numPages = (searchResults.length + (MAX_PER_PAGE-1)) / MAX_PER_PAGE;
final int maxPageNum = Math.max(1, numPages);

// Get access to basic exhibit data.
final AllExhibitImmutableData aeid = catPageBean.getAep().aeid;

// This page, numbered from 1.
final Object pageNumO = request.getParameter(WebConsts.PAGE_NUMBER_PARAMETER);
int pageNum = 1;
if(pageNumO instanceof String)
	{
	try { pageNum = Math.max(1, Math.min(maxPageNum, Integer.parseInt((String) pageNumO, 10))); }
	catch(final NumberFormatException e) { /* Ignore... */ }
	}
%><%--

HEADER

PREV and NEXT links
--%><%
if(numPages > 1)
	{
	// Make prev/next links with critical parameters embedded.
	if(pageNum > 1)
	    { pageContext.setAttribute("prev", "/_cat/doXHTMLSearch.jsp" + catPageBean.computeGETQueryStringURLTail(pageNum-1)); }
	if(pageNum < numPages)
	    { pageContext.setAttribute("next", "/_cat/doXHTMLSearch.jsp" + catPageBean.computeGETQueryStringURLTail(pageNum+1)); }
    }
%><%--
Leave title at site default: just set subtitle...
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE, "Search Results ["+pageNum+"/"+numPages+"]"); %><%--
--%><%@ include file="/_common/_XHTMLStdHd.inc.jsp" %><%--


BODY/CONTENT

RESULTS TABLE
--%><% { // Scope our variables.
final int MAX_TO_SHOW = MAX_PER_PAGE;
final int firstPos = (pageNum-1) * MAX_PER_PAGE;
// Build the search-result XHTML.
%><%@ include file="/_cat/XHTMLSearchResults.inc.jsp" %><%--
--%><% } %><%--

<%--


FOOTER
--%><%@ include file="/_common/_XHTMLStdFt.inc.jsp" %>
