<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--
    Creates the FullSortedExhibitSet FilterBean,
    a non-memory sensitive cache of all exhibits
    sorted in fully-smart order at application scope.

    This can be safely shared by many pages,
    so long as they always call the one-argument select(),
    eg don't try to pass in a non-standard list of items.

    Expects to find dataSource bean in scope.

--%><%@ page import="org.hd.d.pg2k.svrCore.AllExhibitProperties,
                 java.util.Comparator,
                 org.hd.d.pg2k.webSvr.exhibit.*"%>
<%
    %><%--
--%><jsp:useBean id="FullSortedExhibitSet"
             class="org.hd.d.pg2k.webSvr.exhibit.FilterBean"
             scope="application"><%--
    --%><%
    FullSortedExhibitSet.setMemorySensitiveCache(false); // Hold onto this data.

    // We want this list sorted by ``smart'' order for easier human use!
    //
    // We rely on sortByName to use the latest version of the SMART_SORT
    // so that it is always in sync with the data.
    //
    // There is a small chance of a race here with data use in the page,
    // but it should only last for a very short time.
    //
    // It is slightly wasteful for us to generate a new sorter each time.
    FullSortedExhibitSet.setExpr(new SortExpr(null,
        new BuiltInFilters.sortByName(BuiltInFilters.sortByName.SMART)));
    %><%--
--%></jsp:useBean>