<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%--Displays buttons to got to other pages in paginated output.

    To be embedded in a form.

    Expects to find the following (Java) variables defined:

      * paginationBean (in page scope).

      * localeBean (in request scope).

    If there would be a huge number of pages then this ensures
    that at most WebConsts.MAX_RESULTS_PAGES buttons are shown,
    including the first and last and the current page and items either side.

    If any of the labels are long,
    probably indicating a very heterogenous list,
    this switches to a one-off SELECT format rather than all buttons.

--%><%@ page import="org.hd.d.pg2k.webSvr.util.*,
                     java.util.*,
                     org.hd.d.pg2k.webSvr.catalogue.PaginationBeanTree,
                     org.hd.d.pg2k.svrCore.uploader.UploaderUtils"%><%--


OTHER PAGES BUTTONS/SELECT
--%><%
    { // Local scope for any variables we introduce.

    final int _pageNum_ = paginationBean.getPg();
    final int _totalPages_ = paginationBean.getNumberOfPages();

    // Get list of page-button labels.
    final List<String> _labels_ = paginationBean.getPageLabels();
    final int _pgNums_[] = paginationBean.getPageNumbers();

    // Get current page label if any and if available.
    final String _currentPg = request.getParameter(WebConsts.PAGE_NUMBER_PARAMETER);

    // Maximum length of any button label before we switch to SELECT format.
    final int _buttonLabelLengthLimit = PaginationBeanTree.LABEL_MIN_LEN+1;
    // Choose SELECT format if any label is over-length for a button
    // and would possibly make the buttons wrap over multiple lines...
//    // However, don't use select if one already used.
//    final String PNAME_ALREADY_USED_SELECT = ".pg.select.already.used.";
//    final boolean _pgSelectAlreadyUsed_ = (null != pageContext.getAttribute(PNAME_ALREADY_USED_SELECT));
    boolean _useSELECT = false;
//    if(!_pgSelectAlreadyUsed_)
        {
        for(final String label : _labels_)
            {
            if(label.length() > _buttonLabelLengthLimit)
                { _useSELECT = true; break; }
            }
        }

    if(_useSELECT)
        { %> <select name=<%=WebConsts.PAGE_NUMBER_PARAMETER%> onChange="this.form.submit();"><% }
    // Do a previous-page button if possible.
    else if(_pageNum_ > 1)
        {
        %><input type=submit name=<%=WebConsts.PAGE_NUMBER_PARAMETER%> value=<%= UploaderUtils.quoteHTMLArg(paginationBean.getPageLabel(_pageNum_-1)) %>>&lt;<%= localeBean.getLocalisedMessage("common.prev") %> <%
        }

    // Now iterate over the desired pages...
//    // (if not second-or-later oversize label collection on this page)
//    if(!_pgSelectAlreadyUsed_)
        {
        int _pgIndex_ = 0;
        for(final Iterator<String> _pgIt_ = _labels_.iterator(); _pgIt_.hasNext(); ++_pgIndex_)
            {
            // If pages are not contigious, insert elipsis/separator.
            if((_pgIndex_ > 0) && (_pgNums_[_pgIndex_] > _pgNums_[_pgIndex_ - 1] + 1))
                { if(_useSELECT) { %><option disabled="disabled">+</option><% } else { %>+ <% } }

            // Insert the button/option.
            final String _pgNum_ = _pgIt_.next();
            if(_useSELECT)
                {
                %><option value=<%= UploaderUtils.quoteHTMLArg(_pgNum_) %><%
                if(_pgNum_.equals(_currentPg)) { %> selected="selected"<% }
                %>><%= _pgNum_ %>...</option><%
                }
            else
                {
                %><input type=submit name=<%=WebConsts.PAGE_NUMBER_PARAMETER%> value=<%= UploaderUtils.quoteHTMLArg(_pgNum_) %>><%
                }
            }
        }

    if(_useSELECT)
        { %></select><input type=submit name=Go value=Go> <% }
    // Do a next-page button if possible.
    else if(_pageNum_ < _totalPages_)
        {
        %> <%= localeBean.getLocalisedMessage("common.next") %>&gt;<input type=submit name=<%=WebConsts.PAGE_NUMBER_PARAMETER%> value=<%= UploaderUtils.quoteHTMLArg(paginationBean.getPageLabel(_pageNum_+1)) %>><%
        }

//    // Disallow further page selects on this page.
//    if(_useSELECT)
//        { pageContext.setAttribute(PNAME_ALREADY_USED_SELECT, Boolean.TRUE); }
    }
%>
