<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%

    // Flush any spurious leading whitespace/rubbish accumulated to now.
    // Marginally reduces output size and is marginally more conformant.
    // We don't clear any headers or status code.
    response.resetBuffer();
    out.clearBuffer();

    // SET CONTENT_TYPE to include the charset.
    response.setContentType("text/html;charset=" + localeBean.getLocalisedMessage("common.charset"));

%><%--

PUT IN DECLARATION OF HTML CONFORMANCE FOLLOWED BY LINE BREAK
--%><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%--

     Standard page-header-generator for HTML pages.

     May come in high-graphics and low-graphics modes,
     and my be parameterised per-virtual-site in terms of the "skin" used.

     Assumes that the matching standard footer will be used.

     The page this is included in should have set:
         contentType="text/html;charset=UTF-8"
     which is safe for real UTF-8 output and the plain-ASCII
     with possible HTML entity markup that we call ISO-8859-1.

     This expects to find the following beans available:
       * localeBean (JavaBean)
       * dataSource (JavaBean)

     This sets up the following variables:
       * clientIsSpider (boolean): true if our caller seems to be a spider
       * siteIsBusy (boolean): true if our site seems to be very busy

     This looks for the following page-level attributes and uses them
     if set:
       * title (String): short, HTML-safe, main title of page
       * subTitle (String): short, HTML-safe, sub-title of page (ignored if title not set)
       * prev (String): root-relative URL to ``previous'' page.
       * next (String): root-relative URL to ``next'' page.
       * breadcrumbs (Breadcrumbs): list of text x link pairs.

     We supply standard, spider-sensitive values for the following headers:
       * Cache-control
       * Expires
       * ETag (based on AEP hash)
       * Last-Modified* (based on AEP timestamp)
     unless they have already been set.

     We will set the (synthetic) Last-Modified date
     iff none of the cache headers was set.
     In this case we'll also act on an If-Modified-Since header if present.


     This opens the the HTML page,
     (with meta headers if the system is not busy and the client seems to
     be a spider)
     opens a centered table in which the various titles are deposited,
     and opens a single cell for the page body.

--%><%@ page
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
            org.hd.d.pg2k.webSvr.ads.AdUtils"
%><%
    // Set up a very few variables/headers common to all/most skins.

    // In particular, we don't want to to have to waste time when busy
    // repeatedly/redundantly/expensively finding out that we are busy,
    // so this siteIsBusy value is made available here.
    final boolean siteIsBusy = WebUtils.isOverloaded(application);
    // See if the client is likely a spider/bot.
    final boolean clientIsSpider = WebUtils.requestProbablyFromSpider(request);

    // Set up default HTTP cache headers.
    %><%@ include file="/_common/_HTTPStdCacheHdrs.inc.jsp" %><%
    
    // If this is a HEAD, stop here to save time and effort,
    // as we should have set most of the headers that we are going to.
    // If output is not already committed then we discard any accumulated so far.
    // Without this, for example, Tomcat 4.1.x returns the body,
    // which wastes bandwidth and violates the HTTP spec.
    if("HEAD".equalsIgnoreCase(request.getMethod()))
        {
        if(!response.isCommitted())
            {
            response.resetBuffer();
            out.clearBuffer();
            }
        return;
        }
    

    // Set up virtual host selector.
    final VirtualHosts.VirtualHost vHost =
        VirtualHosts.getVirtualHostDetails(request.getServerName(),
                                           request.getRequestURI());
    final String skinName = (vHost == null) ? null : vHost.skin;

    // For recording any click-throughs against, defaults to null.
    String layoutName = null;


    // Choose header skin type: logic must match that for footer.

    // Is this "black minimal" skin?
    if(VirtualHosts.SKIN_BLACK_MINIMAL.equals(skinName))
        { %><%@ include file="/_common/skins/blackMin.hd.inc.jsp" %><% }

    // Else fall through to default skin.
    else
        { %><%@ include file="/_common/skins/default.hd.inc.jsp" %><% }

%>