<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%@ page import="org.hd.d.pg2k.webSvr.util.*,
                     org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
                     org.hd.d.pg2k.webSvr.exhibit.DataSourceBean,
                     org.hd.d.pg2k.webSvr.util.*,
                     org.hd.d.pg2k.svrCore.vars.*,
                     org.hd.d.pg2k.svrCore.*,
                     org.hd.d.tmf.ThroughputMonitorFilterBase"
%><%--
     Standard footer for HTML pages.

     Assumes that the matching standard header has been used
     and that all the variables that it set up are available.

     This expects to be able to use:
       * localeBean
       * pageStartTime
       * vHost

     Selects the appropriate footer based on the VirtualHost.


CLOSE CONTENT DIV...
--%>
    </div>
<% } catch(final Exception e) { e.printStackTrace(); /* Catch/log common transient exceptions in the content div... */ } %>

<%-- POPULAR EXHIBITS (as links) --%>
<%
// Default to wider-than-normal (240px) screen vs default 120px wide.
// We aim to simply truncate over-long lines with CSS, though wrapping is not horrible.

final String links = HTMLThumbnailInsertGenerators.popularUsefulLinksNarrowCol(dataSource, 60, 240, true);
if(links.length() > 0) {
%>
    <div class="links">
        <h2><%= localeBean.getLocalisedMessage("common.tower.Popular") %></h2><%= links %>
    </div>
<% } %>

<%-- SEARCH BOX (form) --%>
    <div class="footer"><%@ include file="/_cat/XHTMLSearchBox.inc.jsp" %></div>

<%-- FOOTER DIV AND THEN END HTML... --%>
    <div class="footer">
       <small>
         <%-- NEXT (accesskey 8; repeated from header) --%><% if(_nextO instanceof String) { %> [<a href="<%= _nextO %>" accesskey="8"><%= localeBean.getLocalisedMessage("common.next") %>&gt;</a>:8]<br /><% } %>

         Content from [<a href="http://gallery.hd.org/" accesskey="9">gallery.hd.org</a>:9], site &copy; Damon Hart-Davis.
<%--

SHOW SYSTEM LOAD and other flags/stats
--%><%
    final String mirrorTag = LocalProps.getMirrorTag();

    // Get estimated system-wide number of users.
    final SimpleNumberStats uStats = (VarTools.generateSimpleNumberStats(dataSource,
                    SystemVariables.ThroughputMonitorFilter_STICKY_CLIENT_COUNT,
                    10 * 60 * 1000, // Max age about 10 minutes...
                    "#u"));
    // Show number of users (if value is available) as NNNu.
    // Assume that if uStats is not null then getSum() callong be either.
    final String nUsersS = ((uStats != null) && (uStats.getSum() != null)) ?
            (String.valueOf(uStats.getSum().intValue()) + "u ") : ("");

	final long pageStartTime = ((java.util.Date) request.getAttribute(org.hd.d.pg2k.webSvr.util.WebConsts.REQUEST_START_DATETIME_ATTR_NAME)).getTime(); /* Compute at last possible moment... */
	final long pageEndTime = System.currentTimeMillis(); /* Compute at last possible moment... */
	%><%--

optional mirror tag
optional new-user flag "n"
optional busy flag "*"
optional number of users "[NNu]"
optional load %
optional page generation/search time in ms...
--%>(<%--
--%><% if(null != mirrorTag) { %><%= mirrorTag %> <% } %><%--
--%><%= (null != request.getAttribute(ThroughputMonitorFilterBase.REQ_ATTR_NAME_NEW_CLIENT_FLAG)) ? ("n") : "" %><%--
--%><%= siteIsBusy /* Don't incur the cost of another call. */ ? "*" : "" %><%--
--%><%= nUsersS %><%= pageEndTime-pageStartTime %>ms<%--
--%>)<%--


CONVERSION TRACKING CODE for AdSense.
--%><% if(Boolean.TRUE.equals(request.getAttribute(ThroughputMonitorFilterBase.REQ_ATTR_NAME_NEW_CLIENT_FLAG))) { %><%--
--%><img height="1" width="1" src="http://www.googleadservices.com/pagead/conversion/1070497197/?value=1&amp;label=Default&amp;script=0" /><%--
--%><% application.log("[Tracking inserted for XHTML/mobile client "+request.getRemoteAddr()+".]");  %><%--
--%><% } %><%--


--%>
       </small>
    </div>

    <%-- 
      The following div element provides an easy way to check this web
      page against the XHTML-MP and CSS validators.
    <div style="margin-top: 10px;">
      <a href="http://validator.w3.org/check?uri=referer">
        <img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML-MP" height="31" width="88" />
      </a>
      <a href="http://jigsaw.w3.org/css-validator/check/referer">
        <img src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS" height="31" width="88" />
      </a>
    </div>
    --%>
  </body>
</html>