<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%

    // Flush any spurious leading whitespace/rubbish accumulated to now.
    // Marginally reduces output size and is marginally more conformant.
    // We don't clear any headers or status code.
    response.resetBuffer();
    out.clearBuffer();

    // SET CONTENT_TYPE to include the charset.
    response.setContentType("application/xhtml+xml;charset=" + localeBean.getLocalisedMessage("common.charset"));

    // MAXIMUM DYNAMICALLY-ASSIGNABLE ACCESS KEY VALUE
    // Other values are reserved for use by this template.
    final int MAX_AK = 6;

    // Next available access key value (starts at 1, not 0: 0 is reserved).
    // Should be incremented after an access key has been assigned;
    // should not be used if already beyond MAX_AK.
    int nextAccessKeyValue = 1;
%><%--

PUT IN XML DECLARATION THEN DECLARATION OF HTML CONFORMANCE FOLLOWED BY LINE BREAK
--%><?xml version="1.0" encoding="<%= localeBean.getLocalisedMessage("common.charset") %>"?>
<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">
<%--

     Standard page-header-generator for XHTML pages.

     May come in high-graphics and low-graphics modes,
     and may be parameterised per-virtual-site in terms of the "skin" used.

     Assumes that the matching standard footer will be used.

     This expects to find the following beans available:
       * localeBean (JavaBean)
       * dataSource (JavaBean)

     This sets up the following variables:
       * clientIsSpider (boolean): true if our caller seems to be a spider
       * siteIsBusy (boolean): true if our site seems to be very busy

     This looks for the following page-level attributes and uses them
     if set:
       * title (String): short, HTML-safe, main title of page
       * subTitle (String): short, HTML-safe, sub-title of page (ignored if title not set)
       * prev (String): root-relative URL to ``previous'' page.
       * next (String): root-relative URL to ``next'' page.

     We supply standard, spider-sensitive values for the following headers:
       * Cache-control
       * Expires
       * ETag (based on AEP hash)
     unless they have already been set.


     This opens the the HTML page,
     (with meta headers if the system is not busy and the client seems to
     be a spider)
     opens a centered table in which the various titles are deposited,
     and opens a single cell for the page body.

--%><%@ page
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.virtualHosts.VirtualHosts,
            org.hd.d.pg2k.webSvr.ads.AdUtils"
%><%--
--%><%@ include file="/_common/_SetPageStartTime.inc.jsp" %><%-- Note start time if not already done for standard footer.
--%><%
    // Set up a very few variables/headers common to all/most skins.

    // In particular, we don't want to to have to waste time when busy
    // repeatedly/redundantly/expensively finding out that we are busy,
    // so this siteIsBusy value is made available here.
    final boolean siteIsBusy = WebUtils.isOverloaded(application);

    // Beware of bad bots eating all our CPU and disc bandwidth.
    final boolean clientIsSpider = WebUtils.requestProbablyFromSpider(request);

    // Set up virtual host selector.
    final VirtualHosts.VirtualHost vHost =
        VirtualHosts.getVirtualHostDetails(request.getServerName(),
                                           request.getRequestURI());
    final String skinName = (vHost == null) ? null : vHost.skin;

    // For recording any click-throughs against, defaults to null.
    String layoutName = null;

    // Proxies need to know that we may vary the output depending on device capabilities.
    // Ads (and some other features) may depend on the User-Agent.
    response.addHeader("Vary", "Accept");
    response.addHeader("Vary", "User-Agent");

	// SET CACHE PARAMETERS (only if not already set)
    %><%@ include file="/_common/_HTTPStdCacheHdrs.inc.jsp" %><%

	// Collect any parameters passed to us from the calling page.
	final Object titleO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE);
	final Object subtitleO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE);

	// Get the prev/next values, if any.
	final Object _prevO = pageContext.getAttribute("prev");
	final Object _nextO = pageContext.getAttribute("next");

%><html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>SmlPx<% if(titleO instanceof String) { %>: <%= titleO %><% } %><%--
           --%><%= (subtitleO instanceof String ? (": " + subtitleO) : "") %></title>
    <style type="text/css">
        .header { background: #ffffcc; color: navy; }
        .footer { background: #ffffcc; color: navy; }
        .ad { background: #ccffff; color: black; }
        .links { background: #ccffff; color: black; text-overflow: clip; }
    </style>
<%--    
INSERT URL-SPECIFIC (META) TAGS ON DEMAND
This allows use to to drop in custom text per-page easily
for such things as Google site-ownership verification.
--%><%
    final String customTag = dataSource.getGenProps(-1).getGen().get(request.getRequestURL().insert(0, WebConsts.GP_HEAD_TAG_INSERT_KEY_PREFIX).toString());
    if(null != customTag) { %><%= customTag %><% }
    %>

  </head>
  <body>
    <div class="header">
        <small>
		<%-- HOME link (defaults to XHTML/mobile entry point) --%><% final String homeURL = ((vHost == null) || (vHost.virtualRootDir == null)) ? WebConsts.VIRTUAL_SITE_CUST_SMLPX_ROOT : vHost.virtualRootDir; %>
		    <a href="<%= homeURL %>"><%= localeBean.getLocalisedMessage("org.hd.pg2k.Home") %></a>
		<%-- RANDOM EXHIBIT link (with cache-buster rnd parameter) --%><a href="/_cat/doHTMLRandom.jsp?suffix=.xhtml&amp;rnd=<%= Integer.toString(Rnd.fastRnd.nextInt() >>> 1, Character.MAX_RADIX) %>"><%= localeBean.getLocalisedMessage("common.random") %></a>
		<%-- I18N selection --%><%@ include file="/_common/_HTMLStdHdLocalePrompt.inc.jsp" %>
        </small><br />

        <%-- TITLE (not small) --%><span style="font-weight: bold; color: navy;"><%= (titleO instanceof String ? TextUtils.sanitiseForXML((String) titleO, 48, true) : "SmlPx") %></span><br />
        <small>
            <%-- PREV (accesskey 7) --%><% if(_prevO instanceof String) { %>[<a href="<%= _prevO %>" accesskey="7">&lt;<%= localeBean.getLocalisedMessage("common.prev") %></a>:7] <% } %>
        <%-- SUBTITLE --%><% if(subtitleO instanceof String) { %><span style="font-weight: bold; color: navy;"><%= TextUtils.sanitiseForXML((String) subtitleO, 64, true) %></span><% } %>
            <%-- NEXT (accesskey 8; repeated in footer) --%><% if(_nextO instanceof String) { %> [<a href="<%= _nextO %>" accesskey="8"><%= localeBean.getLocalisedMessage("common.next") %>&gt;</a>:8]<% } %>
        </small>
    </div>

<%-- FLUSH header so far (eg because the ad may be slow to fetch) --%><% out.flush(); %>
<% final boolean showAds = AdUtils.showAds(dataSource, request); %>
<% if(showAds) { %>
    <div class="ad">
        <%-- AD --%><%@ include file="/_mon/ads/_AdMobXHTML.inc.jsp" %>
    </div>
<% } %>

<% try { /* Catch common transient exceptions in the content div... */ %>
<%-- START THE CONTENT DIV... --%>
    <div class="content">