<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

    "black minimal" SKIN header.

    Black background: title if set.

--%><%@ page
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.svrCore.uploader.UploaderUtils"
    %><%--


--%><%

// Helps us construct titles later...
final Object _titleO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE);
final String _title = (_titleO instanceof String) ? ((String) _titleO) : null;

// Set a non-default alternate background colour to match the body tag below.
PageSkinUtils.setAltBgColour(pageContext, "#000066"); // Dark blue.

%><%--

START THE HTML AND BODY
--%><html>
<head>
<%= ((_title == null) || (_title.length() == 0)) ? "" : ("<title>" + _title + "</title>") %>
<%
// If asking SEs not not index possibly-low-unique-content pages,
// then insert the appropriate robot meta header tag here.
if(WebConsts.USE_NOINDEX_ON_LOW_CONTENT_PAGES &&
   (null != request.getAttribute(WebConsts.STDHDR_ATTR_NAME_NOINDEX)))
    { %><meta name="robots" content="noindex"><% }
%>
<%
    // Insert meta headers if available.
    // Since "min" pages are likely to be sparse these may be really helpful.

    // Get page-specific keywords, if any.
    final Object _keywordsO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_KEYWORDS);
    final String _keywords = (_keywordsO instanceof String) ? ((String) _keywordsO).trim() : null;
    // Check that the specific keywords are present and "safe".
    final boolean keywordsOK = (_keywords != null) && (_keywords.length() > 1) && (_keywords.indexOf('<') == -1);
    if(keywordsOK)
        { %><meta name=keywords content="<%= _keywords %>"><% }
    else
        {
        // Get generic meta keywords and description, if any.
        final String metaKeywords = dataSource.getGenProps(-1).getWEBSVR_META_KEYWORDS();
        if(metaKeywords.length() > 0)
            { %><meta name=keywords content="<%= metaKeywords %>"><% }
        }
%>
</head>
<body bgcolor="#000000" vlink="#39caff" link="#ff0090" text="#ffffff"><%--

HOME link
--%><% final String homeURL = ((vHost == null) || (vHost.virtualRootDir == null)) ? "/" : vHost.virtualRootDir; %><%--
--%><a href="<%= homeURL %>"><font size=1><%= localeBean.getLocalisedMessage("org.hd.pg2k.Home") %></font></a><br><%--

BODY starts...
--%>