<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

    DEFAULT SKIN header.

--%><%@ page
    import="java.io.*,
            java.net.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.bgImg.BgImageUtils,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.svrCore.vars.*,
            org.hd.d.pg2k.webSvr.ads.*,
            org.hd.d.pg2k.svrCore.location.LoadBalancingUtils,
            org.hd.d.pg2k.svrCore.uploader.UploaderUtils"
    %><%--


// SET UP JAVA VARIABLES
--%><%! private static final int maxTitlesLen = 48; %><%-- Max length of main title (chars).
--%><%! private static final int maxShortTitlesLen = 32; %><%-- Max length of short title (chars).
--%><%! private static final int PAGE_WIDTH = PageSkinUtils.GENERIC_WIDTH_PX; %><%-- Layout width of our page.
--%><%! private static final int EDGE_COLS_WIDTH = (15*PageSkinUtils.GENERIC_WIDTH_PX)/100; %><%-- Layout width of our edge columns.
--%><%! private static final int MID_COLS_WIDTH = (PageSkinUtils.GENERIC_WIDTH_PX - 2*EDGE_COLS_WIDTH) / 2; %><%-- Layout width of our middle columns.
--%><%! private static final int TOWER_COL_DEFAULT_WIDTH = 160; %><%-- Default layout width for a tower ad.
--%><%@ include file="/_common/_SetPageStartTime.inc.jsp" %><%-- Note start time if not already done for standard footer.
--%><%
// Work out if this is probaby a first page view by this user.
final boolean firstPageView = (WebUtils.requestProbablyReferredFromExternalSite(request) != null);
final boolean notFastFirstPageView = (!WebConsts.FIRST_PAGE_AFAP || !firstPageView);

// Helps us construct titles later...
final Object _titleO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE);
Object _subTitleO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE);
// Inject sub-title/mission automatically if spider or 1st pageview and not otherwise defined.
if((null == _subTitleO) && (clientIsSpider || firstPageView))
    { _subTitleO = localeBean.getLocalisedMessage("org.hd.pg2k.2ndWelcome"); }
String _windowTitle = null; // WINDOW TITLE: Conjoined titles, if present, else null.
if(_titleO instanceof String)
    {
    final String _title = (String) _titleO;
    final String _subTitle = (_subTitleO instanceof String) ? (String) _subTitleO : null;
    _windowTitle = _title;
    if(_subTitle != null) { _windowTitle = _windowTitle + ": " + _subTitle; }
    // Keep window title (combined titles) to a reasonable length...
    final int maxWinTitleLen = 96;
    if(_windowTitle.length() > maxWinTitleLen) { _windowTitle = TextUtils.sanitiseForXML(_windowTitle, maxWinTitleLen, true); }
    }

// Get the prev/next values, if any.
final Object _prevO = pageContext.getAttribute("prev");
final Object _nextO = pageContext.getAttribute("next");

// Get DataSourceBean and GenProps.
final DataSourceBean _dh_dsb_ = dataSource;
final GenProps genProps = _dh_dsb_.getGenProps(-1);
%><%--

START THE HTML
Keep this (until the flush() of the breadcrumbs line) as trimmed as possible
to try to ensure that breadcrumbs line can be delivered to visitor
without having to wait for any ACKs at the TCP level.
Keeping the text << 1kByte until the flush() will help achieve this.
We may work especially hard to deliver the first page's breadcrumbs ASAP.

To help vistors from the SERPs and with tabbed browsers
omit the site name from the start of the title.
--%><html lang="en, <%= localeBean.getLocale().toString().replace('_', '-') %>"><head><%--
--%><title><%= (_windowTitle != null) ? _windowTitle : localeBean.getLocalisedMessage("org.hd.pg2k.title") %></title><%--
--%><%

// If asking SEs not not index possibly-low-unique-content pages,
// then insert the appropriate robot meta header tag here.
if(WebConsts.USE_NOINDEX_ON_LOW_CONTENT_PAGES &&
   clientIsSpider &&
   (null != request.getAttribute(WebConsts.STDHDR_ATTR_NAME_NOINDEX)))
    { %><meta name="robots" content="noindex"><% }

// Insert meta headers if available, and the site not busy,
// and the client is NOT a spider.
// Possibly skip (generic) headers to improve interactive performance
// (mainly to reduce latency and bandwidth).
if(!siteIsBusy && clientIsSpider)
    {
    // Get meta keywords and description, if any,
    // and conditions suitable (looks like a spider visiting and the site is not busy).
    final String metaKeywords = genProps.getWEBSVR_META_KEYWORDS();
    final String metaDescription = genProps.getWEBSVR_META_DESCRIPTION();

    // Get page-specific keywords, if any and if safe.
    final Object _keywordsO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_KEYWORDS);
    final String _keywords = (_keywordsO instanceof String) ? ((String) _keywordsO).trim() : null;
    // Check that the specific keywords are present and "safe".
    final boolean _keywordsOK = (_keywords != null) && (_keywords.length() > 11) && (_keywords.indexOf('<') == -1);
    if(_keywordsOK)
        { %><meta name=keywords content="<%= _keywords %>"><% }
    // Only include generic keywords for spiders.
    else if(clientIsSpider && (metaKeywords.length() > 0))
        { %><meta name=keywords content="<%= metaKeywords %>"><% }

    // Only include pure *generic* description for non-interactive (spider) users.
    if(clientIsSpider || ((null != metaDescription) && (metaDescription.length() > 0)))
        { %><meta name=description content=<%= UploaderUtils.quoteHTMLArg(localeBean.getLocalisedMessage("org.hd.pg2k.simpleWelcome") + " - " + metaDescription) %>><% }

    // Only a spider could possibly care about the revisit-after header...
    // and probably most don't/won't use it anyway...
    if(false && clientIsSpider && (WebConsts.SPIDER_REVISIT_DAYS > 0))
        { %><meta name="revisit-after" content="<%= WebConsts.SPIDER_REVISIT_DAYS %> days"><% }
    }
%><%--

TRY TO BREAK OUT OF THIRD-PARTY FRAMES
--%><% if(WebConsts.DO_FRAME_BREAKOUT) { %>
<script language="JavaScript1.1" type="text/JavaScript"><!--<%-- Hide from old browsers. --%>
if(parent.frames.length > 0) top.location.replace(document.location);<%-- Escape from any referring site's frame, but preserve one-click "Back". --%>
--></script>
<% } /* End DO_FRAME_BREAKOUT. */ %><%--

INSERT URL-SPECIFIC (META) TAGS ON DEMAND
This allows use to to drop in custom text per-page easily
for such things as Google site-ownership verification.
--%><%
    final String customTag = genProps.getGen().get(request.getRequestURL().insert(0, WebConsts.GP_HEAD_TAG_INSERT_KEY_PREFIX).toString());
    if(null != customTag) { %><%= customTag %><% }
    %><%--

--%></head><%--
--%><body bgcolor=<%= PageSkinUtils.GENERIC_BG_COLOUR_QUOTED %><%--

TRIM MARGINS (disabled at the moment)
 marginwidth=0 topmargin=0 leftmargin=0 marginheight=0

INSERT BG IMAGE
iff it exists and this server is not too busy to serve it
and we're not doing a "lite" UI.
--%><%
    // Get access to session variables (null if none yet)...
    final SessionVarBean _svbH = SessionVarBean.getExtantSessionVars(request, false);
    // Do a full UI iff:
    //   * The user has not explicitly requested a "lite" UI.
    //   * The user has not just arrived at our site (and we want to be fast).
    final boolean liteUINotRequested = (_svbH == null) || !_svbH.isSessionVarLiteUI();
    final boolean fullUI = liteUINotRequested && notFastFirstPageView;

    // Only real humans get a pretty background, and only if we're not busy!
    if(!siteIsBusy && !clientIsSpider && fullUI)
        {
        final String _bgImage = genProps.getWEBSVR_BG_IMAGE();
        final ExhibitStaticAttr _esa = (_bgImage == null) ? null :
            _dh_dsb_.getStaticAttr(_bgImage);
        // Only allow the background image if:
        //   * we have it available locally,
        //   * it is a JPEG,
        //   * it is not too big (ie would be too bulky to be a thumbnail).
        final boolean useDynamicBgImg = (_esa == null) ||
            (_esa.length > ExhibitThumbnails.STD_ABS_MAX_BYTES) ||
            ((ExhibitMIME.getInputFileType(_esa.filePath)) == null) ||
            ((ExhibitMIME.getInputFileType(_esa.filePath)).type != ExhibitMIME.ET_JPEG);
        if(!useDynamicBgImg)
            {
            // Insert exhibit URL keyed to this server...
            %> background="<%= WebUtils.makeExhibitRRURL(_bgImage) %>"<%
            }
        else
            {
            // Insert RRURL for dynamic background image.
            %> background="<%= BgImageUtils.dynBgImgRRUL %>"<%
            }
        }
%>>
<%-- Insert linebreak for sanity of anyone reading the HTML...


--%><%
    final Object _crumbsO = request.getAttribute(WebConsts.STDHDR_ATTR_NAME_BREADCRUMBS);
    final Breadcrumbs _crumbs = (_crumbsO instanceof Breadcrumbs) ?
        ((Breadcrumbs) _crumbsO) : null;
    %><%--
BREADCRUMBS (always contains home-page link)
Try to force good contrast/colours for breadcrumb text.
--%><span style="font: color: black; background-color: white;"><%--
--%><a href="/<%-- localeBean.getLocalisedMessage("org.hd.pg2k.homeURL") --%>"><%= localeBean.getLocalisedMessage("org.hd.pg2k.Home") %></a><%--
--%><% if((_crumbs == null) || (_crumbs.size() == 0)) { %>&nbsp;<% } else {
    // Insert supplied crumbs.
    for(int i = 0; i < _crumbs.size(); ++i)
        {
        // Put in spacer; note that we already have link to home on left.
        %> &gt; <%

        // Insert crumb, wrapping in link if appropriate.
        final Breadcrumbs.Breadcrumb _crumb = _crumbs.getCrumb(i);
        if(_crumb.link != null) { %><a href="<%= _crumb.link %>"><% }
        %><%= _crumb.linkText %><%
        if(_crumb.link != null) { %></a><% }
        }
    }
// Insert title and subtitle if extant
// and if not already in the breadcrumbs.
if(_titleO instanceof String)
    {
    boolean alreadySeenTitleText = false;
    if(_crumbs != null)
        {
        for(int i = _crumbs.size(); --i >= 0; )
            {
            final Breadcrumbs.Breadcrumb _crumb = _crumbs.getCrumb(i);
            if(_crumb.linkText.equals(_titleO))
                {
                alreadySeenTitleText = true;
                break;
                }
            }
        }

    if(!alreadySeenTitleText)
        {
        %> &gt; <%
        %><strong><%= TextUtils.sanitiseForXML((String) _titleO, maxShortTitlesLen, true) %></strong><%
        }
    }
if(_subTitleO instanceof String)
    {
    %> &gt; <%
    %><strong><%= TextUtils.sanitiseForXML((String) _subTitleO, maxShortTitlesLen, true) %></strong><%
    }
%><%--
INSERT LITE/FULL LINK...
--%><% { %><%-- // Scope local variables.
--%><% final SessionVarBean _svb = SessionVarBean.getExtantSessionVars(request, true); %><%--
--%> &nbsp; <small><a href="<%= TextUtils.escapeHTMLMetaChars(_svb.copy().setSessionVarLiteUI(!_svb.isSessionVarLiteUI()).makeSessionVarSetURL(request, !clientIsSpider && notFastFirstPageView, _dh_dsb_)) %>"><%= _svb.isSessionVarLiteUI() ? "[<b>+</b>]" : "[-]" %></a></small><%--
--%><% } %><%--
--%></span><%--
--%><br />

<%-- Insert linebreak(s) for sanity of anyone reading the HTML...


--%><% out.flush(); %><%-- Force out nav/breadcrumbs line ASAP, in single first TCP packet we hope...


--%><%
    // Never generate an ad if this appears to be an error page,
    // nor if the user has requested a "lite" UI (well, rarely!),
    // nor if ads are disabled in general,
    // nor (maybe) on low-content pages.
    final boolean doingAdsAtAll = AdUtils.showAds(_dh_dsb_, request) &&
        (request.getAttribute("javax.servlet.error.request_uri") == null);
    final boolean doingAds = doingAdsAtAll &&
        !(WebConsts.USE_NOINDEX_ON_LOW_CONTENT_PAGES &&
            (null != request.getAttribute(WebConsts.STDHDR_ATTR_NAME_NOINDEX)));

    // Post this value where the footer can get it.
    if(doingAds) { request.setAttribute("doingAds", Boolean.TRUE); }

    // What placement of tower ad will we use, if any?
    // The most useful placement moneywise is probably LEFT,
    // but rotation to avoid ad-blindness is probably useful.
    // We avoid towers unless doing a fullUI, so as to keep the screen narrow.
    // Note that IF we use a tower then it may contain an AdSense Link unit.
    // We may reduce ads on a user's first view.
    AdTowerPos towerPos = AdTowerPos.NOWHERE; // By default, none.
    if(doingAds && liteUINotRequested &&
       (!AdConsts.DROP_ADS_ON_FIRST_PAGE_VIEW || notFastFirstPageView))
        {
        // Select our preferred layout style.
        towerPos = AdUtils.selectPageAdLayout(_dh_dsb_, request, siteIsBusy, false);

        // Record the ad layout style as a suffix that we can extract easily...
        layoutName = AdUtils.computeCTEventName(towerPos);
        }
    // Post this value where the footer can get it.
    request.setAttribute("towerPos", towerPos);

    %><%--


--%><%! private static final int TABLE_COLS = PageSkinUtils.GENERIC_TABLE_COLS; %><%--
START (LEFT-ALIGNED) TABLE...
--%><table border=0 cellpadding=0 cellspacing=0<%--
--%> width=<%= (towerPos == AdTowerPos.NOWHERE) ? PAGE_WIDTH : (PAGE_WIDTH + TOWER_COL_DEFAULT_WIDTH) %>>
<%-- Insert linebreak for sanity of anyone reading the HTML...


FORCE TABLE LAYOUT
For the benefit of browsers such as FireFox 1.0 (FF1)
that seem to need help with the column widths, ie to have them explicit.
In general this will probably improve layout robustness,
and does not seem to do any harm (eg consume significant vertical space)
with IE6, Opera 7/8.
We can safely insert extra columns post hoc to handle tower ads as required.
--%><tr><%--

--%><% if(towerPos == AdTowerPos.LEFT) { %><%-- LEFT TOWER, if present...
--%><td width=<%= TOWER_COL_DEFAULT_WIDTH %><%--Force to fixed width for quick/stable layout--%>></td><%--
--%><% /* towerPos */ } %><%--

--%><th width=<%= EDGE_COLS_WIDTH %>></th><%--
--%><th width=<%= MID_COLS_WIDTH %>></th><%--
--%><th width=<%= MID_COLS_WIDTH %>></th><%--
--%><th width=<%= EDGE_COLS_WIDTH %>></th><%--

--%><% if(towerPos == AdTowerPos.RIGHT) { %><%-- RIGHT TOWER, if present...
--%><td width=<%= TOWER_COL_DEFAULT_WIDTH %><%--Force to fixed width for quick/stable layout--%>></td><%--
--%><% /* towerPos */ } %><%--

--%></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...


PREPARE HTML FOR LIST OF MIRRORS if any.
We highlight the "best" mirror for the user if more than one.
--%><%
    String mirrorText = "";
    // Computing mirror set may be slow,
    // so don't attempt it on the first page view by a user.
    // However, we always let spiders see the mirrors when available.
    if(notFastFirstPageView || clientIsSpider)
	    {
	    // Get list of mirrors, ordered fastest-first...
	    final List<String> mirrors = LoadBalancingUtils.orderMirrorTagsBestBandwidthFirst(
	            LoadBalancingUtils.getActiveMirrors(_dh_dsb_, true));
	    if(mirrors.size() > 0)
	        {
	        // Choose "best" mirror quickly, using normal weighting algorithm,
	        // if there is more than one to select from.
	        final String bestMirror = (mirrors.size() < 2) ? "" :
	            WebUtils.chooseMirrorHostToBalanceLoad(request, _dh_dsb_);
	        // If this host is a mirror then which one is it?
	        final String ourTag = LocalProps.getMirrorTag();
	        final int capacity = 99 + (64 * mirrors.size());
	        final StringBuilder sb = new StringBuilder(capacity);
	        sb.append('[');
	        sb.append(localeBean.getLocalisedMessage("common.mirrors"));
	        // Put in link back to "main" non-mirror home page...
	        sb.append(" <a href=\"").
	            append(localeBean.getLocalisedMessage("org.hd.pg2k.homeURL")).
	            append("\">").
	            append(localeBean.getLocalisedMessage("org.hd.pg2k.Home").toLowerCase()).
	            append("</a>");
	        // Now put in the individual mirrors, highest-bandwidth first...
	        for(final String tag : mirrors)
	            {
	            final String host = LoadBalancingUtils.makeMirrorHostnameFromTag(tag, CoreConsts.MAIN_DATA_HOST);
	            final boolean isBest = host.equals(bestMirror);
	            final boolean isUs = tag.equals(ourTag);
	            sb.append(" <a href=\"http://").append(host).append("/\">");
	            if(isBest) { sb.append("<strong>"); }
	            if(isUs) { sb.append("<i>"); }
	            sb.append(tag.substring(0, 2)); /* Use the country code as the link text... */
	            if(isUs) { sb.append("</i>"); }
	            if(isBest) { sb.append("</strong>"); }
	            sb.append("</a>");
	            }
	        sb.append("] &nbsp; &nbsp; &nbsp; ");
	        mirrorText = sb.toString();
//System.out.println("CAPACITY="+capacity+" vs length="+sb.length());
	        }
        }
%><%--



LOGO/STRAPLINE (left) AND FLAGS (i18n) AND SEARCH...
We can also use this to inject tower ads if need be.
--%><tr><%--

--%><% if(towerPos == AdTowerPos.LEFT) { %><%-- LEFT TOWER, if present...
--%><td rowspan=99 width=<%= TOWER_COL_DEFAULT_WIDTH %><%--Force to fixed width--%> valign=top bgcolor=<%= PageSkinUtils.GENERIC_BG_COLOUR_QUOTED %>><%--
--%><%@ include file="/_common/skins/default.hd.towerAdInsert.inc.jsp" %><%-- Get tower ad(s) if appropriate.
--%></td><%--
--%><% /* towerPos */ } %><%--

Give the "logo" a fixed (point) size...
--%><th width=<%= PAGE_WIDTH/2 %> colspan=2 nowrap rowspan=2 bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %> align=left valign=top><span style="font-size: xx-small; color: <%= PageSkinUtils.GENERIC_AH_COLOUR_QUOTED %>;"><%= localeBean.getLocalisedMessage("org.hd.pg2k.strapline", new Object[]{TextUtils.sizeAsText(_dh_dsb_.getAllExhibitProperties(-1L).getTotalExhibitBytes(), true)}) %>
    (<a href="/_cat/doHTMLRandom.jsp"><%= localeBean.getLocalisedMessage("common.exhibitCount", new Object[]{new Integer(_dh_dsb_.getAllExhibitImmutableData(-1L).size())}) %></a>)</span><br>
    <span style="font-size: 18pt; font-weight: bold; color: <%= PageSkinUtils.GENERIC_AH_COLOUR_QUOTED %>;"><%= localeBean.getLocalisedMessage("org.hd.pg2k.title") %></span></th><%--
--%><td width=<%= PAGE_WIDTH/2 %> colspan=2 nowrap align=right valign=middle bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %>><span style="font-size: small; color: <%= PageSkinUtils.GENERIC_AH_COLOUR_QUOTED %>;"><%= mirrorText %></span><%@ include file="/_common/_HTMLStdHdLocalePrompt.inc.jsp" %></td><%--

--%><% if(towerPos == AdTowerPos.RIGHT) { %><%-- RIGHT TOWER, if present...
--%><td rowspan=99 valign=top bgcolor=<%= PageSkinUtils.GENERIC_BG_COLOUR_QUOTED %>><%--
--%><%@ include file="/_common/skins/default.hd.towerAdInsert.inc.jsp" %><%-- Get tower ad(s) if appropriate.
--%></td><%--
--%><% /* towerPos */ } %><%--

--%></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...

--%><tr bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %>><%--
[logo from previous row takes up first two columns in this row...]
--%><td width=<%= PAGE_WIDTH/2 %> colspan=2 nowrap align=right><font size="-1"><%@ include file="/_cat/HTMLSearchBox.inc.jsp" %></font></td><%--
--%></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...


TITLE AND SUBTITLE IF SET, flanked by prev/next links...
(Prev/next links there partly for search-engines/spiders
in order to ensure that all catalogue pages are reachable from all others.)
--%><tr bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %> align=right><%--
--%><td width=<%= EDGE_COLS_WIDTH %> align=left><% if(_prevO instanceof String) { %><a href="<%= _prevO %>">&lt;<%= localeBean.getLocalisedMessage("common.prev") %></a><% } else { %>&nbsp;<% } %></td><%--
--%><th width=<%= 2*MID_COLS_WIDTH %> colspan=2 align=center><%--
    --%><% if(_titleO instanceof String) { %><h1 style="font-size: x-large; color: <%= PageSkinUtils.GENERIC_AH_COLOUR_QUOTED %>; margin: 0; border: 0; padding: 0;"><%= TextUtils.sanitiseForXML((String) _titleO, maxTitlesLen, true) %></h1><% } %><%--
    --%><% if(_subTitleO instanceof String) { %><h2 style="font-size: large; color: <%= PageSkinUtils.GENERIC_AH_COLOUR_QUOTED %>; margin: 0; border: 0;"><%= TextUtils.sanitiseForXML((String) _subTitleO, maxTitlesLen, true) %></h2><% } else { %>&nbsp;<% } %></th><%--
--%><td width=<%= EDGE_COLS_WIDTH %> align=right><% if(_nextO instanceof String) { %><a href="<%= _nextO %>"><%= localeBean.getLocalisedMessage("common.next") %>&gt;</a><% } else { %>&nbsp;<% } %></td><%--
--%></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...


OPTIONAL BANNER AD ROW AND TOWER IF AD(S) AVAILABLE
Spans all columns in case the ad is very large.
We have the tower *after* the banner in the HTML
in order to preferentially serve ads to the banner if supply is limited...
(Don't do sidebar if the site is busy as it implies extra work later...)
Suppress this banner (usually) if doing RIGHT tower
so as to make good use of real-estate and avoid poor ads in the banner slot
(AdSense will place higher-paying ones in the towers earlier in the HTML).
--%><% if(doingAds &&
          ((fullUI && (towerPos != AdTowerPos.RIGHT)) ||
           /* Often show ads on well-performing URI regardless of "lite" UI, etc. */
           (Rnd.fastRnd.nextBoolean() && !AdUtils.skipUnderperformingAdSlot(_dh_dsb_,
                                               SystemVariables.ACCESSPATTERN_CLICKTHROUGH_BY_URI,
                                               EventPeriod.VLONG,
                                               AdUtils.canonicaliseURI((String) request.getAttribute(ThroughputMonitorFilterPG2K.PNAME_SAVED_REQ_URI)))))) { %><%--
--%><% final String simpleAd = genProps.getSimpleAd(); %><%--
--%><tr bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %>><%--
DO SIMPLE ROTATED BANNER AD...  (Or thin AdLink strip for lite/no-tower layouts...)
Force maximum expected/typical size
standard 468x60 banner centred in full width of main part of table)
to try to help faster page layout if ad is slow to load.
--%><% { %><%-- NORMAL BANNER ROTATION...
--%><td colspan=<%= TABLE_COLS %> align=center width=<%= PAGE_WIDTH %> height=60><%= (simpleAd != null) ? simpleAd : "&nbsp;" %></td><%--
--%><% } %><%--

TOWER SD SLOT ON RIGHT IN EXTRA COLUMN
Have this run down to the bottom of the body.
--%><% if(towerPos == AdTowerPos.RIGHT_DROPPED) { %><%--
--%><td rowspan=99 valign=top bgcolor=<%= PageSkinUtils.GENERIC_BG_COLOUR_QUOTED %>><%--
--%><%@ include file="/_common/skins/default.hd.towerAdInsert.inc.jsp" %><%-- Get tower ad(s) if appropriate.
--%></td><%--
--%><% /* towerPos */ } %><%--

--%></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...
--%><% /* doingAds */ } %><%--


SLIP IN SLIM-STRIP ADLINKS UNIT IF AT ALL POSSIBLE...
--%><% if(doingAdsAtAll && ((towerPos == AdTowerPos.NOWHERE) || (null != request.getAttribute(AdConsts.ASLU_AVAILABLE_REQ_ATTR_NAME)))) { %><%-- AdLinkHeaderLite UNIT (legit because there is no tower with its own AdLink unit)....
--%><% request.setAttribute(AdConsts.ASLU_AVAILABLE_REQ_ATTR_NAME, null); /* AdLink unit for this page has now been allocated. */ %><%--
--%>
<tr bgcolor=<%= PageSkinUtils.GENERIC_ABG_COLOUR_QUOTED %>><th colspan=<%= TABLE_COLS %> height=19 valign=bottom>
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_color = "FFFFCC";
google_ad_width = 728;
google_ad_height = 15;
google_ad_format = "728x15_0ads_al";
google_ad_channel ="8803705085";<%-- AdLinkHeaderLite --%>
google_color_border = "FF0000";
google_color_bg = "FFFFCC";
google_color_link = "0000CC";
google_color_text = "000000";
google_color_url = "008000";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
</th></tr>
<%-- Insert linebreak for sanity of anyone reading the HTML...
--%><% /* doingAds */ } %><%--


READY FOR PAGE BODY...
--%><tr><td colspan=<%= TABLE_COLS %> width=<%= PAGE_WIDTH %> height=<%= Math.max(1400, PageSkinUtils.GENERIC_WIDTH_PX) %> valign=top bgcolor=<%= PageSkinUtils.GENERIC_BG_COLOUR_QUOTED %>>

<%  // Insert emphasised news-flash HTML text (wrapped in a div) if available.  No i18n.
if(firstPageView) // Only show at any page top on first page view by user of this site.
    { // Scope local variables...
    final String newsflash = WebUtils.getNewsflashHTML(genProps);
    if(newsflash.length() > 0)
        { %><div class="newsflash"><strong><%= localeBean.getLocalisedMessage("common.main.news.heading") %>: <%= newsflash %></strong></div><% }
    }
%>
