<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

BASE NODE for virtual "Aloha Earth" site.

FIXME: needs i18n.

--%><%@ page
    import="org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.exhibit.*,
            java.io.IOException,
            org.hd.d.pg2k.webSvr.location.LocationUtils,
            org.hd.d.pg2k.svrCore.location.Location,
            org.hd.d.pg2k.webSvr.virtualHosts.AlohaEarth.*,
            org.hd.d.pg2k.webSvr.ads.*,
            org.hd.d.pg2k.webSvr.catalogue.*"
    session="false"
%><%--

NOTE START TIME
--%><% final long startTime = System.currentTimeMillis(); %><%--

PARAMETERS BEAN...
--%><% final AEParams AEParamsBean = new AEParams(); %><%--
--%><% AEParamsBean.setRequest(request); %><%--

IF REQUEST URI IS IN A NON-CANONICAL FORM
(IE CONTAINING SE-UNFRIENDLY QUERY PARAMETERS)
THEN REDIRECT TO CANONICAL FORM ASAP.
--%><%
    // Check for sample parameters; we need not look for them all.
    if((null != request.getParameter(AEParams.NAME_EAST_OFFSET)) ||
       (null != request.getParameter(AEParams.NAME_MAP_FIELD + ".x")) ||
       (null != request.getParameter(AEParams.NAME_ZOOM_CONTROL_FIELD)))
        {
        response.sendRedirect(AEUtils.AE_SELF_RRURL + AEParamsBean.getAsGetPathInfo(false));
        return;
        }
    %><%--

TIMING, LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

GET AREA OF CURRENT MAP
--%><% final Location.Estd mapArea = AEParamsBean.getLocation(true); %><%--

GET TITLE (AND KEYWORDS) OF CURRENT VIEW ("" if none)
--%><%
    final AlohaEarthMapCache aemfb = AEUtils.getAemfb(dataSource);
    final String areaTitle = aemfb.
        selectViewLocationVirtualPrefixAsTitle(AEParamsBean, application);
    final String title = "Aloha Earth!" + ("".equals(areaTitle) ? "" : (" ("+areaTitle+")"));
    final AllExhibitProperties aep = dataSource.getAllExhibitProperties(-1);
    final String locPrefix = aemfb.selectViewLocationVirtualPrefix(AEParamsBean, aep.epgi.getLocationMap());
    final String fakeExhibitName = locPrefix + "A.a";
    // Insert page-specific keywords in title and meta-headers if extant.
    final String specificAKA = ("".equals(locPrefix)) ? "" :
        GenUtils.getLocalisedTreeDesc(aep, fakeExhibitName, localeBean, false, true, false, true);
    // Comma-separated keywords, or "" if nothing useful to say...
    final String keywords = areaTitle.replace(ExhibitName.WORD_SEP, ',') +
                                // Insert extra "," only if needed...
                                (("".equals(areaTitle) || areaTitle.endsWith(ExhibitName.WORD_SEPS))?"":",") +
                            specificAKA;
%><%--

HEADER
--%><%
// SET CACHE PARAMETERS
// These AE pages should only change relatively slowly,
// so cache them accordingly to help performance.
response.setHeader("Cache-Control",
        "max-age="+CoreConsts.DEFAULT_TEMPORAL_SLACKNESS_S);
response.setDateHeader("Expires", System.currentTimeMillis() +
        (CoreConsts.DEFAULT_TEMPORAL_SLACKNESS_S*1000));

// Set header parameters.
request.setAttribute(WebConsts.STDHDR_ATTR_NAME_KEYWORDS, keywords);
request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, title);

// This is not unique content for SEs to index.
request.setAttribute(WebConsts.STDHDR_ATTR_NAME_NOINDEX, Boolean.TRUE);
%><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--


ADLINKS
--%><% if(AdConsts.AD_SUPPORT) { %><%--
--%><center>
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_color = "000000";
google_ad_width = 728;
google_ad_height = 15;
google_ad_format = "728x15_0ads_al";
google_ad_channel ="9686238065";
google_color_border = ["000000","333333","191933","660000"];
google_color_bg = ["F0F0F0","000000","333366","7D2626"];
google_color_link = ["0000FF","FFFFFF","99CC33","FFFFFF"];
google_color_url = ["008000","999999","FFCC00","DAA520"];
google_color_text = ["000000","CCCCCC","FFFFFF","BDB76B"];
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
</center><%--
--%><% } %><%--


BODY
--%>
<center>
<h1><%= title %></h1>
<p><small><a href="http://gallery.hd.org/terms.html">Free-to-use</a> multimedia exhibits by location from all over the Earth.</small></p>
</center>
<%--

SHOW MAP IMAGE
--%><p align=center>
<table border=0 align=center>
<tr>
<td align=right><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(-1, +1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowNW.png" width=11 height=11 border=0 align=middle alt=NW></a></td>
<td align=center><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate( 0, +1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowN.png" width=16 height=16 border=0 align=middle alt=N></a></td>
<td align=left><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(+1, +1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowNE.png" width=11 height=11 border=0 align=middle alt=NE></a></td>
</tr>
<tr>
<td align=right><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(-1,  0).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowW.png" width=16 height=16 border=0 align=middle alt=W></a></td>
    <td align=center width=<%= AEUtils.DISPLAY_2D_EARTH_MAP_WIDTH %> height=<%= AEUtils.DISPLAY_2D_EARTH_MAP_HEIGHT %>><%--
--%><form method=<%= WebConsts.SEARCH_FORM_METHOD %>
    action="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.getAsGetPathInfo(false) %>"
    style="position:relative; display:block;<%-- overflow:hidden; --%> width:<%= AEUtils.DISPLAY_2D_EARTH_MAP_WIDTH %>px; height:<%= AEUtils.DISPLAY_2D_EARTH_MAP_HEIGHT %>px;"><%-- <%= AEParamsBean.getAsHiddenFormElements() %>
--%><input type=image src="<%= AEUtils.MAP_SERVLET_RRURL %>?<%= AEParamsBean.getAsGetURLParameters(false) %>"
    width=<%= AEUtils.DISPLAY_2D_EARTH_MAP_WIDTH %>
    height=<%= AEUtils.DISPLAY_2D_EARTH_MAP_HEIGHT %>
    align="middle"
    name=<%= AEParams.NAME_MAP_FIELD %>
    style="position:absolute; left:0; top:0; cursor:crosshair;"
    title="<%= (AEParamsBean.getZoomFactor() < AEUtils.MAX_ZOOM) ? "Click to zoom in.  " : "" %>Earth image c/o NOAA"
    alt="<%= (AEParamsBean.getZoomFactor() < AEUtils.MAX_ZOOM) ? "Click to zoom in.  " : "" %>Earth image c/o NOAA"
><%--
--%><%= aemfb.selectViewLocationLabels(dataSource, AEParamsBean) %><%-- Insert the overlay labels...
--%></form></td>
<td align=left><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(+1,  0).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowE.png" width=16 height=16 border=0 align=middle alt=E></a></td>
</tr>
<tr>
<td align=right><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(-1, -1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowSW.png" width=11 height=11 border=0 align=middle alt=SW></a></td>
<td align=center><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate( 0, -1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowS.png" width=16 height=16 border=0 align=middle alt=S></a></td>
<td align=left><a href="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.cloneAndTranslate(+1, -1).getAsGetPathInfo(false) %>"><img src="/_static/icon/arrowSE.png" width=11 height=11 border=0 align=middle alt=SE></a></td>
</tr>
</table></p>
<p align=center><small><%--Click on the map or use--%>Use the Zoom Control to zoom in/out; click on the arrows to scroll. <%-- FIXME: needs i18n --%></small></p>
<%--


ZOOM control

Start a form with current values as hidden parameters. --%>
<form method=<%= WebConsts.SEARCH_FORM_METHOD %> action="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.getAsGetPathInfo(false) %>">
<%-- <%= AEParamsBean.getAsHiddenFormElements() %> --%>
<p align=center>
<%
    final String zoomText = "Zoom Control: "; // Needs i18n.
    %><%= zoomText %><%
%>
    <!%-- Zoom-out buttom --%>
    <input type=submit name=<%= AEParams.NAME_ZOOM_CONTROL_FIELD %> value="-">
    <%
        final int zf = AEParamsBean.getZoomFactor();
        for(int i = AEUtils.MIN_ZOOM; i <= AEUtils.MAX_ZOOM; ++i)
            {
            // Show numeric value, always numbered from 1 upwards,
            // bigger meaning more zoom in (more expansion of Earth image),
            // with the current zoom level having no link.
%><input type=submit name=<%= AEParams.NAME_ZOOM_CONTROL_FIELD %> value="<%= i - AEUtils.MIN_ZOOM + 1 %><%= (i==zf) ? "*" : "" %>"><%
            }
    %>
    <%-- Zoom-in buttom --%>
    <input type=submit name=<%= AEParams.NAME_ZOOM_CONTROL_FIELD %> value="+">
</p>
</form>
<%--


IMAGE CENTRE INFO
--%><p align=center>
<%
    final String centreText = "Image Centred On: "; // Needs i18n.
%><%= centreText %>
<%= Math.round(mapArea.getN().value.floatValue()) %>N,
<%= Math.round(mapArea.getE().value.floatValue()) %>E:
<%= LocationUtils.makeLocTNImgHTML(mapArea) %>
(+/-
<%= Math.round(mapArea.getN().error.floatValue()) %>N
<%= Math.round(mapArea.getE().error.floatValue()) %>E)</p>
<%--

SPACER (with optional AdSense ad)
--%>
<p align=center>You may also wish to visit the DHD Multimedia Gallery <a href="http://gallery.hd.org/places-and-sights/">Places-and-Sights</a> collection.
<% if(AdConsts.AD_SUPPORT) { %>
<br />
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_ad_url = "http://<%= request.getServerName() %><%= (request.getServerPort() == 80) ? "" : ":"+request.getServerPort() %>/_static/ads/google_adsense_script.html"; // Collapse if no ad...
google_ad_width = 728;
google_ad_height = 90;
google_ad_format = "728x90_as";
google_ad_channel ="3310345400";<%-- AlohaEarthMidPage --%>
google_color_link = "FFFFFF";
google_color_text = "CCCCCC";
google_color_url = "999999";
google_color_border = "333333";
google_color_bg = "000000";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
<% /* end AD_SUPPORT */ } %>
</p>
<p align=center>
<%
    if(!"".equals(locPrefix))
        {
        final String desc = GenUtils.getLocalisedTreeDesc(aep,
                                                          fakeExhibitName,
                                                          localeBean,
                                                          true, true, false, false);
        if(!"".equals(desc))
            {
            // Write out tree-based description if one is available...
            %>
<!-- google_ad_section_start --><%-- Ask AdSense to concentrate on this text. --%>
<%= desc %>
<!-- google_ad_section_end -->
<br /><%
            }
        }

%>
<hr width="50%" align=center><p>
<%--


SHOW EXHIBITS, PAGINATED.
SET UP THE PAGINATION BEAN...
--%><% final PaginationBeanTree paginationBean = new PaginationBeanTree(); %><%--
--%><%
    // List of exhibits (full names) in the current area.
    final List<String> exhibits = aemfb.
        selectContainedExhibits(AEParamsBean);
//    paginationBean.setNumberOfItems(exhibits.size());
    final List<String> shortNames = new ArrayList<String>(exhibits.size());
    for(final Iterator<String> it = exhibits.iterator(); it.hasNext(); )
        { shortNames.add( /* MemoryTools.intern */ (ExhibitName.getFileComponent(it.next()))); }
    paginationBean.setTreeNodeDetails("", shortNames);
    final String pgParam = request.getParameter(WebConsts.PAGE_NUMBER_PARAMETER);
    paginationBean.setPg(pgParam);
    %><%--
--%>
<p><%= localeBean.getLocalisedMessage("common.exhibitCount", exhibits.size())%></p>
<% if(exhibits.size() > 0) { %>
<center>
<%--

OTHER PAGES BUTTONS (top copy)
--%>
<form method=<%= WebConsts.SEARCH_FORM_METHOD %> action="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.getAsGetPathInfo(false) %>">
<p><%@ include file="/_common/_HTMLPageButtons.inc.jsp" %></p>
</form>
<%--

RESULTS TABLE
--%><% { // Scope our variables.
// Generate array of short names containing just the desired subset.
final List res = exhibits.subList(paginationBean.getStartIndex(),
                                  paginationBean.getEndIndex());
final String[] searchResults = new String[res.size()];
for(int i = searchResults.length; --i >= 0; )
    { searchResults[i] = ExhibitName.getFileComponent((String) res.get(i)); }

final int MAX_TO_SHOW = searchResults.length;
final int firstPos = 0;
// Build the search-result HTML.
%><p><%@ include file="/_cat/HTMLSearchResults.inc.jsp" %></p><%--
--%><% } %><%--

OTHER PAGES BUTTONS (bottom copy: keep in sync with top)
--%>
<form method=<%= WebConsts.SEARCH_FORM_METHOD %> action="<%= AEUtils.AE_SELF_RRURL + AEParamsBean.getAsGetPathInfo(false) %>">
<p><%@ include file="/_common/_HTMLPageButtons.inc.jsp" %></p>
</form>

</center><% } %><%-- End of "if(exhibits.size() > 0)"...

NOTE TIME TAKEN
--%>
<p align=right><small><%= System.currentTimeMillis() - startTime %>ms</small></p>
<%--

FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>
