<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

BASE NODE for virtual "LondonPix" site.

This is a single-page virtual site www.londonpix.org.uk.

--%><%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.svrCore.AllExhibitProperties,
            java.util.*,
            org.hd.d.pg2k.svrCore.ExhibitName,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.exhibit.*,
            java.io.IOException,
            org.hd.d.pg2k.svrCore.ExhibitAttrUtils,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts,
            org.hd.d.pg2k.svrCore.uploader.UploaderUtils"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...




HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "Aah! London!"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--



BODY
--%>
<center>
<h1>Aah! <font color=red>Lo</font><font color=white>nd</font><font color=blue>on</font>!</h1>
<p>Welcome to ``Aah! London!'' aka London Pix,
   a collection of images from and about London, England.</p>
<p>A random selection of the available images is shown on each visit.
   (Depending on your browser settings you may have to hit your
   browser's RELOAD or REFRESH button to see a new selection.)</p>
<p>Click on each thumbnail for more details and a link to the full-size image.</p>
<p>Bookmark this page and revisit it each day.</p>
</center>
<%--


FLUSH OUTPUT in case thumbnails take a while to generate
--%><% out.flush(); %><%--


GET OUR RESULTS
We take places-and-sights items,
whose names begin "England-London-",
that are JPEG.
We'll then randomly select and show some of those with large thumbnails.
--%><jsp:useBean id="LondonPixExhibitSet"
             class="org.hd.d.pg2k.webSvr.exhibit.FilterBean"
             scope="application"><%--
    --%><%
    LondonPixExhibitSet.setMemorySensitiveCache(false); // Hold onto this data.
    LondonPixExhibitSet.setExpr(
        new FilterExpr(
            new FilterExpr(
                new FilterExpr(null,
                               //new BuiltInFilters.filtAll(new String[]{"places-and-sights"})),
                               new BuiltInFilters.filtByCategory(new String[]{"places-and-sights"})),
                           //new BuiltInFilters.filtAll(new String[]{"England-London-"})),
                           new BuiltInFilters.filtPrefixMatch(new String[]{"England-London-"})),
                       new BuiltInFilters.filtSimpleSuffixMatch(new String[]{".jpg"}))
        );
    %></jsp:useBean>

    <%
    // Maximum number of exhibits to show...
    // Make it somewhat less than the maximum results per search/tree page...
    final int MAX_TO_SHOW = Math.max(5,
                                     WebConsts.MAX_RESULTS_PER_PAGE / 2);

    // Build a local bean each time the page is requested that
    // pulls out a sorted random sub-set of items
    // that have standard thumbnails.
    // If we attempt to fetch one that no longer has a thumbnail,
    // we'll just skip it.
    final DataSourceBean ds = dataSource;
    final AllExhibitProperties aep = ds.getAllExhibitProperties(-1L);
    final FilterBean sortedSelection = new FilterBean();
    sortedSelection.setExpr(
        new SortExpr(
            new SortExpr(
                new FilterExpr(
                    new SortExpr(null,
                                 // Preselect a slightly oversize random set of candidates...
                                 new BuiltInFilters.sortRandomN(2 * MAX_TO_SHOW, null)),
                             // Reject all those without (standard) thumbnails.
                             (new FilterIF(){
                                 public boolean accept(AllExhibitProperties aep, String exhibitName)
                                     { return(WebUtils.exhibitHasThumbnail(ds, exhibitName, true, false)); }
                                 })),
                         // Slim down to the desired size set of results...
                         new BuiltInFilters.sortRandomN(MAX_TO_SHOW, null)),
                     // Sort into "smart"-ish order.
                     new BuiltInFilters.sortByName(BuiltInFilters.sortByName.SIMPLE_SMART)
        ));

    // Compute/cache full set of eligible exhibits.
    final List allCandidiates = LondonPixExhibitSet.select(application);

    // Pull out sub-set of cached candidates.
    final List results = sortedSelection.select(application, allCandidiates);

    %><p align=center><%

    final java.awt.Dimension thumbnailXyDim = new java.awt.Dimension();
    for(final Iterator it = results.iterator(); it.hasNext(); )
        {
        final String exhibitName = (String) it.next();
//System.err.println("EXHIBIT NAME [2]: " + exhibitName);

        // Try to get a thumbnail, which must be an inlineable image.
        final String thumbnailRRURL = WebUtils.makeHTMLInlineImageThumbnailURL(
            ds, exhibitName,
            true, // Make a standard thumbnail.
            true, // Make root-relative URL.
            thumbnailXyDim,
            false); // Force thumbnail generation if we have to...

        if(thumbnailRRURL != null)
            {
            // Use main stem as ALT text rather than generic "thumbnail" word.
            final String mainStem = ExhibitName.getMainWordsComponent(exhibitName, ExhibitAttrUtils.getAttrWords().getAttrWordsSortedSet());
%>
<table border=<%= PageSkinUtils.GENERIC_TN_BORDER_WIDTH_PIXELS %> align=center><tr><td><a href="<%= WebUtils.makeCatPageURL(exhibitName, WebConsts.F_secondary_generated_HTML_suffix) %>"><img src="<%= thumbnailRRURL %>" width=<%= thumbnailXyDim.width %> height=<%= thumbnailXyDim.height %> alt=<%= UploaderUtils.quoteHTMLArg(mainStem) %><%= WebConsts.TN_IMG_TAG_EXTRA_ATTR %>></a></td></tr></table>
<%
            }
        }

    %></p><%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>
