<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

BASE NODE for virtual "SmlPx.mobi" site.

--%><%@ page
    import="org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.webSvr.exhibit.*,
            java.io.*"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...
--%><%@ include file="/_common/_FullSortedExhibitSetBean.inc.jsp" %><%-- Get sorted-exhibits bean...


EXPIRY/CACHEING
Force a relatively short expiry for this potentially-"fresh" page, even for spiders.
We don't publickly cache pages generated within a session
(eg with a non-default locale) to avoid confusion.
--%><%
    response.setHeader("Cache-Control",
            ((request.getSession(false) == null) ? "public," : "private,") +
            "max-age="+(WebConsts.DEFAULT_PAGE_CACHE_MS/2000));
    response.setDateHeader("Expires", System.currentTimeMillis() +
            WebConsts.DEFAULT_PAGE_CACHE_MS/2);
%><%--


HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "Small Pictures"); %><%--
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_SUBTITLE, "@ DHD Multimedia Gallery"); %><%--
--%><%@ include file="/_common/_XHTMLStdHd.inc.jsp" %><%--


BODY/CONTENT
--%><%
    // Get the exhibit properties...
    final AllExhibitProperties aep = dataSource.getAllExhibitProperties(-1L);

    // Count the exhibits,
    // in particular in case there are temporarily zero during start-up.
    // (In which case we omit the intro para entirely.)
    final int nExhibits = aep.aeid.size();
    final List items = FullSortedExhibitSet.select(application);
    if((nExhibits > 1) && (items.size() > 0)) // Ultra-cautious!
        {
        // Insert links to catalogue pages to give spiders a good entree, as well as humans!
        final String first = (String) items.get(0);
        final String last = (String) items.get(items.size() - 1);
        final SortedSet<String> attrWords = ExhibitAttrUtils.getAttrWords().getAttrWordsSortedSet();
        %><p><%= localeBean.getLocalisedMessage("common.main.intro",
            nExhibits,
            "<a href=\"" + WebUtils.makeCatPageRRURL(first, WebConsts.F_secondary_generated_XHTML_suffix) +"\">" + WebUtils.hyphenateHTMLText(ExhibitName.getMainWordsComponent(first, attrWords)) + "</a>",
            "<a href=\"" + WebUtils.makeCatPageRRURL(last, WebConsts.F_secondary_generated_XHTML_suffix) +"\">" + WebUtils.hyphenateHTMLText(ExhibitName.getMainWordsComponent(last, attrWords)) + "</a>")
            %></p>
            <% // Insert linebreak for readbility of XHTML.
        }
     
    // If this returns a non-null value
    // then we assume that a (small) thumbnail is available immediately.
    final String exhibitName = WebUtils.getPopularExhibit(dataSource,
                          ExhibitMIME.getParamsByType(ExhibitMIME.ET_JPEG));
    if(exhibitName != null)
        {
        // Get RRURL for small thumbnail.
        final String rrURL = WebUtils.makeThumbnailRRURL(exhibitName, false);
        
        // Get the exhibit immutable computable properties if possible.
        final ExhibitPropsComputable epc = aep.getExhibitPropsComputable(exhibitName);
        final java.awt.Dimension xyDim = (epc == null) ? null : epc.getXyDimensions();
        // Compute what thumbnail dimensions should be...
        final java.awt.Dimension thumbnailXyDim = (xyDim == null) ? null : ExhibitThumbnails.computeThumbnailDimensions(xyDim, false);

%><h2><%= localeBean.getLocalisedMessage("common.main.PopJPEG") %></h2><%
%><a href="<%= WebUtils.makeCatPageRRURL(exhibitName, WebConsts.F_secondary_generated_XHTML_suffix) %>"><%
%><img src="<%= rrURL %>" alt="<%= localeBean.getLocalisedMessage("common.thumbnail") %>"<%
        if(thumbnailXyDim != null)
            {
            %> width="<%= thumbnailXyDim.width %>"<%
            %> height="<%= thumbnailXyDim.height %>"<%
            }
%> /><br /><%
%><%= WebUtils.hyphenateHTMLText(ExhibitName.getFileComponent(exhibitName)) %></a><br />
<% // Insert linebreak for readbility of XHTML.
        }

    // Get a "best" item (semi-randomly).
    final String[] bestEx = HTMLThumbnailInsertGenerators.getBestExhibitSelection(application, 1, Rnd.fastRnd);
    if(bestEx.length > 0)
        {
%><h2><%= localeBean.getLocalisedMessage("common.selection.bestExhibits.title") %></h2><%

        final String en = bestEx[0];

%><a href="<%= WebUtils.makeCatPageRRURL(en, WebConsts.F_secondary_generated_XHTML_suffix) %>"><%

	    final ExhibitPropsComputable epc = aep.getExhibitPropsComputable(en);
		final java.awt.Dimension xyDim = (epc == null) ? null : epc.getXyDimensions();
        final ExhibitMIME.ExhibitTypeParameters exhibitType = (ExhibitMIME.getInputFileType(en));

		// Insert (small) thumbnail if possible...
		// FOR .mobi THIS IS ONLY FOR GIF AND JPEG IMAGES
		final URL exhibitURL = WebUtils.makeExhibitURL(en, request, dataSource);
		final boolean canInline = WebUtils.canInlineInXHTMLPage(exhibitType, request);
		if(canInline)
		    {
		    // Try and show a thumbnail.
		    // Never bother trying to create the tn; speed is of the essence.
		    final ExhibitThumbnails tns = dataSource.getThumbnails(en, false);
		    if((null != tns) && (null != tns.getSmall()))
		        {
		        // Get RRURL for small thumbnail.
		        final String rrURL = WebUtils.makeThumbnailRRURL(en, false);
		
		        // Compute what thumbnail dimensions should be...
		        final java.awt.Dimension thumbnailXyDim = (xyDim == null) ? null : ExhibitThumbnails.computeThumbnailDimensions(xyDim, false);
				
%><img src="<%= rrURL %>" alt="<%= localeBean.getLocalisedMessage("common.thumbnail") %>"<%
		        if(thumbnailXyDim != null)
		            {
		            %> width="<%= thumbnailXyDim.width %>"<%
		            %> height="<%= thumbnailXyDim.height %>"<%
		            }
%> /><br /><%
                }
            }
%><%= WebUtils.hyphenateHTMLText(ExhibitName.getFileComponent(en)) %></a><br />
<% // Insert linebreak for readbility of XHTML.
        }

    // Get a "new" item (semi-randomly).
    final String[] newEx = HTMLThumbnailInsertGenerators.getNewExhibitSelection(application, 1, Rnd.fastRnd);
    if(newEx.length > 0)
        {
%><h2><%= localeBean.getLocalisedMessage("common.selection.newExhibits.title") %></h2><%

        final String en = newEx[0];

%><a href="<%= WebUtils.makeCatPageRRURL(en, WebConsts.F_secondary_generated_XHTML_suffix) %>"><%

	    final ExhibitPropsComputable epc = aep.getExhibitPropsComputable(en);
		final java.awt.Dimension xyDim = (epc == null) ? null : epc.getXyDimensions();
        final ExhibitMIME.ExhibitTypeParameters exhibitType = (ExhibitMIME.getInputFileType(en));

		// Insert (small) thumbnail if possible...
		// FOR .mobi THIS IS ONLY FOR GIF AND JPEG IMAGES
		final URL exhibitURL = WebUtils.makeExhibitURL(en, request, dataSource);
		final boolean canInline = WebUtils.canInlineInXHTMLPage(exhibitType, request);
		if(canInline)
		    {
		    // Try and show a thumbnail.
		    // Never bother trying to create the tn; speed is of the essence.
		    final ExhibitThumbnails tns = dataSource.getThumbnails(en, false);
		    if((null != tns) && (null != tns.getSmall()))
		        {
		        // Get RRURL for small thumbnail.
		        final String rrURL = WebUtils.makeThumbnailRRURL(en, false);
		
		        // Compute what thumbnail dimensions should be...
		        final java.awt.Dimension thumbnailXyDim = (xyDim == null) ? null : ExhibitThumbnails.computeThumbnailDimensions(xyDim, false);
				
%><img src="<%= rrURL %>" alt="<%= localeBean.getLocalisedMessage("common.thumbnail") %>"<%
		        if(thumbnailXyDim != null)
		            {
		            %> width="<%= thumbnailXyDim.width %>"<%
		            %> height="<%= thumbnailXyDim.height %>"<%
		            }
%> /><br /><%
                }
            }
%><%= WebUtils.hyphenateHTMLText(ExhibitName.getFileComponent(en)) %></a><br />
<% // Insert linebreak for readbility of XHTML.
        }

%><%--        


FOOTER
--%><%@ include file="/_common/_XHTMLStdFt.inc.jsp" %>
