<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%-- Relatively simple, single page, HTML-only, non-i18n site, no session by default. --%>
<%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.ads.AdUtils,
            org.hd.d.pg2k.webSvr.ads.AdConsts"
    session="false"
%>
<%
// No cacheing...
// HTTP/1.0 headers.
response.setHeader("Expires", "0");
response.setHeader("Pragma", "no-cache");
// HTTP/1.1 headers.
response.setHeader("Cache-Control", "no-cache, must-revalidate");
%>

<html>
<%-- We won't bother with meta tags since no right-minded search engine will index this anyway with zero expiry time... --%>
<head><title>ZA Pix</title></head>
<body bgcolor="#000000" vlink="#39caff" link="#ff0090" text="#ffffff">
<center>
<img src="logo.jpg" width="212" height="108" alt="ZAPix"> <img src="Sanibona.jpg" width="207" height="97" alt="Sanibona"><br>
<p>Welcome to ZA Pix, a collection of images from and about South Africa.</p>
<p>A random selection of the available images is shown each time you reload.</p>
<p>Click on each thumbnail for more details and a link to the full-size item.</p>

<%-- Having written the header,
       * Flush what we have so far to the user for good responsiveness.
       * Get access to our data source.
       * Get (and cache, at application level) our exhibit selection.
     The first visitor after a Web restart, any exhibit change, or
     a memory crisis, will pay to get the filtering (re)done.
--%>
<% out.flush(); %>
<%@ include file="/_common/_localeBean.inc.jsp" %><%-- Get locale bean set up... --%>
<%@ include file="/_common/_exhibitBean.inc.jsp" %> <%-- Get the dataSource bean set up... --%>
<%-- First stage: select and cache all SA exhibits at application level. --%>
<jsp:useBean id="ZAPixExhibitSet"
             class="org.hd.d.pg2k.webSvr.exhibit.FilterBean"
             scope="application">
    <%-- Slightly crude filter setting! --%>
    <% ZAPixExhibitSet.setExpr(new FilterExpr(null, new BuiltInFilters.filtSimpleSubstringMatch(new String[]{"South-Africa"}))); %>
</jsp:useBean>
<% final int TABLE_EDGE = 3; %>
<%-- Second stage: select a new random set; don't cache the results. --%>
<jsp:useBean id="_rndSet"
             class="org.hd.d.pg2k.webSvr.exhibit.FilterBean"
             scope="request">
    <%-- Slightly crude filter setting! --%>
    <% _rndSet.setExpr(new SortExpr(null, new BuiltInFilters.sortRandomN(new String[]{""+(TABLE_EDGE*TABLE_EDGE)}))); %>
</jsp:useBean>

<%
final List allZAExhibits = ZAPixExhibitSet.select(application);
final List selectedExhibits = _rndSet.select(application, allZAExhibits);
%>
<p><%= allZAExhibits.size() %> exhibits available.</p>

<p><table border="1" align="center">
<% // Show the exhibits in unsorted order for...
final boolean standardThumbnails = true;
final int BORDER_WIDTH = 5;
final int columnWidth = 2*BORDER_WIDTH +
    (standardThumbnails ? ExhibitThumbnails.STD_STATIC_IMAGE_TN_LDIM_PX : ExhibitThumbnails.SML_STATIC_IMAGE_TN_LDIM_PX);
int adsShown = 0; // Number of ads (assumed AdSense AdUnits) shown so far.
for(int row = 0; row < TABLE_EDGE; ++row)
    {
    %><tr><%
    for(int col = 0; col < TABLE_EDGE; ++col)
        {
        %><td align="center" width="<%= columnWidth %>"><%
        final int item = (TABLE_EDGE * row) + col;
        if(item < selectedExhibits.size())
            {
            // If we have enough exhibits, insert this one!
            final String exhibitName = (String) selectedExhibits.get(item);
            final ExhibitStaticAttr esa = dataSource.getStaticAttr(exhibitName);

            // URL of target catalogue page.
            final java.net.URL catPageURL = WebUtils.makeCatPageURL(esa.filePath, WebConsts.F_secondary_generated_HTML_suffix);

//            if(ImageUtils.canInlineInHTMLPage(esa.getType()))
//                {
                // Try and get a thumbnail, which must be an inlineable image.
                final java.awt.Dimension thumbnailXyDim = new java.awt.Dimension();
                final String thumbnailRRURL = WebUtils.makeHTMLInlineImageThumbnailURL(
                    dataSource, exhibitName,
                    standardThumbnails,
                    true, // Make root-relative URL.
                    thumbnailXyDim,
                    false); // Always force thumbnail generation; we need thumbnails!
                if(thumbnailRRURL != null)
                    {
                    %><table border=<%= BORDER_WIDTH %>><tr><td><a href="<%= catPageURL %>"><img src="<%= thumbnailRRURL %>" width="<%= thumbnailXyDim.width %>" height="<%= thumbnailXyDim.height %>" alt="<%= localeBean.getLocalisedMessage("common.thumbnail") %>"<%= WebConsts.TN_IMG_TAG_EXTRA_ATTR %>></a></td></tr></table><br /><%
                    }
                else if(AdConsts.AD_SUPPORT && (adsShown++ < AdConsts.ADSENSE_MAX_ADUNITS))
                    {
                    // We have no thumbnail to show and have not already shown our ad quota,
                    // so we insert an ad above the link to the picture...
                    %>
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_color = "000000";
google_ad_width = 250;
google_ad_height = 250;
google_ad_format = "250x250_as";
google_ad_channel ="4801438407";
google_color_link = "FFFFFF";
google_color_text = "CCCCCC";
google_color_border = "333333";
google_color_bg = "000000";
google_color_url = "999999";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
<br />
<br />
                    <%
                    }
                else
                    {
                    %>[no thumbnail]<br /><%
                    }
//                }

            // Compute the short (file-component-only) name.
            final String shortName = ExhibitName.getFileComponent(exhibitName);

            %><a href="<%= catPageURL %>"><font size="-1"><%= TextUtils.sanitiseForXML(shortName, 40, true) %></font></a><%
            }
        else { %><br /><% }
        %></td><%
        }
    %></tr><%
    }
%>
</table></p>

<%-- Show trailing AdLinks however many AdUnits we may have shown. --%>
<% if(AdConsts.AD_SUPPORT) { %>
<script type="text/javascript"><!--
google_ad_client = "pub-4667114163381926";
google_alternate_color = "000000";
google_ad_width = 200;
google_ad_height = 90;
google_ad_format = "200x90_0ads_al";
google_ad_channel ="";
google_color_link = "FFFFFF";
google_color_text = "CCCCCC";
google_color_border = "333333";
google_color_bg = "000000";
google_color_url = "999999";
//--></script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>
<% } %>

</center>
</p><br /><hr width="10%" align="left"><p><small>All images are supplied by <a href="http://gallery.hd.org/" target="_top">DHD Multimedia Gallery</a>. <br />All images are copyright their <a href="http://gallery.hd.org/terms.html" target="_top">respective authors</a>. <br />Server time: <%= new Date() %>.</small></p>
</body>
</html>
