<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<%--
Opening page for upload of exhibits from contributors.
Simple-ish, safe-ish, definitely ugly!
We verify the user's ID and hold it in the session.
We collect the exhibit properties in the session too,
which makes more than one upload at once by the user impossible.
--%>
<%@ page
    import="java.util.*,
            org.hd.d.pg2k.svrCore.*,
            org.hd.d.pg2k.svrCore.props.*,
            org.hd.d.pg2k.webSvr.exhibit.*,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.upload.*,
            java.io.File,
            org.hd.d.pg2k.svrCore.datasource.ExhibitDataFileSource,
            org.hd.d.pg2k.svrCore.MIME.ExhibitMIME,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts,
            org.hd.d.pg2k.svrCore.uploader.UploaderConsts"
    session="true"
%>
<%@ include file="/_common/_localeBean.inc.jsp" %><%-- Get locale bean set up... --%>
<%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up... --%>
<%-- Field name used to indicate a log out. --%>
<%! private static final boolean USE_ACCEPT_FIELD = true; %><%-- Try to restrict upload type. --%>
<%
    // Get the exhibit properties; never null.
    final AllExhibitProperties aep = dataSource.getAllExhibitProperties(-1);

    // Make this page cacheable only for a limited time..
//    response.setHeader("Cache-Control",
//        "max-age=" + (UploadConsts.UPLOAD_PAGE_EXPIRY_MS/1000));
//    response.setDateHeader("Expires",
//        System.currentTimeMillis() + UploadConsts.UPLOAD_PAGE_EXPIRY_MS);

    // Make this page uncacheable else
    // the browser may simply go on using the last value it got.
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");
    response.setHeader("Expires", "0");

%>
<html>
<head>
<title>Exhibit Upload</title>
<meta name="robots" content="noindex,nofollow">
</head>
<body bgcolor="white">
<h1>Exhibit Upload</h1>
<p>(<font color=red>News: please try out our <a href="<%= WebConsts.EXT_MSG_BOARD_URL %>">new (experimental, ie what Google would call "beta"!) message board</a>.
This one is free and took 5 minutes to set up, but if it seems useful
then I will extend its use.</font>)</p>
<p>

<%
    // We recheck each time if the upload directory is available,
    // since it might be transiently unavailable, for example, at boot time.
    final String uploadDirS = LocalProps.getUploadDir();
    if((uploadDirS == null) || !(new File(uploadDirS)).isDirectory())
        {
        // If no upload directory, uploads are disabled.
        %>
<p>Uploads are disabled for this system, sorry.  [<%= new Date() %>]</p>
</body></html>
        <%
        return;
        }
    if(LocalProps.getUploadMaxBytesTotal() <= 0)
        {
        // If no upload space, uploads are disabled.
        %>
<p>Uploads are disabled for this system (no space), sorry.</p>
</body></html>
        <%
        return;
        }
    if(!Boolean.FALSE.equals(dataSource.isSlave()))
        {
        // If not a master then we can't do an upload.
        %>
<p>You are not logged onto the master system,
   so you cannot do an upload, sorry.</p>
</body></html>
        <%
        return;
        }

    // Try and force output as the next step may take a while.
    out.flush();

    // Collect list of all files currently in upload area.
    final AllExhibitImmutableData aeidUploaded;
    try {
        aeidUploaded = ExhibitDataFileSource._getAllExhibitImmutableData(uploadDirS, -1L, false);
        }
    catch(Exception e)
        {
        %>
<p>Sorry, uploads are not currently possible.
   Please contact the maintainer.</p>
</body></html>
        <%
        e.printStackTrace();
        return;
        }

    %>

<%-- Get the to-be-uploaded-exhibit info (creating it if need be)... --%>
<jsp:useBean id="uib"
             class="org.hd.d.pg2k.svrCore.uploader.UploadInfoBean"
             scope="session" />
<%-- Give the bean context to validate its inputs. --%>
<% uib.setAep(aep); %>
<% uib.setUploadAeid(aeidUploaded); %>
<%-- Set its attributes from form parameters as far as we can. --%>
<jsp:setProperty name="uib" property="*" />
<%-- Override/set the exhibit author name to be the logged-in user. --%>
<jsp:setProperty name="uib" property="author" value="<%= String.valueOf(session.getAttribute(UploaderConsts.USERID_FIELD_NAME)) %>" />
<%-- Give the bean a chance to sanitise the name. --%>
<% uib.tryToSanitise(); %>

<%--

Short-cut here for when uploading a sequence of exhibits,
so that the user does not have to scroll through the whole page
to do the next upload.

If everything seems tickity-boo then offer the upload box at the page top.

We avoid this if the user is trying to log out!

--%><%
    Object userIDo = session.getAttribute(UploaderConsts.USERID_FIELD_NAME);
    // We assume that if the author initials in the session
    // then the user has been validated...
    if((null == request.getParameter(UploaderConsts.LOGOUT_FIELD_NAME)) &&
       (userIDo instanceof String) &&
       uib.enoughValidUniqueInfo())
        {
        // Try to compute the broad MIME type of what we expect to upload.
        // We only attempt to enforce the first component because not all
        // the MIME types are agreed on in detail by everyone.
        String acceptMIMEType = null;

        if(USE_ACCEPT_FIELD)
            {
            final String extn = uib.getSuffix().substring(1);
            final ExhibitMIME.ExhibitTypeParameters etp =
                ExhibitMIME.isValidInputExhibitNameExtension(extn);
            if(etp != null)
                {
                String mt = etp.mimeType;
                acceptMIMEType = mt.substring(0, mt.indexOf('/') + 1) + '*';
                }
            }
%>
<table border=5>
<tr><td>
<p>Your suggested name is <strong><%= uib.getFullName() %></strong>.</p>
    <%
     if(uib.getDescription().length() > 0)
         { %><p>Description:<strong> <%= uib.getDescription() %></strong>.</p><% }

     final String newWords = uib.getNewMainWords();
     if(newWords.length() != 0)
         {
         %><p><font color="red">WARNING:</font> some of the words in the name you have suggested appear not to exist
              in any exhibits already in the Gallery: <font color="red"><%= newWords %></font>.</p>
           <p>Please check speling and capITALisation eg "South Africa" rather than "sarf africa".</p>
           <p>The eariler words in your name are more important; the first word is especially important.</p><%
         }
    %>
<form action="upload2.jsp" method="post" enctype="multipart/form-data">
<p><strong>Please locate the exhibit file and press Upload:
<input type="file"
       <%= (USE_ACCEPT_FIELD && (acceptMIMEType != null))? ("accept=\"" + acceptMIMEType + "\"") : "" %>
       size="20" maxlength="<%= ExhibitName.MAX_NAME_LENGTH %>" name="<%= UploaderConsts.exhibitFile %>">
<input type="submit" value="Upload">
</strong></p>
</form>
<p />
</td></tr>
</table>
<%
        }
%>

<p>This page allows you to upload exhibit files.
   (Please don't attempt to do more than one upload at once!)
   A final inspection may be done by a human before your uploaded files
   get installed.</p>
<p>This upload system is still crude and incomplete,
   and your comments on it are welcome.</p>
<p>You may want to have a copy of the catalogue search page to hand;
   <a href="/_cat/doHTMLSearch.jsp" target="<%= UploaderConsts.searchWindow %>">click here
   to bring one up in a separate window</a>.
<p>You may find it useful to have to hand a description of how
   <a href="http://gallery.hd.org/naming.html" target="_blank">names work in the Gallery</a>,
   and even <a href="http://gallery.hd.org/scanningPrints.html" target="_blank">suggestions for scanning that we use</a>.

<%
    // If the user has asked to log out,
    // then drop their credentials, at least for this upload mechanism.
    if(request.getParameter(UploaderConsts.LOGOUT_FIELD_NAME) != null)
        {
        // Forget about this userID.
        session.setAttribute(UploaderConsts.USERID_FIELD_NAME, null);
        // We don't invalidate the entire session.
        }

    // If no valid user ID is held,
    // EITHER:
    //   * We expect to see the ID in the fields coming in to this
    //     page-pull now, or
    //   * We demand one now with verification details.
    //
    // We are initially very wary about what we retrieve from
    // the session in case (for example) it has been persisted
    // and restored and the code requirements have changed.
    if((userIDo == null) ||
       !(userIDo instanceof String) ||
       !ExhibitName.validAuthorSyntax((String) userIDo) ||
       (request.getParameter(UploaderConsts.LOGOUT_FIELD_NAME) != null))
        {
        // Did we just receive valid user credentials in the arguments?
        // We insist on:
        //  1) A syntactically-valid author name.
        //  2) The author being already extant in the Gallery.
        //  3) A valid-length password being supplied.
        //  4) The password actually being correct!
        final String userIDParam = request.getParameter(UploaderConsts.USERID_FIELD_NAME);
        final String userPass = request.getParameter(UploaderConsts.PASSWD_FIELD_NAME);
        if((userIDParam != null) && // ID supplied.
           ExhibitName.validAuthorSyntax(userIDParam) && // Valid author syntax.
           (aep.getAuthorExhibitCounts().get(userIDParam) != null) && // Extant.
           (userPass != null) && // Must be a password and a suitable length.
               (userPass.length() >= CoreConsts.MIN_PASSWORD_LEN) &&
               (userPass.length() <= CoreConsts.MAX_PASSWORD_LEN) &&
            SimplepassProps.isAuthorUploadPasswordCorrect(userIDParam, userPass))
            {
            /* Store the ID in the session and continue. */
            userIDo = userIDParam;
            session.setAttribute(UploaderConsts.USERID_FIELD_NAME, userIDo);
            }

        // If userIDo is null we still do not have valid credentials,
        // and need to force a login.
        if(userIDo == null)
            {
            %>
<h2>Please Log in</h2>
<p>I need to know who you are in order to file your exhibits correctly.</p>
<p>Please fill in the information below to log in.  You must
   have (at least temporary) cookies enabled else you will keep coming back
   to this page.</p>
<form action="upload.jsp" method="post">
<p><table border="1">
<tr><th>Your login ID:</th><td><input type="text" name="<%= UploaderConsts.USERID_FIELD_NAME %>" size="<%= ExhibitName.MAX_AUTH_INITIALS_LENGTH %>" maxlength="<%= ExhibitName.MAX_AUTH_INITIALS_LENGTH %>"></td></tr>
<tr><th>Your password:</th><td><input type="password" name="<%= UploaderConsts.PASSWD_FIELD_NAME %>" size="<%= CoreConsts.MAX_PASSWORD_LEN %>" maxlength="<%= CoreConsts.MAX_PASSWORD_LEN %>"></td></tr>
<tr><td colspan="2"><input type="submit" value="Log in"></td></tr>
</table>
</form>
</body>
</html>
            <%
            return;
            }
        }

    // Make the user (author) ID available.
    final String userID = (String) userIDo;
    userIDo = null; // Help GC.

    // Show who we think that the user is.
    %><p>You are: <strong><%= userID %></strong>.</p>

<form action="upload.jsp" method="post">
<input type="hidden" name="<%= UploaderConsts.LOGOUT_FIELD_NAME %>" value="true"/>
<p>If you want to <font color="red">log out</font>, press this button: <input type="submit" value="Log out">.</p>
</form>


<h2>Space Available</h2>
<p>The maximum space allowed for uploads today is
   <%= LocalProps.getUploadMaxBytesPerUser() %> bytes.</p>

<p>Checking files already uploaded...</p>
<p>(Computing stats...)</p><% out.flush();

    // Compute size consumed in total and by each user.
    final long uploadedTotal = aeidUploaded.computeFileSpaceBytes(null);
    final long uploadedByThisUser = aeidUploaded.computeFileSpaceBytes(userID);
    final long uploadSpaceLeft = Math.max(0,
        Math.min(LocalProps.getUploadMaxBytesPerUser() - uploadedByThisUser,
                 LocalProps.getUploadMaxBytesTotal() - uploadedTotal));
%>
<p>You have uploaded <%= uploadedByThisUser %> bytes of exhibit,
   currently waiting to be accepted by the maintainer.
   You have <%= uploadSpaceLeft %> bytes of upload space left.</p>

<% out.flush(); %><%-- // Try and force output as the next step may take a while. --%>


<h2>Set the Exhibit Properties</h2>

<p>Fill in the properties that you require for the exhibit,
and press the <em>Save</em> button.  You must at least fill in
or change values for any item whose row is highlighted in red.</p>

<p>
<% uib.setCommonValuesForUnsetFields(); %><%-- Guess some of the blanks! --%>
<form action="upload.jsp" method="post">
<table border="1">
<%! private static final int DEFAULT_ENTRY_TEXT_BOX_WIDTH = 64; %>
<tr bgcolor="yellow"><th>Exhibit Attribute</th><th>Value</th></tr>
<%! private static final int ENTRY_BOX_WIDTH = Math.min(DEFAULT_ENTRY_TEXT_BOX_WIDTH, ExhibitName.MAX_NAME_LENGTH); %><%-- Width of general text-entry fields in characters. --%>
<%! private static final int ENTRY_BOX_DEPTH = (ExhibitName.MAX_NAME_LENGTH + ENTRY_BOX_WIDTH - 1) / ENTRY_BOX_WIDTH; %>
<tr<%if(uib.getCategory().length()==0){%> bgcolor="red"<%}%>><th>Exhibit category:</th><td><select name="category"><%= uib.makeCategorySelectBody(localeBean) %></select></td></tr>
<tr<%if(uib.getMainWords().length()==0){%> bgcolor="red"<%}%>><th>Main words:</th><td><textarea name="mainWords" rows="<%= ENTRY_BOX_DEPTH %>" cols="<%= ENTRY_BOX_WIDTH %>" wrap="virtual"><%= uib.getMainWords() %></textarea><br>(One or more words describing the exhibit, most important first.  If you put numbers or attribute words at the end I may move them or rudely delete them!)</td></tr>
<tr><th>Attribute words:</th><td><input type="text" name="attributeWords" size="<%= ENTRY_BOX_WIDTH %>" maxlength="<%= ExhibitName.MAX_NAME_LENGTH %>" value="<%= uib.getAttributeWords() %>"><br>(Zero or more attribute words, such as "tweaked" and "mono".  Use just "-" to remove all attribute words.  The list of acceptable attribute words in current use is: <i><%= uib.getInUseAttrWordListAsString(true) %></i>. Those not in current use (possibly to be avoided) but legal are : <i><%= uib.getInUseAttrWordListAsString(false) %></i>.)  I will rudely delete any invalid words you put in this part; sorry!</td></tr>
<tr><th>Number in series:</th><td><input type="text" name="number" size="4" maxlength="8" value="<%= uib.getNumber() %>"> (0 is the default value, and will not be inserted into the exhibit name in the Gallery.)</td></tr>
<tr><th>Author:</th><td><%= uib.getAuthor() %></td></tr>
<tr<%if(uib.getSuffix().length()==0){%> bgcolor="red"<%}%>><th>Exhibit type and file suffix:</th><td><select name="suffix"><%= uib.makeSuffixSelectBody() %></select></td></tr>
<%! private static final int DESC_ENTRY_BOX_WIDTH = Math.min(DEFAULT_ENTRY_TEXT_BOX_WIDTH, CoreConsts.DESCRIPTION_MAX_CHARS); %><%-- Width of general text-entry fields in characters. --%>
<%! private static final int DESC_ENTRY_BOX_DEPTH = Math.min(10, (CoreConsts.DESCRIPTION_MAX_CHARS + DESC_ENTRY_BOX_WIDTH - 1) / DESC_ENTRY_BOX_WIDTH); %>
<tr><th>Exhibit description:</th><td><textarea wrap="virtual" name="description" cols="<%= DESC_ENTRY_BOX_WIDTH %>" rows="<%= DESC_ENTRY_BOX_DEPTH %>"><%= TextUtils.escapeHTMLMetaChars(uib.getDescription()) %></textarea><br>Optional plain ASCII description of the exhibit, possibly with HTML markup, maximum <%= CoreConsts.DESCRIPTION_MAX_CHARS %> characters.  <strong>Use "-" to clear an entry.</strong>
                                 <%
                                 if(uib.getDescription().length() > 0)
                                     { %><p align=center><strong>Your description may look like this on-screen:</strong> <%= uib.getDescription() %></p><% }
                                 %>
                                 </td></tr>

<tr><th>Save the exhibit data:</th><th><input type="submit" value="Save Info"></th></tr>
</table>
</form>
</p>
    <%
        final String newWords = uib.getNewMainWords();
        if(newWords.length() != 0)
            {
            // Do warning about unrecognised words...
            %><%= localeBean.getLocalisedMessage("uploader.newWordsWarning", newWords) %><%
            }


        // Now note any show-stopper problems to the user...
        if(!uib.enoughInfo())
            {
            %><p><%= localeBean.getLocalisedMessage("uploader.notEnoughInfo") %></p><%
            }
        else if(!uib.canMakeValidName())
            {
            %><p><%= localeBean.getLocalisedMessage("uploader.notValidName") %></p><%
            }
        else if(!uib.nameUniqueInMainDatabase())
            {
            %><p><%= localeBean.getLocalisedMessage("uploader.nameExistsLive", uib.getFullName()) %></p><%
            }
        else if(!uib.nameUniqueInAuxDatabase())
            {
            %><p><%= localeBean.getLocalisedMessage("uploader.nameExistsUpload", uib.getFullName()) %></p><%
            }

        // We only allow exhibit upload if the user has provided enough info
        // to correctly save the exhibit,
        // and everything else was OK...
        else if(uib.enoughValidUniqueInfo())
            {
    %>

<p><%= localeBean.getLocalisedMessage("uploader.nameOK", uib.getFullName()) %></p>

<h2>Upload the File</h2>

<p>When you have saved the exhibit info that you want to,
you can actually upload the file into the holding area for
the Gallery maintainer to examine.</p>

<p>ONLY START THE UPLOAD <strong>AFTER</strong> YOU HAVE SAVED YOUR LAST SET OF
CHANGES TO THE INFORMATION, ELSE THOSE LATEST CHANGES WILL BE LOST.</p>

<%
            // Try to compute the broad MIME type of what we expect to upload.
            // We only attempt to enforce the first component because not all
            // the MIME types are agreed on in detail by everyone.
            String acceptMIMEType = null;

            if(USE_ACCEPT_FIELD)
                {
                final String extn = uib.getSuffix().substring(1);
                final ExhibitMIME.ExhibitTypeParameters etp =
                    ExhibitMIME.isValidInputExhibitNameExtension(extn);
                if(etp != null)
                    {
                    String mt = etp.mimeType;
                    acceptMIMEType = mt.substring(0, mt.indexOf('/') + 1) + '*';
                    }
                }
%>
<form action="upload2.jsp" method="post" enctype="multipart/form-data">
<p>Please locate the exhibit file and press Upload:
<input type="file"
       <%= (USE_ACCEPT_FIELD && (acceptMIMEType != null))? ("accept=\"" + acceptMIMEType + "\"") : "" %>
       size="20" maxlength="<%= ExhibitName.MAX_NAME_LENGTH %>" name="<%= UploaderConsts.exhibitFile %>">
<input type="submit" value="Upload">
</p>
</form>
    <%
            }
    %>

</body>
</html>
