<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

Contact sheet of "best" exhibits.

--%><%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            java.util.Arrays,
            java.util.Random,
            org.hd.d.pg2k.webSvr.util.*,
            org.hd.d.pg2k.webSvr.exhibit.DataSourceBean"
    session="false"
%><%--

TIMING, LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_SetPageStartTime.inc.jsp" %><%-- Note start time if not already done for standard footer.
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...


EXPIRY/CACHEING
Force a relatively short expiry always for this potentially-"fresh" page, even for spiders.
--%><%
    response.setHeader("Cache-Control",
            ((request.getSession(false) == null) ? "public," : "private,") +
            "max-age="+(WebConsts.DEFAULT_PAGE_CACHE_MS/2000));
    response.setDateHeader("Expires", System.currentTimeMillis() +
            WebConsts.DEFAULT_PAGE_CACHE_MS/2);
%><%--


HEADER
--%><%
    final Breadcrumbs crumbs = new Breadcrumbs();
    crumbs.append(new Breadcrumbs.Breadcrumb(localeBean.getLocalisedMessage("common.main.VirtualCollections"), WebConsts.VIRTUAL_COLLECTIONS_ROOT));
    request.setAttribute(WebConsts.STDHDR_ATTR_NAME_BREADCRUMBS, crumbs);
%><%--
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, localeBean.getLocalisedMessage("common.selection.newExhibits.title")); %>
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--


BODY
--%><h2><%= localeBean.getLocalisedMessage("common.selection.newExhibits.title") %></h2>
<p>The newest exhibits in the Gallery.</p>
<%
    final long stopBy = System.currentTimeMillis() + (siteIsBusy ? -1 : (WebConsts.MAX_PG_DOWNLOAD_MS/2));
    %><%! private static final DataSourceBean.AEPLinkedKey newExhibitCacheKey = new DataSourceBean.AEPLinkedKey("newExCacheKey"); %><%
    final DataSourceBean dsb = dataSource;
    // We cache the "new" exhibits contact sheet once complete
    // (eg we assume that thumbnails don't go away once we have them locally).
    String contactSheet;
    if(null == (contactSheet = (String) dsb.getAEPLinkedValue(newExhibitCacheKey)))
        {
        // Assume that we can use (nearly) the full display width for the contact sheet
        // to minimise scrolling with large sheets.
        contactSheet = HTMLThumbnailInsertGenerators.generateGenericContactSheetHTML(
                (PageSkinUtils.GENERIC_WIDTH_PX*9)/10, // About 90% to match other tables...
                Arrays.asList(HTMLThumbnailInsertGenerators.getNewExhibitSelection(application,
                    WebConsts.SINGLE_PAGE_CONTACT_SHEET_TN_COUNT, // Show a lot on one page...
                    null)), // Pick newest exhibits...
                null, // No "special" colour.
                null, // No "special" exhibit.
                stopBy,
                dsb);

        // If apparently incomplete then we don't cache the result
        // but instead just use what we computed
        // and hope to compute the full value and cache it next time.
        if(!contactSheet.endsWith(HTMLThumbnailInsertGenerators.CS_INCOMPLETE))
            { dsb.putIfAbsentAEPLinkedValue(newExhibitCacheKey, contactSheet); }
        }
    %><center><p><%= contactSheet %></p></center><%
%><%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %>
