<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            org.hd.d.pg2k.svrCore.props.LocalProps,
            org.hd.d.pg2k.svrCore.location.LoadBalancingUtils,
            org.hd.d.pg2k.svrCore.location.GeoUtils,
            java.net.InetAddress,
            org.hd.d.pg2k.svrCore.Tuple,
            java.net.UnknownHostException,
            org.hd.d.pg2k.svrCore.VarTools,
            org.hd.d.pg2k.svrCore.vars.SystemVariables,
            org.hd.d.pg2k.svrCore.AddrTools,
            org.hd.d.pg2k.webSvr.util.WebUtils,
            org.hd.d.pg2k.svrCore.location.LoadBalancingUtils,
            org.hd.d.pg2k.webSvr.util.WebConsts"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "Resources"); %><%-- // FIXME: need i18n.
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Code Download, Snippets and Resources</h1>

<p>A raw snapshot of code for this project can be found in <a href="/src.snapshot.tar.bz2">BZIP2-ed GNU TAR format</a>; please read LICENCE.txt.</p>

<p>There is also <a href="/_javadoc/index.html">javadoc</a> available online.</p>

<p>You might also look at the <a href="/todo.jsp">to-do</a> list
   <%-- or the <a href="todo-loading.jsp">list of material waiting to be loaded and named</a> --%>
   if you are feeling very bored!</p>

<p>You can see <a href="/naming.html">how we name exhibits</a> in the Gallery.</p>

<p>The AI exhibit scorer work has been <a href="/_AI/index.jsp">revived</a>.</p>

<p>Current users worldwide (including spiders, hotlinkers, etc) approximately:
    <%= VarTools.generateSimpleNumberStats(dataSource, SystemVariables.ThroughputMonitorFilter_CLIENT_COUNT, -1, "#,###u").getSum().intValue() %></p>

<p>Current (human, sticky) visitors worldwide approximately:
    <%= VarTools.generateSimpleNumberStats(dataSource, SystemVariables.ThroughputMonitorFilter_STICKY_CLIENT_COUNT, -1, "#,###u").getSum().intValue() %></p>

<p>Projected yearly unique (human, sticky) visitors:
    <%= VarTools.generateSimpleNumberStats(dataSource, SystemVariables.ThroughputMonitorFilter_YEARLY_UNIQUE_VISITORS, -1, "#,###u/y").getSum().intValue() %></p>

<p>Location/mirror info:
<ul>
<li>Your apparent IP address is: <%= request.getRemoteAddr() %></li>
<%
    final String mirrorTag = LocalProps.getMirrorTag();
    if(mirrorTag != null)
        { %><li>You are on mirror: <%= mirrorTag %></li><% } %>
<%
    InetAddress clientIP = null;
    String clientLocation = null;
    try {
        clientIP = InetAddress.getByName(request.getRemoteAddr());
        %><li>Your apparent host name (if any) is: <%= AddrTools.doReverseLookup(clientIP, true) %></li><%
        clientLocation = GeoUtils.getRegionByAddress(clientIP, false);
        }
    catch(UnknownHostException e) { /* Cannot parse client address... */ }
    // Check that we have a real country code or region tag (eg not a numeric address).
    if((clientLocation != null) && (clientLocation.length() >= 2) &&
            ((clientLocation.charAt(0) < '0') || (clientLocation.charAt(0) > '9')))
        { %><li>Your apparent country/region is: <%= clientLocation %></li><% } %>
<li>Currently available mirrors (highest bandwidth first) are: <%= LoadBalancingUtils.orderMirrorTagsBestBandwidthFirst(LoadBalancingUtils.getActiveMirrors(dataSource, true)) %></li>
<% final String bestMirror = WebUtils.chooseMirrorHostToBalanceLoad(request, dataSource); %>
<li>Your best mirror is probably: <a href="http://<%= bestMirror %>/"><%= bestMirror %></a></li>
</ul>
</p>

<p>
HostIP.info thinks that your country/flag is:
<A HREF="http://www.hostip.info/"><IMG SRC="http://www.hostip.info/api/flag.GIF" BORDER="0" ALT="IP Address Lookup"></A>.<br />
Is this wrong? If so, <a href="http://www.hostip.info/correct.html?spip=<%= request.getRemoteAddr() %>" target="_top">please make a correction</a>.
</p>

<p>Internet Traffic Report (live):
    <A HREF="http://www.InternetTrafficReport.com/"> <IMG ALT="The Internet Traffic Report monitors the flow of data around the world. It then displays a value between zero and 100. Higher values indicate faster and more reliable connections." SRC="http://www.InternetTrafficReport.com/itr-clean.gif" WIDTH="125" HEIGHT="89" BORDER="0"> </A>.
    </p>

<p>Alexa ranking info for this site:<br />
   <SCRIPT type='text/javascript' language='JavaScript' src='http://xsltcache.alexa.com/traffic_graph/js/g/a/1y?&u=http%3A%2F%2Fgallery.hd.org%2F'></SCRIPT>
   </p>

<p>DNS info about <a href="http://www.dnsreport.com/tools/dnsreport.ch?domain=hd.org">the Gallery zone</a>...</p>

<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--


--%>
