<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%><%--

    TERMS-AND-CONDITIONS PAGE.

    The official URL of this page is:

        http://gallery.hd.org/terms.html

--%><%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            org.hd.d.pg2k.svrCore.AllExhibitProperties,
            org.hd.d.pg2k.svrCore.AddrTools,
            org.hd.d.pg2k.svrCore.props.GenProps,
            org.hd.d.pg2k.webSvr.util.*,
            java.util.*,
            java.net.InetAddress"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "Terms and Conditions"); %><%-- FIXME: needs i18n
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>

<h2>Executive Summary</h2>

<ol>
<li>If you use our stuff, please link to us to help other people find us.
<li>If you make money from using our stuff, share it with us!
<li>Don't sell or steal our stuff, or be nasty to us.
<li>Thanks very much to our contributors!
</ol>

<h2>The Small Print</h2>

The creators of the exhibits can be identified by the capitalised initials
between the last dash (`-') and the following dot (`.'), eg in:
    <samp>example-picture-2-DHD.jpg</samp>
the photographer is DHD, ie Damon Hart-Davis.
<p>
Gallery contributors/authors/photographers:
<ul>
<%
    out.flush(); // Checking if user is a SPAMmer may take a while...

    // WE DON'T SHOW EMAIL ADDRESSES TO:
    //  1) KNOWN SPAMMERS/COMPROMISED MACHINES (to hinder harvesting by SPAMmers).
    //  2) KNOWN SPIDERS/BOTS (to avoid emails ending up in their cached pages for later harvesting by SPAMmers).

    final GenProps gp = dataSource.getGenProps(-1);
    final boolean dontShowMail = WebUtils.requestProbablyFromSpider(request) ||
        (null != AddrTools.isAddrBlackholed(gp.getDNSRBLs(), InetAddress.getByName(request.getRemoteAddr()), false));

    final AllExhibitProperties aep = dataSource.getAllExhibitProperties(-1);
    final Map am = aep.getAuthorExhibitCounts();
    final SortedSet ssa = new TreeSet(am.keySet());
    for(final Iterator it = ssa.iterator(); it.hasNext(); )
        {
        final String auth = (String) it.next();
        final GenProps.AuthData ad = gp.getAuthData(auth);
        %><li><%
        final String h = WebConsts.VIRTUAL_COLLECTIONS_BYAUTHOR_ROOT + auth + '/';
        %><a href="<%=h%>"><%= auth %></a> <i>(<%= am.get(auth) %>)</i><%-- AUTH (count) --%><%

        // Add information from author database if present.
        if(ad != null)
            {
            // Insert real name (bold/strong); should always be available.
            %>: <strong><%= ad.name %></strong><%

            // Insert home-page link if available.
            if(ad.www != null)
                { %>, <a href="<%= ad.www %>" target="_top"><%= ad.www %></a><% }

            // Insert email link if available.
            if(!dontShowMail && (ad.email != null))
                { %>, <a href="mailto:<%= ad.email %>"><%= ad.email %></a><% }

            // End sentence...
            %>.<%

            // Insert description sentence if available.
            if(ad.desc != null)
                { %> <%= ad.desc %><% }
            }

        %></li><%-- Insert line-break here for clarity. --%>
<%
        }
%>
</ul>
<p>
For full-quality copies of more of Adam Hart-Davis' photos (not free!), please contact the
<a href="http://www.sciencephoto.com/" target="_top">Science Photo Library</a> in London
by <a href="mailto:research@sciencephoto.co.uk">email</a> or 'phone +44 (0) 20 7432 1100.
<p>
<center>
To see who has contributed what, see the collections organised
<a href="/_virtual/ByAuthor/">by author</a>.<p>
</center>
<p>
Thanks are also due to the many people who have contributed in other ways
to the Gallery such as through <a href="/_mon/pleasegive.jsp">donations</a>
and to the <a href="/thanks.jsp">code, translations, etc</a>.
<p>
The creators of these Gallery images, sounds and other multimedia items
retain copyright, but grant you the following non-exclusive rights to use them
for any reasonable commercial or non-commercial purpose, providing:
<ul>
<li>You do not pass this work off as your own or redistribute or resell it.
<li>You do not systematically download or copy any significant fraction
of the Gallery without <a href="mailto:d@hd.org">my</a> express
advance permission (for reasons of bandwidth and enforcing the
previous condition).
<li>You acknowledge the author, including in derivative works,
if possible with a caption of the form:
<blockquote>
    <tt><var>Author Name</var>/DHD Multimedia Gallery</tt>
</blockquote>
You might improve this with a link to the lobby of the Gallery at
<a href="http://gallery.hd.org/">http://gallery.hd.org/</a>
(without a <code>rel="nofollow"</code> attribute if possible),
which is the "official" top/entrance URL for the Gallery.
(Note that other pages may be renamed or renumbered at any time,
so linking to them is unreliable.)
<li>You bear any liability arising from use of the Gallery exhibits.
<li>You do not use the material in the Gallery to harm or attempt to
harm or embarrass the author(s), Gallery or associated people or organisations.
<li>You make an effort to contribute similar material of your own creation
to the Web under similar terms, if and when you can.
</ul>
<p>
<strong>Only the catalogued multimedia files
listed in the body of each page by name are available under these terms. All
rights are reserved on all other content of the pages.</strong>
As an exception to this, items marked as contributed by ``ANON'' and
that mention that they are from a PD (public-domain) distribution,
may be freely redistributed (eg some of the sound clips) as that is how
they were obtained.
<p>
We would be very grateful if you would consider a
<a href="/_mon/pleasegive.jsp">donation towards our running costs</a>
if you use one of our exhibits!
<p>
There are some other <a href="/resources.jsp">resources</a> available
that you may wish to use.
<p>
Thank you for taking the time to read and understand these conditions.
<p>
And <a href="/thanks.jsp">thanks</a> once again to our contributors for making
this whole gallery possible in the first place!
<p>
Damon<br />
<a href="mailto:d@hd.org">d@hd.org</a>
<p>
<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--


--%>
