<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            org.hd.d.pg2k.webSvr.util.WebConsts"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, localeBean.getLocalisedMessage("common.ThankYou")); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Thanks</h1>

<p>Here I list some of the people without whose support the Gallery would
   not have happened.  If I've missed out anyone, I apologise.</p>

<p>First and foremost the contributors, of course.  I initially had the idea
   to put up some of Adam Hart-Davis' (AJHD) slides that were not quite
   good enough for commercial sale but excellent for Web use.  He said I
   could scan a few hundred that he would otherwise throw away.  Those images,
   and many since, were the genesis of the Gallery and have proven very
   popular.</p>

<p>Of course, while I was waiting for Adam's slides to get scanned, I saw a
   bargain in a photography shop window and got hooked myself to the tune of
   many thousands of (much less good than Adam's) photos in the Gallery.</p>

<p>Many other friends have been incredibly generous and let me put up their
   images and other multimedia files too; what a wonderfully kind lot you
   are out there!</p>

<p>Some people have helped me with elements of the code, and some bits are
   derived from open-source such as Apache code.</p>

<p>I can't possibly cover all the items purloined/borrowed, but a few
   are listed here.  Also the code may contain references to sources.</p>

<p>Thanks to <a href="http://jakarta.apache.org/tomcat/">Apache</a>
   for the example compression filter code
   (and a first-rate development and deployment platform).</p>

<p>Thanks to <a href="mailto:bmarchal@pineapplesoft.com">Beno&icirc;t Marchal</a>
   for example code to handle multipart/form-data HTTP POST data.</p>

<p>Thanks to Muhammad Arif Raza for his help with various parts of the code,
   including i18n support.</p>

<p>The Gallery uses DNS code from <a href="http://www.dnsjava.org/" target="_top">dnsjava.org</a>;
   thanks!</p>

<p>The Gallery uses EXIF-extraction code from <a href="http://www.drewnoakes.com/code/exif/" target="_top">Drew Noakes</a>;
   thanks!</p>

<p>A big thank you to ej-Technologies for donating me a free licence 2003/09/10
   for their <a href="http://www.ej-technologies.com/products/jprofiler/overview.html">JProfiler</a><sup>tm</sup>
   product with which I tune and debug the Gallery.  Remaining bugs are my
   fault of course!

<p>And of course where would I be without testing tools such as
   <a href="http://www.junit.org/" target="_top">jUnit</a>,
   Clover, HttpUnit, etc?</p>

<p>I wish particularly to thank Bruno Girin (BG) for being an enthusiastic
   and steadfast contributor of pictures, i18n French-language support and
   bonhomie thoughout the duration of this project.</p>

<p><strong>Damon Hart-Davis</strong><br>
   Kingston-upon-Thames, UK<br>
   2005<p>


<h2>Translation</h2>

<p>Several people have helped with translations to support internationalisation
   (i18n!) in the Gallery; thank you all.</p>

<p>Some people have done huge chunks of transation work for free; in particular
   much of the French and Spanish support was done by Bruno Girin (BG),
   the German support by Burkhard Kloss (BGK),
   and the Dutch support by Guy Asaert and Jeroen Kerkhof.
   Look in the i18n files for more credits.</p>


<h2>Code Examples, Snippets and Resources</h2>

<p>You might wish to look at the <a href="/resources.jsp">resources</a> page
   to get the source code, javadoc, etc.
   Basically everything is under a BSD-style licence.</p>

<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--


--%>
