<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.webSvr.util.WebConsts,
            java.util.Set,
            java.util.Map,
            org.hd.d.pg2k.webSvr.util.WebUtils,
            org.hd.d.pg2k.svrCore.*,
            java.util.TreeSet"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "To-Do: Fixes"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Things To Do: Fixes</h1>

<p>This page is a list of auto-detected problems in the Gallery.</p>

<h2>Exhibits with Missing/Duplicate MD5 Hash</h2>

<%
    final AllExhibitProperties aep = dataSource.getAllExhibitProperties(-1);
    final Set<String> hashMD5Err = aep.getHashMD5Err();
    final int hashMD5ErrSize = hashMD5Err.size();
    final Map<ROByteArray,String> hashMD5ToName = aep.getHashMD5ToName();
%>

<p>Count of such duplicate or problematic entries: <%= hashMD5ErrSize %>
<% if(hashMD5ErrSize > 0) { %>
<dl>
<%
// List in sorted order...
for(final String fullName : new TreeSet<String>(hashMD5Err))
    {
    %><dt><a href="<%= WebUtils.makeCatPageRRURL(fullName, WebConsts.F_secondary_generated_HTML_suffix) %>"><strong><%= fullName %></strong></a></dt> <%
    %><dd><%

    final ExhibitPropsLoadable exhibitPropsLoadable = aep.getExhibitPropsLoadable(fullName);
    final AccessionData accessionMetadata = exhibitPropsLoadable.getAccessionMetadata();
    if(accessionMetadata == null)
        {
        %>no accession meta-data<%
        }
    else
        {
        final ROByteArray hashMD5 = accessionMetadata.hashMD5;
        if(hashMD5 == null)
            {
            %>no MD5 hash<%
            }
        else
            {
            final String dupOf = hashMD5ToName.get(hashMD5);
            if(dupOf == null)
                {
                %>cannot find dup exhibit<%
                }
            else
                {
                %>duplicate of <a href="<%= WebUtils.makeCatPageRRURL(dupOf, WebConsts.F_secondary_generated_HTML_suffix) %>"><%= dupOf %></a><%
                }
            }
        }

    %></dd><%
    %></li><%
    }
%>
</dl>
<% } %>
</p>


<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--


--%>
