<%--
Copyright (c) 1996-2007, Damon Hart-Davis
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the
    distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--%>
<%@ page
    import="org.hd.d.pg2k.svrCore.CoreConsts,
            org.hd.d.pg2k.webSvr.util.WebConsts"
    session="false"
%><%--

LOCALE AND EXHIBIT BEANS...
--%><%@ include file="/_common/_localeBean.inc.jsp" %><%-- i18n support...
--%><%@ include file="/_common/_exhibitBean.inc.jsp" %><%-- Get exhibit data bean set up...

HEADER
--%><% request.setAttribute(WebConsts.STDHDR_ATTR_NAME_TITLE, "To-Do List"); %><%--
--%><%@ include file="/_common/_HTMLStdHd.inc.jsp" %><%--

BODY
--%>
<h1>Things To Do</h1>

<p>This page is a list of design and coding things to do for the Gallery, largely unsorted and unorganised...  Much of it is just wish-list.</p>

<p>There is a page <a href="todo-loading.jsp">of major pending uploads, scans, etc</a>
   to keep track of the backlog of things waiting to be put up.</p>

<p>There is a page <a href="todo-fixes.jsp">of pending fixes, housekeeping, etc</a>
   to be done.</p>

<p>This page content is English-only.</p>


<h2>Possible Student Projects</h2>

<p>Note that there are some large and fairly self-contained tasks which
   might be suitable for an undergraduate end-of-year project,
   for which some support would be provided
   as well as acknowledgement of the student's contribution.  Work done
   (eg code) would be made publicly available under the same conditions
   as the rest of the Gallery; eg open source code under the BSD licence.

<p>In outline, possible projects include:

<ol>

<li>3D real-time interactive walkthrough of the Gallery,
    as if visiting and wandering around a physical gallery
    being able to inspect stills and movies "hung" on the walls, etc,
    with rendering of comparable quality to games consoles,
    or in Web browsers or mobile phones with Java.
    The Gallery view should be accessible to as many users as is reasonably
    possible, not requiring unreasonably expensive bandwidth or CPU,
    or at least a graceful degradation of experience in limited environments.
    One possible delivery mechanism would be Java WebStart.

<li>Integration of charging mechanism, preferably widely supported such
    as VISA or PayPal IPN or EntroPay, to enable instant donations or
    the ability to pay for faster access (and thus Gallery upgrades!)
    especially when the system is very busy.

<li>Extension of exhibit-upload and management features,
    with the following features:
    <ul>
    <li>Runs off-line but connects as needed to upload exhibits,
        update its off-line index, etc, retrying as needed,
        and efficient with bandwidth for users on slow/expensive connections.
    <li>Allows the user to rename entire directories full of exhibits
        ready for bulk upload, verifying names, magic numbers, etc,
        and possibly moving to an "uploaded" directory when done
        and providing the user with an local catalogue of all their own images.
    <li>Allows entry and editing of all aux data about an exhibit,
        such as description, location, etc,
        possibly with locator on world map and/or mockup catalogue page.
        All edits and uploads still to be approved by the maintainer.
    <li>Usable by contributors to manage their own collection of images,
        a local index and full thumbnails off-line,
        plus any uploaded-but-not-yet approved exhibits,
        eg for picture research.
    <li>Usable by the maintainer to examine all pending exhibits and approve
        or not and possibly create a list of files to be moved into the
        Gallery proper in one operation run off-line,
        eg on the Gallery master server's file server.
        This implies that that the maintainer has "super" rights;
        these could possibly be attached to the "ANON" contributor ID.
        (This final step must at least initially NOT be available on-line
        for security reasons, or possibly only over HTTPS and/or
        from "trusted" IP addresses.)
    <li>Can run over HTTPS or be otherwise authenticated on each operation
        if need be.
    <li>Allows for edit and update of existing exhibits already uploaded by that
        user.
    <li>Possible explicit support for author "stories"/travalogues.
    <li>Allows synchronisation of on-line and off-line aux data and maybe
        exhibit data (so the user gets a handy indexed copy of their images
        wherever they want).  This synchronisation to be partial or full with
        clear progress indication and the possibility to cancel and keep any
        progress already made.
    <li>As many possible of these features as is reasonable are provided
        through the light-weight Web interface,
        so a contibutor arriving at an Internet cafe with their digital camera
        can achieve many of the same end results in a similar way,
        and in any case the look-and-feel and general operations should stay
        similar so that a user can switch back and forth easily and for as few
        unexpected (eg security and architectural) consequences as possible.
    </ul>

    <li>Any agreed set of the to-do items described elsewhere.

</ol>




<h2>High-Priority Items</h2>

<p>These are the things I'd like to do first for various reasons.</p>

<p>Ideally, this should only ever contain a handful of items,
   preferably quick to resolve,
   and not especially categorised.<p>

<p>The first items in this list are probably the most likely or important.</p>

<p><b>
    <ul>

    <li>Include version number in site and make it available programmatically.

    <li>Integrate with PayPal IPN and/or EntroPay to take payment.

    <li>Fix "infinite redirections" problem that hurts IE6:
<pre>
GET /_virtual/ByCategory/places-and-sights/Su/Ss/S-/Sc/archive-11.HTM HTTP/1.1
Host: gallery.hd.org

HTTP/1.1 302 Moved Temporarily
Content-Type: text/html;charset=ISO-8859-1
Date: Wed, 10 Mar 2004 17:11:02 GMT
Location: http://gallery.hd.org/_virtual/ByCategory/places-and-sights/Su/Ss/S-/Sc/archive-11.HTM
Transfer-Encoding: chunked
Server: Apache Tomcat/4.1.27 (HTTP/1.1 Connector)
Vary: Accept-Language
Vary: Accept-Language
Content-Language: en

0
</pre>

    <li>IPv6 support and ECM assuming that IPv6/48 ~ IPv4/24, eg see:
        www.arin.net/billing/fee_schedule.html and
        www.ripe.net/ripe/docs/ipv6policy.html

    <li>Fix "Recent additions to the Gallery" filter on search page.

    <li>Add select-by maximum-bytes and minimum-megapixels/resolution/orientation/Hz filters, eg:
        <ul>
        <li>640x480
        <li>800x600
        <li>1024x762
        <li>1024x600w
        <li>1280x762w
        <li>1600x1200
        <li>1920x1200w
        </ul>

    <li>Store (and add it) local-only (ie per server) CTR-by-layout-style stats.

    <li>Index and allow select by EXIF camera make and model data.

    <li>Write new tool(s) to:
        <ul>
        <li>Move a complete set of "approved" exhibits safely into place.
        <li>Set file permissions.
        </ul>

    </ul>

</b></p>



<h2>Medium Priority</h2>

<p>This is where the bulk of pending things should be filed.</p>

<p>The first items in this list are probably the most likely or important.</p>

<p>This should be(come) roughly categorised by area, eg upload or tree-display.</p>

<h3>User Experience, Interactivity, New Features (M)</h3>

<ul>

    <li>SVG support (FF now supports it natively).

    <li>Improve Aloha Earth.  Still to do (and suggestions from testers):
        <ul>
        <li>Integrate with higher-resolution images for high zoom,
            eg from satellite sources such as http://www.sat.dundee.ac.uk/pdus.html.
        <li>Integrate with live images, eg weather sat overlay.

        <li>(RF) a search box with country names
        <li>(RF) do make it clear that page buttons are such
        <li>(RF) include number of pages near exhibits number
        <li>(RF) allow the user to specify the number of images per page

        </ul>

<li>Add HREF listener to JWS uploader HTML items.

<li>Integrate with Google Maps API.

<li>Write JavaScript-based word completion on search page,
    a little like the clues given by JIndexer,
    based on the lexicon of words collected by JIndexer or otherwise.
    This should not take lots of space (ie time to download or execute),
    and should not prevent search being used normally if JavaScript is disabled.

<li>On search page show words NOT found in index,
    and closest ones to them alphabetically.

<li>Improve thumbnail quality by ensuring that JPEG thumbnails do not contain any thumbnail
    from the original image (eg via the metadata).

<li>To search add select by (less than) size, eg: 1kB, 32kB, 1MB, 32MB, 100MB up to max exhibit size.

<li>To search add image select by (more than) total pixels, eg: 1kpix ... 10Mpix.

<li>By country filter/search in catalogue and Aloha Earth and starting with user's location.
    Implies maintaining map of ccTLD x country prefix in places-and-sights x i18ned name.

<li>Add map coordinate filter/search to catalogue and Aloha Earth.

<li>Add "not" (ie invert) to each search select option.

<li>A Computer-Generated Images (CGI) section,
    including maybe games screenshots,
    and other synthetic imagery (eg maybe visualisations, graphs).
    (Also possibly computer-games packshots in Mechanoids section.)
    Thanks to <a href="http://www.level80.co.uk/">Level80</a> for provoking
    the thought!

<li>When new "session" starts, produce lightweight but good version of page
    to make page load as fast as possible even from an empty cache.
    May also help server survive DDoS and being "/."-ed,
    and means we may save effort on visitors who only look at one page.

<li>Add property/ies in GenProps to override default livery colours,
    text colour, etc.

<li>Automatically extract more text/information from exhibits
    for indexing and display
    such as:
    <ul>
    <li>OCR of still images: eg http://www.java-channel.org/display.jsp?id=c_10678
    <li>Speech-to-text from audio/video.
    </ul>

<li>Extend/improve automatic detection with list of User-Agent regexes in GenProps.

<li>Fix any other satellite sites
    (freesp sites we still own for example).

<li>Add number of exhibits at/below current node in tree and against sub-nodes
    in tree-based views.

<li>Show "bg" images tiled, possibly as their own backdrop.

<li>Enhance jIndexer with a strict-AND mode (where all words must show)
    which should be very fast and only return relevant results,
    and an auto-AND mode which tries strict-AND and falls back to
    normal all-words mode, and make that the default for user queries.

<li>Add ability for contributors to add anotated virtual collections
    (eg "stories" or travelogues) under their name on the site
    and edit these via a Web interface including mainly their own exhibits,
    thus enabling (for example) people travelling to upload digital pics
    from Internet cafes and provide annotations and descriptions
    in a particular order (from which a visitot can click through to the
    catalgoue page for more detail on particular items)
    and edit or add to at any time, for example when they come back.
    Must be robust enough to survive some tweaking of names by the Gallery
    maintainer.

<li>BG suggests: ``Another idea I had for your pg2k site: you have this
    'find an exhibit at random' button which I think is very cool (it keeps
    people hooked to the site). So you could extend the concept so that people
    could choose an exhibit totally at random or amongst the best/worst rated,
    not rated, new, etc. exhibits.''  On the search page this might chose given
    the filter criteria, and keywords if any, and might automatically exclude
    poorly-rated exhibits by default, for example (which helps my LRU cache?).
    We might also make the random function non-uniform, ie more likely to pic
    `better' exhibits.

</ul>

<h3>Structural/Architectural Changes (M)</h3>

<ul>

<li>Reload cached by-word index on restart of server.

<li>Try BZIP2 and LZMA compression methods for very large RPC frames.

<li>Add generic getProperties(hash, name, subtype) to data pipeline
    to allow efficient run-time distribution of IP maps, i18n updates, etc,
    and allow possibility of sending patch rather than whole file.

<li>Consider NTP-like (automatic or manual) hierarchy,
    so data (etc) can be retrieved/exchanged in tree structure.

<li>Add facility on-line for anyone to suggest i18n text,
    missing or extant (maybe log as an event).

<li>Add equals() and hashCode() for sort and filter classes,
    including anonymous ones.

<li>Consider creating alternative caching pipeline element
    that assumes that it has enough space for all exibits
    and keeps a ZIP-file representation of the exhibits and
    aux data.

<li>Investigate <a href="http://www.opengis.org/">Open GIS Consortium</a>
    as source of APIs, data format standards, data for the maps,
    and partners to link with to improve user experience.

</ul>

<h3>Efficiency/Performance/Robustness (M)</h3>

<ul>

<li>Allow cache to extend start of fetch for a request so as to be able
    to cache the results of a request.

<li>Create automatic to-do pages to help with maintenance for such items as:
    <ul>
    <li>Places-and-sights items without any (or very broad) location.
    <li>Duplicate exhibits by hash.
    <li>Most frequently-used i18n items (and locale) missing a translation.
    <li>Most popular subjects/keywords/etc to indicate possible new exhibits.
    </ul>

<li>Provide read/write tests for all media types.

<li>Periodically (asynchronously) pull in "current" event set of particular period
    when it has been requested from upstream of simple cache.
    This keeps it somewhat up to date at no huge cost,
    especially avoiding the requester being blocked unnecessarily.

<li>Exclude redirection to mirrors showing a different AEP hashcode to us,
    eg to cope with transition while new exhibits are being propagated.
    Do this via new hashcode global (Number) variable.

<li>Consider vote-limiting by IP globally limiting fraction over one or more days.

<li>Add (possibly to GenProps) run-time map of IP address to country code,
    at least for the countries we know anything about or where we have mirrors.
    This should also have a proximity map (eg closest to RIPE/uk) by country code,
    and a default "best" region/country to serve from (eg ARIN/us).
    and a set of weightings to replace the static ones in the GeoProximity enum.
    This should allow much more accurate targetting of clients to servers
    than with the static information.

<li>Create location/load-sensitive Java-based DNS service for gallery entries.

<li>Record stats on user visit duration and pages viewed.

<li>Record stats on bandwidth and downloads by URI.

<li>Do unit tests of system behaviour under heavy load.

<li>Do automated (HttpUnit?) tests for upload and other parts of the site.

<li>Use JTidy to vet/sanitise any external or comment text to be embedded
    in Gallery pages (probably only if the txt contains at least &lt; or &amp;);
    this would include section text for example.

<li>Make FullSortedExhibitSet usage more efficient in not having to reset
    (sort) expression every time.

<li>Attempt to have cache read ahead (a la UNIX bread() algorithm) so that
    slient should not be blocked waiting for transfer of data into cache
    other than possibly on first read.

<li>Make Observer in AbstractFilterBean (a) embedded (b) hold only
    a SoftReference to the AFB so that the DataSourceBean reference
    to the Observer does not stop it being GCed (c) possibly unregister
    the Observer upon GC of the AFB to clean up state as quickly as
    possible (d) maybe allow a cache to be memory sensitive and an Observer.

<li>Disable cacheing or force revalidation of pages if the user has a session,
    since that session might be being used for a changed language (i18n)
    or sticky tree pages, for example, which cacheing might mess up.

<li>Extend the normal filter base to (a) optionally be memory sensitive
    if very quick to construct and (b) throw away some or all of their
    content or make it memory sensitive if unused for some minium time
    or a large multiple of the time to compute its value (say 1/1000th)
    to automatically reclaim resources slowly even if the exhibit set
    does not change.

<li>Deal with all the "TODO"s and "FIXME"s in the code.

</ul>

<h3>Upload (M)</h3>

<ul>

<li>Put extra choose/upload box near top of page when loading a series
    to avoid having to scroll to the bottom of the page each time.

<li>Show links to items already uploaded;
    allow some designated users to see all pending uploads.

<li>Allow direct upload from another URL, eg where contributor
    already has photos on their own site.

<li>In JWS uploader:
    <ul>
    <li>Allow stand-alone use as app uploading to master.
    <li>Compute/show upload Bps, estimated time-to-complete all queued upload,
        and improve progress-meter behaviour.
    <li>Show progress while adding (many) files for upload.
    <li>Fix resetting of number-in-series to 1 when perhaps not appropriate.
    </ul>

<li>Exhibit upload:
    <ul>
    <li>Complete upload passwords in shared db with user able to reset passwd.
    <li>Collect location information.
    <li>Save exhibit properties and accession files.
    <li>Add listing of similar extant exhibit names a la search engine.
    <li>When checking for name clashes in upload,
        if possible warn of names that differ only in number, author, suffix
        or main words.
    </ul>

</ul>

<h3>Uncategorised (M)</h3>

<ul>

<li>Prioritising/categorising all the tasks on this page!
    Including breaking up into sub-groups such as upload- or search- related.

<li>Make "exhibit range" leader at top of tree pages XXX ... YYY possibly
    more like in home page with the text linked or normalised in some way.

<li>As a further potential optimisation of tree display,
    where all the leaves below a node would fit onto a single page for display,
    fold them into that node directly
    (though allow the sub-nodes to exist for consistency).

<li>Improve layout (etc) of Tree JSP output, such as labelling the buttons better,
    putting the number of entries in brackets after a directory a la Yahoo, etc.

<li>Do lazy tree-building to allow much faster initial access to large trees
    (eg at 20030616, "all" exhibits of circa 11,000 entries takes 40s on rosehip to rebuild)
    probably by building a customised object rather than a raw Map.
    This can be transparent to the Tree display JSP.
    Possibly have the AllExhibitsProperties generate a canonical set of lower-cased names
    and/or prefixes so that we don't need lots of copies of the same values in memory.

<li>Re-enable Amazon advertising.

<li>Modify ExhibitDataFileSource to try to reload any new static data cache
    (prepared offline) immediately rather than imposing a minimum time
    before retrying.  Possibly apply in conjunction with new minimum
    delay which is multiple (10x) time taken to actually load data
    to minimise stress on CPU and disc.

<li>Allow uploader (or admin user, maybe filtered by IP address)
    to view (some or all) pending items in some way,
    including details such as size and timestamp,
    to make it easy to see what is pending and if something has already
    been uploaded.

<li>Show uploader quick selection of "similar" exhibits based on stuff
    in their saved info.

<li>Add code to expire/zap redundant thumbnails in server-side cache.

<li>JUNIT COMMAND-LINE AND/OR IN-SERVLET TESTING,
    including tests for cache-clearing Observer/Observable in DataSourceBean.

<li>Add capability in search engine to restrict search by date, size, dimensions,
    "has comment/description", has location, etc.

</ul>





<h2>Low Priority</h2>

<p>Probably just wish-list pie-in-the-sky material: may never happen.</p>

<p>The first items in this list are probably the most likely or important.</p>

<p>This should be(come) roughly categorised by area, eg upload or tree-display.</p>

<h3>User Experience, Interactivity, New Features (L)</h3>

<ul>

<li>Add table of URLs for more info on each media type where possible,
    eg www.mpeg.org.

<li>Possibly change alt text of thumbnail to first word (or two) of exhibit
    to help partially-sighted visitors for example.

<li>Add a recent/popular searches item to make good use of any search cache
    providing it does not hurt privacy.

<li>Add instant messagging (IM) or chat to Gallery,
    possibly a "room" per catalogue page so you can go meet at the Gallery.
    Consider http://myjxta2.jxta.org/ as J2EE compat.

</ul>

<h3>Efficiency/Performance/Robustness (L)</h3>

<ul>

<li>Keep most-recently-used (MRU) thumbnails in memory cache.
    Something like 10 * MAX_RESULTS_PER_PAGE entries should
    not be too expensive in terms of memory and should provide
    reasonable behaviour for page refreshes, etc.
    Do this when we have JDK1.4's LinkedHashMap as the code is trivial then.

<li>Have /notFound.jsp respond with a MIME type that the client can handle,
    specifically not with a relatively-expensive HTML page to
    a .txt page request or a client that accepts only WML for example.

<li>Redirect all queries via a lookup cache keyed to the data hash;
    this can be keyed on an equality/hash test on SearchFilterBean for example.

<li>Add hand-crafted support, at least for exhibits and possibly also for thumbnails,
    for:
    <ul>
    <li>Range
    <li>If-Modified-Since
    <li>If-Range
    </ul>
    for where the container cannot or will not, and in particular
    where letting the container do it would be very inefficient.
    We need not handle all cases.
    <p>
    See, for example, the <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.31">HTTP/1.1 spec for Range</a>.

<li>I'd like to be able to use Last-Modified headers again,
    possibly filtering out If-Modified-Since headers inbound for Tomcat 4.0.1.

<li>Put in filter to compensate for various buggy browsers, and
    especially bogus If-Modified-Since header that upsets Tomcat 4.0.1:
    <pre>
    if-modified-since=Saturday, 29-Dec-:1 02:09:07 GMT
    </pre>

</ul>

<h3>Upload (L)</h3>

<ul>

<li>Try harder to provide some sort of progress report during exhibit upload.

<li>Have upload2.jsp verify that file has
    correct magic number, etc, maybe even display it back to
    user.

<li>Add upload bandwidth measurement on system, complete with running total
    (and initial estimaate based on outgoing bandwidth limit, if any).

<li>Allow admin user to upload images by other authors?

<li>Allow SSL login for auth upload and admin.

</ul>

<h3>Misc, Admin and Maintenance (L)</h3>

<ul>

<li>Possibly add optional tie-breaker for identical (or near-identical)
    scoring items in JIndexer with Comparator and/or have sort-by
    "Goodness" or relevance or date switch on search.

<li>Avoid enabling page cacheing of "standard" (eg catalogue) pages when the
    site is busy as it stops langauge switching from working properly...

<li>Write a standard logger interface to write to System.err or
    the servlet-container's log as appropriate.

<li>Write tool so find out which properites in the common bundle have
    not had translations supplied so that I can ask for them;
    log most common property/language missing entry combinations.

</ul>




<h2>Unsorted list of things to do</h2>

No special order.

<ul>

<li>Get Last-modified working on catalogue pages to reduce load.
    Requires:
    <ul>
    <li>Write HttpUnit tests for pages.
    <li>Upgrade to Tomcat 4.1.19 or greater.
    <li>HttpUnit tests of cacheing.
    </ul>
    <p>
    Also make use of and set E-tags in the headers.
    </p>

<li>Add check in upload that shows when a new first "main" word is about
    to be used as that is especially important.

<li>Add query caching for a small number of identical successive queries;
    maybe always hold the last 100 (with very long queries truncated or forbidden)
    with any beyond that held in a memory-sensitive cache.

<li>Attempt to speed and focus search by having search default to *all* words
    (and make sure that JIndexer lookup is optimised for this case),
    with a user-selectable alternative of *most* words (the current)
    which might be the automatic fall-back if no results are found with the default.
    This could be very fast if jindexer is optimised for the "all" case.
    Currently jindexer only ensures that all meants entries that match all come first
    as opposed to excluding all other items; maybe this should change.

<li>Add _by/Estd/ for Aloha Earth replacement and scrap old Aloha Earth.

<li>Map in ZAPIX replacement front page.

<li>Index items by attribute word and by discovered attributes at run-time
    (eg all .mpg get attribute "video" and all .jpg could get "still").
    Include "new" automatic attribute for most recently-added exhibits.

<li>Add landscape/portrait image selector/filter.

<li>Eliminate most unused attributes and rename odd items to further prune list.

<li>Possibly tune JIndexer to stop adding in results of words in the search
    list when the results could not possibly make a difference to the final
    result (usually very common words), since this may mean that any optional
    (and maybe slow) filter we supply can be called far less often.

<li>Have user able to register browser (with system generated unique ID)
    to remember search prefs, remember "favourite" exhibits,
    show new related images each time in
    "Similar exhibits" section, etc.  This unique ID and browser
    registration can be shared with other broswers at user request.
    We might do some of this in a session if extant.

<li>Have a link on each word in an exhibit name to pick out more with that
    same feature, at least as a primary criterion.  Eg pick on a normal
    word to find more with that word, or an attribute to find more with
    that attribute, or the author to find more by that author, etc...

<li>See comments for search/catalogue improvement in
    misc/comments/20020606SearchComments.txt.

<li>To avoid ambiguity, prevent last component of name (main or attribute)
    being an integer.

<li>Suggestion for new category of buildings:
    <pre>
       Date: Tue, 19 Mar 2002 17:14:38 -0000
       From: "Louise Hartup"

    May I suggest that you add a category of buildings.  I also get involved
    with marketing (for my sins) and we're always looking for good business
    images.  You could also do people at work and that sort of thing though I
    doubt you'd be interested based on the nature of the pictures on your site.

    ...and in a further email...

    With regard to the buildings I was thinking of the sort of arty pictures you
    now see in most marketing material which photograph buildings in an unusual
    way (am I making myself clear???! - not really methinks!).  I need images
    that capture different industries for example, telecoms, mining, farming,
    oil production, financial services, education, police, drug rehabilitation,
    prisons, community care, chemical etc. etc. The focus again is perhaps an
    unusual picture that captures something of the essence of the
    industry/people who work in said industry, preferably using strong colours.
    You've no idea how hard it is to find a decent picture of a mobile phone (I
    should imagine you're thinking I'm sadder and sadder!). For my sins, I once
    worked for PwC and they commissioned a library of images for use in their
    material which were absolutely amazing, difficult for me to describe, but
    one was of the inside of a beautiful library, there were sand dunes and
    unusual architecture - I think they called them world images. Anyway I now
    work for a tiny company and am trying to help them pull some marketing stuff
    together (this is NOT my forte!). I had a delve around ages ago and found
    nothing that would help.  However yesterday I found your site and your
    pictures have definitely livened up my essays.
    </pre>

<li>Add filters with weightings/sliders from
    "very important" through to "very important not so".

<li>Add accession year and EXIF data to vote correlations.

<li>Self-sizing aka cache.

<li>Log sticky visitor ccTLD/region/proximity.

<li>Allow selective Urchin tracking by user region/country...

<li>Add search filter for "best" exhibits.

<li>Convert voting buttons to POST or JavaScript to avoid activation by "accelerators".

<li>Cache/load serialised DSB by-word index.

<li>Add indexing support for Unicode chars &gt; 0xff.

<li>Flashing hotlink img.

<li>Formalise links to external mechanisms to sell high-res images,
    such as with shareit.com and AHD's magnet photo, eg have
    property in new properties file with external link and another
    with a simple largely-language-free summary of the features of
    the purchasable version.  (We can then have i18n as we will for the
    description.)

<li>Find out why sometimes a small thumbnail is generated when a large
    one is not, and possibly forbid the situation.

</ul>

<%--


FOOTER
--%><%@ include file="/_common/_HTMLStdFt.inc.jsp" %><%--


--%>
